﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse

XIncludeFile("./GFX_Wizzard_BF.pbi")

; This function create a CSS sprite sheet from a GIF with automatic created invisible color (Background color) and a sheet data file

; GIF can have different defined invisible colors for different frames
; This code define for the complete generated sheet a new invisible color, only one ! - This works very fine and make a sheet post processing very simple
; A sprite sheet is high flexible, mostly, i think, for using GIF like output inside a app sheet using is many better as GIF using
; BF can handle any sprite sheets very easy and simple, also lossly compressed sheets
; Movie like sheets without a invisible color you can fine compress as JPG files how ever you want
; For sheets with a used invisible color PNG works very fine, but you can compress this files also as JPG image

; For lossly compressed sheets with a used invisible color you must use the PB function SetColorDistanceSpriteMask_BF for clearing the sprite mask from compression artifacts
; For best results with lossly compressed sheets you can simple define also a own invisible color for each sheet
; Best results you get with a invisible color nearly the color from the sprite content edges - So you can create simple also a nice edge blur for the sprites 

EnableExplicit

Define path$=OpenFileRequester("Select a GIF picture", "", "", 0)
If path$="" Or UCase(GetExtensionPart(path$))<>"GIF": End : EndIf

ActivateAlphaChannel_BF(1) ; Is this function activated, the created sheet is a PNG with invisible color
                           ; You must deactivate this function after using or it influence all BF core based functions

; This call create a CSS sheet with a sheet info file and include the same file to the end from the sheet image
CreateCSSandDataSheet_simple_BF(path$, 0, 2, 1)

CompilerEndIf
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 18
; Folding = -
; EnableXP
; DisableDebugger