﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - FloodFill demo - simple - This function can output directly on images, PB sprites and canvas

EnableExplicit

Define window_ID, win_event, image_ID, texture_ID, sprite_ID, result
Define i, image_x, image_y, image_width, image_height, point
Define path$

  #GeeBee="./Image_Set/Geebee2.bmp"
  #Clouds="./Image_Set/Clouds.jpg"
  #SoilWall="./Image_Set/soil_wall.jpg"
  #RustySteel="./Image_Set/RustySteel.jpg"
  #Caisse="./Image_Set/Caisse.png"
  #Dirt="./Image_Set/Dirt.jpg"
  #Background="./Image_Set/Background.bmp"
  #Cat_1="./Image_Set/Cat_01.jpg"

; Presets
image_width=600 : image_height=475

image_ID=LoadImage(#PB_Any, #SoilWall)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_WIzzard_BF - For PB Sprites",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

OpenWindowedScreen(WindowID(window_ID), 0, 0, image_width, image_height)

sprite_ID=CreateSprite(#PB_Any, image_width, image_height)

StartDrawing(SpriteOutput(sprite_ID))
Box (40, 10, 128 , 400, $AAA1)
RoundBox (185, 80, 133 , 250 , 20, 20, $AAAAA2)
Box (300, 280, 150 , 150, $AAA3)
Circle(460, 260, 125, $AAAAA4)
StopDrawing()

; - Call function #1 -
path$=#SoilWall
texture_ID=LoadImage(#PB_Any, path$)
result=FloodFill_BF(-2, sprite_ID, texture_ID,
                    0, ; Startpoint for FloodFill x
                    0) ; y
ErrorCheck_BF(result)

StartDrawing(SpriteOutput(sprite_ID))
DrawingMode(#PB_2DDrawing_Transparent)
DrawText_BF(20, 5, "A VERY COOL FUNCTION"+#LF$+
                   "GFX WIZZARD BF"+#LF$+
                   "www.nachtoptik.de"+#LF$+
                   "Sprites simple !")
StopDrawing()

; - Call function #2 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
result=FloodFill_BF(-100, sprite_ID, texture_ID,
                    40,
                    10)
ErrorCheck_BF(result)

; - Call function #3 -
path$=#GeeBee
texture_ID=LoadImage(#PB_Any, path$)
result=FloodFill_BF(-2, sprite_ID, texture_ID,
                    185,
                    100,
                    60, ; Startposition texture output x
                    80) ; y
ErrorCheck_BF(result)

; - Call function #4 -
path$=#Clouds
texture_ID=LoadImage(#PB_Any, path$)
result=FloodFill_BF(-2, sprite_ID, texture_ID,
                    185, ; Output x
                    100) ; Output y
ErrorCheck_BF(result)

; - Call function #5 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
result=FloodFill_BF(-2, sprite_ID, texture_ID,
                    300,
                    280,
                    0,
                    0,
                    0,
                    0,
                    0,
                    0,
                    30,
                    30)
ErrorCheck_BF(result)

; - Call function #6 -
path$=#Cat_1
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, 300, 260)
result=FloodFill_BF(-2, sprite_ID, texture_ID,
                    450,
                    250,
                    0,
                    135) ; Adjust photo
ErrorCheck_BF(result)

Repeat
  
  If Delay_BF(0, 10)
    FlipBuffers() ; Draw PB sprite
    ClearScreen(RGB(0, 0, 0))
    DisplaySprite(sprite_ID, i, 0)
    DisplaySprite(sprite_ID, i-image_width, 0) 
    i=(i+1)%image_width
    
    Repeat
      win_event=WindowEvent()
      If win_event=#PB_Event_CloseWindow
        FreeTextures_BF() ; Free grabed textures
        End
      EndIf
    Until Not win_event
    
  EndIf
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 2
; EnableXP
; DisableDebugger