﻿; FontWizzard_BF - Demo code - Formatted lists - Gadgets based
XIncludeFile("./FontWizzard_BF.pbi")
EnableExplicit

CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  If Not Subsystem("qt") And Not Subsystem("gtk2")
    MessageRequester("Hint", "The gadget distances here are not adapted to gtk3"+#LF$+
                             "Use qt Or gtk2")
    EndIf
  CompilerEndIf

Define DR.f=DesktopResolutionX(), i

Define scaling.f=1.0 ; List output size

Define window_ID=OpenWindow(#PB_Any, 0, 0, 950*scaling, 600*scaling, "Font_Wizzard_BF", #PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_Invisible)

Define x=100*scaling ; List output x pos
Define y=80*scaling  ; List output y pos
PresetMaxFontsize_FW(12*scaling)
For i=1 To 10
  Define text$=Str(i)
  AddFrame_FW(2*scaling*DR, #Black)
  ImageBasedGadget_FW(0,          ; gadget_Typ, - 0 = ButtonImageGadget - 1 = ImageGadget - 2 = CanvasGadget 
                      "",         ; Font$
                      0,          ; font_flag
                      x,          ; output_x
                      y,          ; output_y
                      50*scaling, ; output_width
                      45*scaling, ; output_height
                      #Blue,      ; text_color
                      0,          ; text_adjustment
                      $80FFFFFF,  ; background_color -1 = invisible
                      text$,      ; text$
                      -16,        ; padding_x
                      0,          ; padding_y
                      1,          ; resize_factor.f
                      0)          ; gadget_frame_flag
  y+45*scaling
Next i

Define x=150*scaling ; List output x pos
Define y=80*scaling  ; List output y pos
TextColor_Line_FW(1, #Blue) ; Set Line 1 blue
Define font_flag
For i=1 To 10
  If i<4 : TextStretching_FW(5) : font_flag=#PB_Font_Bold : Else : TextStretching_FW() : font_flag=0 : EndIf
  If i>3 : TextColor_Line_FW(1, -1) : EndIf ; Deactivate again
  AddFrame_FW(2*scaling*DR, #Black)
  ImageBasedGadget_FW(0,             ; gadget_Typ, - 0 = ButtonImageGadget - 1 = ImageGadget - 2 = CanvasGadget 
                      "",            ; Font$
                      font_flag,     ; font_flag
                      x,             ; output_x
                      y,             ; output_y
                      150*scaling,   ; output_width
                      45*scaling,    ; output_height
                      #Black,        ; text_color
                      1,             ; text_adjustment
                      $8000FFFF,     ; background_color -1 = invisible
                      "Hello World", ; text$
                      -16,           ; padding_x
                      -5,            ; padding_y
                      1,             ; resize_factor.f
                      0)             ; gadget_frame_flag
  y+45*scaling
Next i

Define x=300*scaling ; List output x pos
Define y=80*scaling  ; List output y pos
For i=1 To 10
  AddFrame_FW(2*scaling*DR, #Black)
  ImageBasedGadget_FW(0,             ; gadget_Typ, - 0 = ButtonImageGadget - 1 = ImageGadget - 2 = CanvasGadget 
                      "",            ; Font$
                      0,             ; font_flag
                      x,             ; output_x
                      y,             ; output_y
                      150*scaling,   ; output_width
                      45*scaling,    ; output_height
                      #Black,        ; text_color
                      1,             ; text_adjustment - 0=center - 1=left - 2=right
                      $8000FF00,     ; background_color - -1 = invisible
                      "How are you", ; text$
                      -16,           ; padding_x
                      -5,            ; padding_y
                      1,             ; resize_factor.f
                      0)             ; gadget_frame_flag
  y+45*scaling
Next i

Define x=450*scaling ; List output x pos
Define y=80*scaling  ; List output y pos
TextColor_Line_FW(2, #Red)
Define text$="Hey"+#LF$+"We hope you are well"
For i=1 To 10
  AddFrame_FW(2*scaling*DR, #Black)
  ImageBasedGadget_FW(0,           ; gadget_Typ, - 0 = ButtonImageGadget - 1 = ImageGadget - 2 = CanvasGadget 
                      "",          ; Font$
                      0,           ; font_flag
                      x,           ; output_x
                      y,           ; output_y
                      150*scaling, ; output_width
                      45*scaling,  ; output_height
                      #Black,      ; text_color
                      1,           ; text_adjustment - 0=center - 1=left - 2=right
                      $8000FFFF,   ; background_color - -1 = invisible
                      text$,       ; text$
                      -16,         ; padding_x
                      -5,          ; padding_y
                      1,           ; resize_factor.f
                      0)           ; gadget_frame_flag
  y+45*scaling
Next i

Define x=600*scaling ; List output x pos
Define y=80*scaling  ; List output y pos
TextColor_Line_FW(2, #Blue)
For i=1 To 10
  Select i
    Case 1
      Define text$="Created with FontWizzard_BF" 
    Case 2
      Define text$="A new way for text output on PB"
    Case 3
      Define text$="Click the Gadgets"
    Case 4
      Define text$="All you can eat"+#LF$+"Many advanced features" 
  EndSelect
  AddFrame_FW(2*scaling*DR, #Black)
  ImageBasedGadget_FW(0,           ; gadget_Typ, - 0 = ButtonImageGadget - 1 = ImageGadget - 2 = CanvasGadget 
                      "",          ; Font$
                      0,           ; font_flag
                      x,           ; output_x
                      y,           ; output_y
                      250*scaling, ; output_width
                      45*scaling,  ; output_height
                      #White,      ; text_color
                      1,           ; text_adjustment - 0=center - 1=left - 2=right
                      $800000FF,   ; background_color - -1 = invisible
                      text$,       ; text$
                      -16,         ; padding_x
                      -5,          ; padding_y
                      1,           ; resize_factor.f
                      0)           ; gadget_frame_flag
  y+45*scaling
Next i

HideWindow(window_ID, 0)
Repeat
  Define win_event=WaitWindowEvent()
  If win_event=#PB_Event_Gadget
    Debug GetGadgetText_FW(EventGadget())
    Debug "Text Color $"+Hex(GetGadgetTextColor_FW(EventGadget()))
    Debug "Background Color $"+Hex(GetGadgetBackgroundColor_FW(EventGadget()))
    Debug "Image ID $"+Hex(GetGadgetImage_FW(EventGadget()))
    Debug "Used Fontsize "+GetGadgetFontsize_FW(EventGadget())
    Debug "Text stretching X "+GetGadgetStretch_X_FW(EventGadget())
    Debug "Text stretching Y "+GetGadgetStretch_Y_FW(EventGadget())
    Debug "Gadget Type FW "+GetGadgetType_FW(EventGadget())
    Debug " "
  EndIf
Until win_event=#PB_Event_CloseWindow

; Free all Gadgets_FW, fonts and cached images used
FreeAllGadgets_FW() ; Here you must not use - Look in the FW declare part
; IDE Options = PureBasic 5.73 LTS (MacOS X - x64)
; CursorPosition = 7
; FirstLine = 3
; Folding = -
; EnableXP
; DPIAware