﻿
; FontWizzard_BF - Demo code

XIncludeFile("./FontWizzard_BF.pbi")

EnableExplicit

UsePNGImageDecoder() 
UseJPEGImageDecoder()

Define DR.f=DesktopResolutionX()

Define image_1_ID=LoadImage(#PB_Any, "./Image_Set/Foam.png")
Define image_2_ID=LoadImage(#PB_Any, "./Image_Set/grass1.png")

Define window_ID=OpenWindow(#PB_Any, 0, 0, 960, 470,
                            "Font_Wizzard_BF",
                            #PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_Invisible)

; Set the text color for a line - You must deactivate again (Set LineColor_FW=-1) - First 1000 Lines supported
TextColor_Line_FW(1, $80000000)
TextColor_Line_FW(2, $FF0000)
TextColor_Line_FW(3, $FFFF00FF)

; Headletter mode for any text output - You must daactivate again - X, Y
TextStretching_FW(5*DR, 5*DR)

Define text$="Headletter mode"+#LF$+"Multicolor fitted text"+#LF$+"This is a ButtonImageGadget"
Define button_1_ID=ButtonImageGadget(#PB_Any, 10, 10, 720, 170, 0)
SetImageBasedGadgetText_FW(button_1_ID,
                           "Tahoma",
                           #PB_Font_Bold,
                           #Red,  ; Text color - Alpha channel sensitive - Sample $8000FFFF
                           0,     ; Text adjustment - 0=center - 1=left - 2=right
                           -1,    ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                           text$, ; text$
                           5*DR,  ; Padding x
                           5*DR)  ; Padding y

; Headletter mode for any text output - You must daactivate again - X, Y
TextStretching_FW(1*DR, 5*DR)

Define text$="Real Headletter mode"+#LF$+"Automatically fitted text"+#LF$+"This is a ButtonImageGadget"
Define button_2_ID=ButtonImageGadget(#PB_Any, 20, 200, 320, 100, 0)
SetImageBasedGadgetText_FW(button_2_ID,
                           "Tahoma",
                           #PB_Font_Bold,
                           #Blue,     ; Text color - Alpha channel sensitive - Sample $8000FFFF
                           0,         ; Text adjustment - 0=center - 1=left - 2=right
                           $8000FFFF, ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                           text$,     ; text$
                           0*DR,      ; Padding x
                           5*DR)      ; Padding y 

; Headletter mode for any text output - You must daactivate again - X, Y
TextStretching_FW(3*DR, 5*DR)

Define text$="Hello World"+#LF$+"This is a ImageGadget"+#LF$+"Try any text"
Define imagegadget_1_ID=ImageGadget(#PB_Any, 0, 0, 0, 0, 0) ; , #PB_Image_Border)

AddImage_1_FW(image_2_ID,
              -30*DR, ; x pos
              0*DR,   ; y pos
              100*DR, ; Width
              100*DR, ; Height
              255)    ; Alpha

AddImage_2_FW(image_2_ID,
              315*DR,
              20*DR,
              50*DR,
              50*DR,
              255)

AddFrame_FW(4, #Red) ; Add a frame

; Activate LinearGradient
FrontColor_FW(#Green)
BackColor_FW(#Green)
GradientColor_Pos_FW(0.5, #Blue)
LinearGradient_FW(1, 0, 0, 350*DR, 0)

SetImageBasedGadget_FW(imagegadget_1_ID,
                       "Arial",
                       #PB_Font_Bold,
                       360,     ; output_x
                       200,     ; output_y
                       370,     ; gadget_width
                       100,     ; gadget_height
                       #Red,    ; Text color - Alpha channel sensitive - Sample $8000FFFF
                       0,       ; Text adjustment - 0=center - 1=left - 2=right
                       #Yellow, ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF 
                       text$)   ; text$

LinearGradient_FW()

Define text$=#LF$+"Hello World"+#LF$+"This is a CanvasGadget"+#LF$+"Automatically fitted text"
Define canvas_1_ID=CanvasGadget(#PB_Any, 
                                10,                ; output_x
                                320,               ; output_y
                                330,               ; gadget_width
                                130,               ; gadget_height
                                #PB_Canvas_Border) ; Border

SetImageBasedGadgetText_FW(canvas_1_ID,
                           "",
                           #PB_Font_Bold,
                           #Blue,  ; Text color - Alpha channel sensitive - Sample $8000FFFF
                           0,      ; Text adjustment - 0=center - 1=left - 2=right
                           #White, ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                           text$,  ; text$
                           0,      ; padding_x
                           0)      ; padding_y

AddImage_1_FW(image_2_ID,
              275*DR, ; x pos
              15*DR,  ; y pos
              50*DR,  ; Width
              50*DR,  ; Height
              255)    ; Alpha

AddFrame_FW(2*DesktopResolutionX(), #Blue) ; Add a frame

; Headletter mode for any text output - You must daactivate again - X, Y
TextStretching_FW(1*DR, 1*DR)

text$="Created"+#LF$+"with DrawText_FW"
DrawText_FW(canvas_1_ID,
            "",            ; Font
            #PB_Font_Bold, ; Font flag
            5*DR,          ; Output X
            5*DR,          ; Output Y
            100*DR,        ; Text width
            30*DR,         ; Text height
            #Blue,         ; Text color - Alpha channel sensitive - Sample $8000FFFF
            0,             ; Text adjustment - 0=center - 1=left - 2=right
            #Green,        ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
            text$,         ; text$
            -5*DR,         ; padding_x
            0*DR)          ; padding_y

DrawText_FW(canvas_1_ID,
            "",                                ; Font
            #PB_Font_Bold,                     ; Font flag
            (GadgetWidth(canvas_1_ID)-108)*DR, ; Output X
            5*DR,                              ; Output Y                         
            100*DR,                            ; Text width
            30*DR,                             ; Text height
            #Red,                              ; Text color - Alpha channel sensitive - Sample $8000FFFF
            0,                                 ; Text adjustment - 0=center - 1=left - 2=right
            -1,                                ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
            text$,                             ; text$
            -5,                                ; padding_x
            0)                                 ; padding_y

Define button_5_ID=ButtonImageGadget(#PB_Any, 360, 320, 370, 130, 0) ; Creating only for output in the event loop

Define output_ID=CanvasGadget(#PB_Any, ; Creating only for output in the event loop
                              750,     ; Output X
                              20,      ; Output Y
                              190,     ; gadget_width
                              430)     ; gadget_height

; ----- DrawText_FW Part ----- 

AddImage_1_FW(image_1_ID,
              0*DR,                      ; Offset X
              0*DR,                      ; Offset Y
              GadgetWidth(output_ID)*DR, ; Width
              130*DR,                    ; Height
              50) 

AddImage_2_FW(image_2_ID,
              -60*DR,                        ; Offset X
              0*DR,                          ; Offset Y
              GadgetWidth(output_ID)*DR/1.5, ; Width
              130*DR,                        ; Height
              255)

text$="DrawText_FW"
DrawText_FW(output_ID,
            "",            ; Font
            #PB_Font_Bold, ; Font flag
            0*DR,          ; Output X
            -5*DR,         ; Output Y                           
            190*DR,        ; Text width
            60*DR,         ; Text height
            #Black,        ; Text color - Alpha channel sensitive - Sample $8000FFFF
            0,             ; Text adjustment - 0=center - 1=left - 2=right
            -1,            ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
            text$,         ; text$
            0,             ; padding_x
            0,             ; padding_y
            1)             ; Resize Factor  

LinearGradient_FW() ; Deactivate again

; Headletter mode for any text output - You must daactivate again - X, Y
TextStretching_FW(2*DR, 1*DR)

text$="Cool"+#LF$+
      "fitted text"+#LF$+
      "All channels"+#LF$+
      "Inheritable cursor"+#LF$
DrawText_FW(output_ID,
            "",                     ; Font
            #PB_Font_Bold,          ; Font flag
            0,                      ; Output X
            GetCursor_Y_FW()-15*DR, ; Output Y                    
            190*DR,                 ; Text width
            100*DR,                 ; Text height
            #Blue,                  ; Text color - Alpha channel sensitive - Sample $8000FFFF
            0,                      ; Text adjustment - 0=center - 1=left - 2=right
            -1,                     ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
            text$,                  ; text$
            20,                     ; padding_x
            0,                      ; padding_y
            1)                      ; Resize Factor  

text$="It's cool man"+#LF$+"This is DrawText_FW"
Define i, ii=GetCursor_Y_FW()-10*DesktopResolutionX()

; Set the text color for a line - You must deactivate again (Set LineColor_FW=-1) - First 1000 Lines supported
TextColor_Line_FW(1, #Red)

For i=0 To 1
  DrawText_FW(output_ID,
              "",            ; Font
              #PB_Font_Bold, ; Font flag
              0,             ; Output X
              ii,            ; Output Y      
              190*DR,        ; Text width
              35*DR,         ; Text height
              #Red,          ; Text color - Alpha channel sensitive - Sample $8000FFFF
              Bool(i%2),     ; Text adjustment - 0=center - 1=left - 2=right
              #Green,        ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
              text$,         ; text$
              10,            ; padding_x
              0)             ; padding_y
  ii=GetCursor_Y_FW()
Next i

TextStretching_FW() ; Deactivate again

AddFrame_FW(2*DesktopResolutionX(), #Blue) ; Add a frame

; Set the text color for a line - You must deactivate again (Set LineColor_FW=-1) - First 1000 Lines supported
TextColor_Line_FW(1, #Green)

For i=0 To 1
  ii=GetCursor_Y_FW()+5*DesktopResolutionX()
  DrawText_FW(output_ID,
              "",            ; Font
              #PB_Font_Bold, ; Font flag
              0,             ; Output X
              ii,            ; Output Y
              190*DR,        ; Text width
              40*DR,         ; Text height
              #Blue,         ; Text color - Alpha channel sensitive - Sample $8000FFFF
              Bool(i%2)+1,   ; Text adjustment - 0=center - 1=left - 2=right
              #Red,          ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
              text$,         ; text$
              10,            ; padding_x
              0)             ; padding_y
Next i

ProgressBar_FW(10*DR,   ; Offset X
               115*DR,  ; Offset Y
               170*DR,  ; Width
               20*DR,   ; Height
               0,       ; Min
               100,     ; Max
               50,      ; State
               #Red,    ; Foreground color
               $EEEEEE, ; Background color
               255,     ; Alpha
               0)       ; 1 = vertical

; Headletter mode for any text output - You must daactivate again - X, Y
TextStretching_FW(1*DR, 1*DR)

text$="This is a "+#LF$+"CanvasGadget"+#LF$+"Works also on screen,"+#LF$+"images, sprites, window"
ii=GetCursor_Y_FW()
DrawText_FW(output_ID,
            "",                  ; Font
            #PB_Font_Bold,       ; Font flag
            0*DR,                ; Output X
            GetCursor_Y_FW()-20, ; Output Y                             
            190*DR,              ; Text width
            130*DR,              ; Text height
            #Blue,               ; Text color - Alpha channel sensitive - Sample $8000FFFF
            0,                   ; Text adjustment - 0=center - 1=left - 2=right
            -1,                  ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
            text$,               ; text$
            -15,                 ; padding_x
            0)                   ; padding_y

ActivateAutoFree_FW(0) ; Disable auto free accessories for the loop

AddImage_1_FW(image_1_ID,
              0*DR,                         ; x pos
              0*DR,                         ; y pos
              GadgetWidth(button_5_ID)*DR,  ; Width
              GadgetHeight(button_5_ID)*DR, ; Height
              50) 

AddImage_2_FW(image_2_ID,
              -40*DR,
              -40*DR,
              GadgetWidth(button_5_ID)/3*DR,
              GadgetHeight(button_5_ID)*DR,
              255)

AddImage_3_FW(image_2_ID,
              300*DR,
              50*DR,
              GadgetWidth(button_5_ID)/8*DR,
              GadgetHeight(button_5_ID)/3*DR,
              255)

HideWindow(window_ID, 0)

; Headletter mode for any text output - You must daactivate again - X, Y
TextStretching_FW(1*DR, 2*DR)

; Set the text color for a line - You must deactivate again (Set LineColor_FW=-1) - First 1000 Lines supported
TextColor_Line_FW(1, #Red)
TextColor_Line_FW(3, #Green)

i=0 : ii=0
Define text$="Hello World"+#LF$+#LF$+"ButtonImageGadget"+#LF$+"With included ProgressBar"
Repeat
  Delay(10)
  Repeat ; Get all window events
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      End
    EndIf
  Until Not win_event
  
  If i>100 : i=0  : EndIf
  If ElapsedMilliseconds()>ii+30 : i+1 : ii=ElapsedMilliseconds()
    
    ProgressBar_FW(85*DR,   ; Offset X
                   42*DR,   ; Offset Y
                   200*DR,  ; Width
                   20*DR,   ; Height
                   0,       ; Min
                   100,     ; Max
                   i,       ; State
                   #Green,  ; Foreground color
                   #Yellow, ; Background color
                   150,     ; Alpha
                   0)       ; 1 = vertical
    
    SetImageBasedGadgetText_FW(button_5_ID,
                               "Georgia",
                               #PB_Font_Bold,
                               #Blue, ; Text color - Alpha channel sensitive - Sample $8000FFFF
                               0,     ; Text adjustment - 0=center - 1=left - 2=right
                               -1,    ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
                               text$, ; text$
                               10*DR, ; Padding x
                               10*DR) ; Padding y
    
  EndIf
ForEver
; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 25
; FirstLine = 21
; EnableXP
; DPIAware