﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse
  
  XIncludeFile("./GFX_Wizzard_BF.pbi")
  
  ; Demo - GIF output - Using ImageGadget_BF
  
  EnableExplicit
  
  Define frame, delay, i, invisible_color, win_event, init=1
  
  CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
  
  Define path$=OpenFileRequester("Select a GIF", "", "", 0)
  
  If path$="" : End : EndIf
  
  If UCase(GetExtensionPart(path$))<>"GIF"
    MessageRequester("Hint", "This is not a GIF !")
    End
  EndIf

  Define gif_ID=LoadImage(#PB_Any, path$)
  
  ; ------------------------------------------------------------------------------
  
  Define window_ID=OpenWindow(#PB_Any, 0, 0, DesktopWidth_UserScaled_BF()-400, Desktopheight_UserScaled_BF()-200, "GFX_Wizzard_BF - GIF output demo on a window with ImageGadget_BF",
                              #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  SetWindowColor(window_ID, $D0D0D0)
  WindowBounds(window_ID, 120, 120-MenuHeight(), #PB_Ignore, #PB_Ignore)
  
  Define temporary_frame_ID=CreateImage(#PB_Any, 960, 600)
  
  Define x=20                ; Output pos x
  Define y=20                ; Output pos y
  Define padding=16          ; Padding - Deactivate with -1
  Define background_color=0  ; Background color - For a invisible background set background_color=-2 (-1 is reserved for ignore)
  Define grid_color=$DCDCDC  ; Grid color
  Define grid_size=8         ; Grid size
  Define grid_tiling=20      ; Grid tiling
  Define frame_color=$FFFFFF ; Frame color
  Define frame_size=6        ; Frame size
  Define flags=0             ; #PB_Image_Raised - #PB_Image_Border - Frame flags
  
  Define width=WindowWidth(window_ID)+WindowWidth(window_ID)%2-40, height=WindowHeight(window_ID)+WindowHeight(window_ID)%2-40 
  
  Define gadget_1_ID=ImageGadget_BF(gif_ID,
                                    x,
                                    y,
                                    width,
                                    height,
                                    background_color,
                                    padding,
                                    grid_color,
                                    grid_size,
                                    grid_tiling,
                                    frame_color,
                                    frame_size,
                                    flags)
  
  Delay_BF(1,-1) ; time=-1 Initialize the timer - This set the first delay to zero for beginning a animation directly without a delay)
  
  Repeat
    Delay(1)
    
    ; Frame delay - Using timer 1
    If Delay_BF(1, Get_Gif_FrameDelay_BF(gif_ID, frame)) : If init : init=0 : Else : frame+1 : init=0 : EndIf : If frame=ImageFrameCount(gif_ID) : frame=0 : EndIf 
      
      SetImageFrame(gif_ID, frame)
      
      SetImageGadget_BF(gadget_1_ID, gif_ID)
    EndIf
    
    Repeat ; Get all window events
      win_event=WindowEvent()
      If win_event=#PB_Event_CloseWindow
        End
      EndIf
    Until Not win_event
    
  ForEver
  
CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 28
; FirstLine = 15
; Folding = -
; EnableXP
; Executable = ..\test.exe
; DisableDebugger