﻿
; MessageRequester_Magic_BF

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($FF, $00, $00, $FF))
GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))

Define title_line$="MessageRequester_Magic_BF"
Define text$="Hello World"+#LF$+"How are you"+#LF$+#LF$+"GFX_Wizzard_BF"
Define flags.a=#PB_MessageRequester_YesNoCancel ; #PB_MessageRequester_Yes - #PB_MessageRequester_YesNo
Define text_button_yes$="Yes"+#LF$+"so it is cool"
Define text_button_no$="No - so not"
Define text_button_cancel$="Cancel"
Define text_width=600
Define text_height=200
Define text_stretching_x=0 ; Text stretching x - Headline mode - Negative values available
Define text_stretching_y=0 ; Text stretching y - Headline mode - Negative values available
Define text_padding_x=20   ; This shrink the text x - Negative values available
Define text_padding_y=20   ; This shrink the text y - Negative values available
Define text_color=#Blue    ; Colors are alpha channel sensitive
Define buttons_color=#Black
Define text_background_color=$FF00FFFF    ; -1 = transparent
Define buttons_background_color=$20FFFF00 ; -1 = transparent
Define buttons_width=125
Define buttons_height=35
Define button_yes_padding_x=8
Define button_yes_padding_y=12
Define button_no_padding_x=30
Define button_no_padding_y=12
Define button_cancel_padding_x=8
Define button_cancel_padding_y=15
Define font$="Georgia"
Define font_style=0 ; #PB_Font_Bold

Define Image_ID=LoadImage(#PB_Any, "./Image_Set/Foxy.png")

; Add a percent based fitted proportional image to MagicTextGadget_BF - You must deactivate again
MagicStretchText_Add_Image_BF(image_ID, ; Image ID - deactivate = -1
                              80*DPI_ResizeFactor_BF(), ; x
                              5*DPI_ResizeFactor_BF(),  ; y
                              60,                       ; Image width  - percent,
                              60,                       ; Image height - percent,
                              255,                      ; Image alpha
                              1)                        ; Sticky image)       

; Activate linear gradient
; LinearGradient_BF(1, 0, 0, text_width*DPI_ResizeFactor_BF()/2, text_height*DPI_ResizeFactor_BF())

; Add a border
Define frame_size_stretchtext=3
Define frame_padding_stretchtext=8
Define frame_rounding_stretchtext=6
Define frame_color_stretchtext=$AAAAAA
Magic_StretchText_Pro_Border_BF(frame_size_stretchtext,
                                frame_padding_stretchtext,
                                frame_rounding_stretchtext,
                                frame_color_stretchtext)

; This function deactivate the automatically text stretching for vector text based Gadgets_BF,
; - as sample ToggleGadget_BF, StretchTextGadget_BF, MagicTextGadget_BF, MessageRequester_Magic_BF
; This is a mighty feature - you must activate again text stretching
; With an unsymmetrical padding the stretching becomes active on MagicText, positive values reduce the output, negative values increase it
Define preset_stretchfactor_x.d=1.0
Define preset_stretchfactor_y.d=1.0
Deactivate_TextStretching_BF(1, preset_stretchfactor_x.d, preset_stretchfactor_y.d)

Define result=MessageRequester_Magic_BF(title_line$,
                                        text$,
                                        flags.a,
                                        text_button_yes$,
                                        text_button_no$,
                                        text_button_cancel$,
                                        text_width,
                                        text_height,
                                        text_stretching_x,
                                        text_stretching_y,
                                        text_padding_x,
                                        text_padding_y,
                                        text_color,
                                        buttons_color,
                                        text_background_color,
                                        buttons_background_color,
                                        buttons_width,
                                        buttons_height,
                                        button_yes_padding_x,
                                        button_yes_padding_y,
                                        button_no_padding_x,
                                        button_no_padding_y,
                                        button_cancel_padding_x,
                                        button_cancel_padding_y,
                                        font$,
                                        font_style)

Deactivate_TextStretching_BF(0) ; Deactivate again 

MagicStretchText_Add_Image_BF() ; Deactivate again 

; Debug result
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 79
; FirstLine = 56
; EnableXP
; DPIAware