﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Demo - Migrate a ButtonImageGadget PB to a ColorButtonGadget_BF

EnableExplicit

Activate_DPI_aware_BF(1) ; This activate DPI_aware

Define button_width=450
Define button_height=250

Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 600, "Migrate a Gadget PB to a Gadget_BF", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)

Define x_pos=WindowWidth(window_ID)/2-button_width/2
Define y_pos=WindowHeight(window_ID)/2-button_height/2

; Create a ButtonImageadget PB
Define button_gadget_1_ID=ButtonImageGadget(#PB_Any,
                                            x_pos,
                                            y_pos,
                                            button_width,
                                            button_height,
                                            0)

; Migrate the ButtonImageGadget PB to a ColorButtonGadget_BF

; Use ever a large font for the buttons - Then the function adjust the needed font size automatically (about 60 for the mostly large buttons)
Define font_ID=LoadFont(#PB_Any, "Arial", 60, #PB_Font_Bold)

button_gadget_1_ID=ColorButtonGadget_BF("Hello BF",
                                        -2,                 ; Replace x_pos with -2
                                        button_gadget_1_ID, ; Replace y_pos with the PB Gadget ID
                                        button_width,
                                        button_height,
                                        #Yellow,
                                        #Blue,
                                        font_ID)

If Not IsGadget(button_gadget_1_ID) ; You can check the result >0 is OK
  MessageRequester("ERROR", "Can not create a Gadget_BF")
  End
EndIf

Repeat
  Define win_event=WaitWindowEvent()
  
  If win_event=#PB_Event_Gadget
    
    Select EventGadget()
      Case button_gadget_1_ID
        
    EndSelect
    
  EndIf
  
Until win_event=#PB_Event_CloseWindow

FreeGadget_BF(button_gadget_1_ID) ; Free all used resources
                                  ; Ending the thread free automatically all resources, so you must not free a Gadget_BF

; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 7
; EnableXP
; DPIAware