﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Progressbar_BF using  - DPI aware

EnableExplicit

Define window_ID=OpenWindow(#PB_Any, 0, 0, 650, 420, "ProgressBar_BF - Simplest", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
SetWindowColor(window_ID, $909090)

Define Bar_1=ProgressBarGadget(#PB_Any, 90, 120, 460, 25, 0, 100) ; Simple create a OS ProgressBar #1
Define Bar_2=ProgressBarGadget(#PB_Any, 90, 180, 460, 25, 0, 100) ; Simple create a OS ProgressBar #2
Define Bar_3=ProgressBarGadget(#PB_Any, 90, 240, 460, 25, 0, 100) ; Simple create a OS ProgressBar #3

; Settings for SetFrontText_Progressbar_BF
; txt$          - Mostly as percentage
; txt_x         - Output pos x
; txt_y         - Output pos y
; txt_direction - rotating arc as degree
; txt_color     - Text color
; txt_alpha     - Set alpha blending for text from 1 to 256 - Set 1=full visible - 256=invisible (Tool and GFX_Wizzard_BF specific)
; font_ID       - You can select a font (ID) for using - but you must not - You can set as sample #SysFont_BF or #SysFontBold_BF
; This function add a text inside the bar_Progressbar_BF
; Use this function over a SetGadgeState_Progressbar_BF call
; Set text$=" " create only a dividing line

; Progressbar_BF
; This function replace SetGadgetState()
; This function is for simplest replacing OS progressbars on all OS with multi color custom progressbars
; The created custom progressbars are canvas gadgets, the tool give back this canvas gadgets and it ID's
; Also the tool can give back only a image (ID) for fine post processing, as sample with the GFX_Wizzard_BF
; Replace simple SetGadgetState with SetGadgetState_Progressbar_BF and add parameters you want, more you must not do

; Sample call :
; SetGadgetState(bar_ID, 100*writen/file_size) ; OS progress bar
; SetGadgetState_Progressbar_BF(bar_ID, 100*writen/file_size), flags, mode, slider_color_1, background_color) ; Progressbar_BF

; Available flags :
; #PB_ProgressBar_Vertical
; #PB_ProgressBar_Unknown
; #PB_ProgressBar_Horizontal
; #PB_ProgressBar_Remove

; mode=1 - Gradient color - Horizontal direction - mode=-1 same mode=1 but only image creating
; mode=2 - Gradient color - Vertical direction - mode=-2 same mode=1 but only image creating
; For disable automatically gradient_color set slider_color_2=-1
; For moving the linear gradient output position set gradient_color_offset as percent
; For using #PB_ProgressBar_Unknown, you must handle the animation self (Maybe threaded - I will not preset threads here)

Define value=80 ; %
Define mode=2
Define slider_color_1=#Green
Define background_color=$E6E6E6
Define slider_color_2=#Red
Define border_thickness=2
Define border_color=$707070
Define linear_gradient_offset=30
Define direction=#PB_ProgressBar_Horizontal

; Call the ProgressBar #1
SetGadgetState(Bar_1, value) ; Simple replace your OS ProgressBar calls, more is not needed #1

; Call the ProgressBar BF #2
SetGadgetState_Progressbar_BF(Bar_2, value) ; Set the ProgressBar PB Gadget_ID and the value - state #2

; Call the ProgressBar BF #3
SetFrontText_0_Progressbar_BF(Str(value)+"%" ,3 ,4, 0, #Black, 0, SysFont_BF) ; You can add text
SetFrontText_1_Progressbar_BF("GFX_Wizzard_BF - Simple a little more" ,100 ,4, 0, #Blue, 0, SysFont_BF) ; You can add text
SetGadgetState_Progressbar_BF(Bar_3,                                                                    ; Gadget ID
                              85,                                                                       ; Value - State
                              direction,                                                                ; Direction
                              mode,                                                                     ; Mode
                              slider_color_1,                                                           ; Slider color 1
                              background_color,                                                         ; Background color
                              slider_color_2,                                                           ; Slider color 2 - Additional slider color
                              border_thickness,                                                         ; Border thickness - -1 activate the CanvasGadget() border, >0 a custom border
                              border_color,                                                             ; Border color
                              linear_gradient_offset)                                                   ; Linear gradient output offset - A negative value flip the slider colors

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 23
; FirstLine = 5
; EnableXP
; DPIAware