﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Progressbar_BF using  - DPI aware

EnableExplicit

Define window_ID=OpenWindow(#PB_Any, 0, 0, 650, 420, "ProgressBar_BF - Simplest", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
SetWindowColor(window_ID, $909090)

Define Bar_1=ProgressBarGadget(#PB_Any, 50, 60, 450, 25, 0, 100)   ; Simple create a OS ProgressBar #1
Define Bar_2=ProgressBarGadget(#PB_Any, 560, 20, 45, 380, 0, 100)  ; Simple create a OS ProgressBar #2
Define Bar_3=ProgressBarGadget(#PB_Any, 50, 150, 350, 25, 0, 100)  ; Simple create a OS ProgressBar #3
Define Bar_4=ProgressBarGadget(#PB_Any, 470, 170, 30, 200, 0, 100) ; Simple create a OS ProgressBar #4
Define Bar_5=ProgressBarGadget(#PB_Any, 50, 230, 300, 20, 0, 100)  ; Simple create a OS ProgressBar #5
Define Bar_6=ProgressBarGadget(#PB_Any, 400, 230, 30, 160, 0, 100) ; Simple create a OS ProgressBar #6
Define Bar_7=ProgressBarGadget(#PB_Any, 340, 280, 20, 120, 0, 100) ; Simple create a OS ProgressBar #7
Define Bar_8=ProgressBarGadget(#PB_Any, 90, 320, 200, 25, 0, 100)  ; Simple create a OS ProgressBar #8

; Settings for SetFrontText_Progressbar_BF
; txt$          - Mostly as percentage
; txt_x         - Output pos x
; txt_y         - Output pos y
; txt_direction - rotating arc as degree
; txt_color     - Text color
; txt_alpha     - Set alpha blending for text from 1 to 256 - Set 1=full visible - 256=invisible (Tool and GFX_Wizzard_BF specific)
; font_ID       - You can select a font (ID) for using - but you must not - You can set as sample #SysFont_BF or #SysFontBold_BF
; This function add a text inside the bar_Progressbar_BF
; Use this function over a SetGadgeState_Progressbar_BF call
; Set text$=" " create only a dividing line

; Progressbar_BF
; This function replace SetGadgetState()
; This function is for simplest replacing OS progressbars on all OS with multi color custom progressbars
; The created custom progressbars are canvas gadgets, the tool give back this canvas gadgets and it ID's
; Also the tool can give back only a image (ID) for fine post processing, as sample with the GFX_Wizzard_BF
; Replace simple SetGadgetState with SetGadgetState_Progressbar_BF and add parameters you want, more you must not do

; Sample call :
; SetGadgetState(bar_ID, 100*writen/file_size) ; OS progress bar
; SetGadgetState_Progressbar_BF(bar_ID, 100*writen/file_size), flags, mode, slider_color_1, background_color) ; Progressbar_BF

; Available flags :
; #PB_ProgressBar_Vertical
; #PB_ProgressBar_Unknown
; #PB_ProgressBar_Horizontal
; #PB_ProgressBar_Remove

; mode=1 - Gradient color - Horizontal direction - mode=-1 same mode=1 but only image creating
; mode=2 - Gradient color - Vertical direction - mode=-2 same mode=1 but only image creating
; For disable automatically gradient_color set slider_color_2=-1
; For moving the linear gradient output position set gradient_color_offset as percent
; For using #PB_ProgressBar_Unknown, you must handle the animation self (Maybe threaded - I will not preset threads here)

Define mode=2
Define slider_color_1=#Green
Define background_color=$E6E6E6
Define slider_color_2=#Red
Define border_thickness=2
Define border_color=$AAAAAA
Define linear_gradient_offset=30

; SetGadgetState(Bar_1, value) ; Simple replace your OS ProgressBar calls, more is not needed
Define value=90 ; %
Define value$=Str(value)+"%"
SetFrontText_0_Progressbar_BF(value$ ,3 ,5, 0, #Black, 100, SysFont_BF) ; You can add text

; Call the ProgressBar BF #1
SetGadgetState_Progressbar_BF(Bar_1,                      ; Gadget ID
                              value,                      ; Value - State
                              #PB_ProgressBar_Horizontal, ; Direction
                              mode,                       ; Mode
                              slider_color_1,             ; Slider color 1
                              background_color,           ; Background color
                              slider_color_2,             ; Slider color 2 - Additional slider color
                              border_thickness,           ; Border thickness - -1 activate the CanvasGadget() border, >0 a custom border
                              border_color,               ; Border color
                              linear_gradient_offset)     ; Linear gradient output offset - A negative value flip the slider colors

; Call the ProgressBar BF #2
Define value=80 ; %
If value=100 : Define value$=Str(value)+"%": Else : value$=" "+Str(value)+"%" : EndIf
SetFrontText_0_Progressbar_BF(value$ ,4 ,360, 0, #Black, 100, SysFont_BF) ; You can add text
linear_gradient_offset=50
SetGadgetState_Progressbar_BF(Bar_2,
                              value,
                              #PB_ProgressBar_Vertical,
                              2,
                              #Red,
                              $E6E6E6,
                              #Green,
                              border_thickness,
                              border_color,
                              linear_gradient_offset)

; Call the ProgressBar BF #3
Define value=80 ; %
Define value$=Str(value)+"%"
SetFrontText_0_Progressbar_BF(value$ ,3 ,5, 0, #Black, 100, SysFont_BF) ; You can add text
linear_gradient_offset=50
SetGadgetState_Progressbar_BF(Bar_3,
                              value,
                              #PB_ProgressBar_Horizontal,
                              1,
                              #Green,
                              $E6E6E6,
                              $71B33C,
                              border_thickness,
                              border_color,
                              0)

; Call the ProgressBar BF #4
Define value=80 ; %
linear_gradient_offset=50
SetGadgetState_Progressbar_BF(Bar_4,
                              value,
                              #PB_ProgressBar_Vertical,
                              1,
                              $71B33C,
                              $E6E6E6,
                              #Green,
                              border_thickness,
                              border_color,
                              0)

; Call the ProgressBar BF #5
SetGadgetState_Progressbar_BF(Bar_5,
                              value,
                              #PB_ProgressBar_Horizontal,
                              1,
                              #Green,
                              $E6E6E6,
                              -1,
                              -1,
                              border_color,
                              0)

; Call the ProgressBar BF #6
SetGadgetState_Progressbar_BF(Bar_6,
                              value,
                              #PB_ProgressBar_Vertical,
                              1,
                              #Green,
                              $E6E6E6,
                              $71B33C,
                              border_thickness,
                              border_color,
                              0)

; Call the ProgressBar BF #7
SetGadgetState_Progressbar_BF(Bar_7,
                              90,
                              #PB_ProgressBar_Vertical,
                              2,
                              #Green,
                              $E6E6E6,
                              #Red,
                              border_thickness,
                              border_color,
                              -60)

; Call the ProgressBar BF #8
SetGadgetState_Progressbar_BF(Bar_8,                                       ; Gadget ID
                              value,                                       ; Value - State
                              #PB_ProgressBar_Horizontal,                  ; Direction
                              mode,                                        ; Mode
                              slider_color_1,                              ; Slider color 1
                              $707070,                                     ; Background color
                              slider_color_2,                              ; Slider color 2 - Additional slider color
                              3,                                           ; Border thickness - -1 activate the CanvasGadget() border, >0 a custom border
                              $FFBF00,                                     ; Border color
                              -50)                                         ; Linear gradient output offset - A negative value flip the slider colors

; Call the ProgressBar BF #9
HideWindow(window_ID, 0)
Define i=-200
Repeat
  If i>200 : i=-200 : EndIf
  
  If Delay_BF(1, 20) : i+1 : EndIf
  
  SetFrontText_0_Progressbar_BF("Hello World - BF is cool" ,i ,5, 0, #Black, 100, SysFont_BF) ; You can add text
  If i>40 And i<100
    border_color=#Red
    border_thickness=5
    SetFrontText_1_Progressbar_BF(Str(i)+"%" ,3 ,5, 0, #Black, 100, SysFont_BF) ; You can add text
  Else
    border_color=$FFBF00 
    border_thickness=3
  EndIf
  
  SetGadgetState_Progressbar_BF(Bar_8,                      ; Gadget ID
                                i,                          ; Value - State
                                #PB_ProgressBar_Horizontal, ; Direction
                                mode,                       ; Mode
                                slider_color_1,             ; Slider color 1
                                $CCCCCC,                    ; Background color
                                slider_color_2,             ; Slider color 2 - Additional slider color
                                border_thickness,           ; Border thickness - -1 activate the CanvasGadget() border, >0 a custom border
                                border_color,               ; Border color
                                -50)                        ; Linear gradient output offset - A negative value flip the slider colors
  
Until WaitWindowEvent(10)=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 97
; FirstLine = 72
; EnableXP
; DPIAware
; DisableDebugger