﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Progressbar_BF using on MagicGadget_BF - DPI aware
; Look in the Wizzard declare part or on Progressbar_BF demo code 1 or 2 for parameter descriptions

EnableExplicit

Define win_event, font_1_ID, image_1_ID, image_2_ID, image_3_ID, i_1

Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 650, 420, "ProgressBar_BF - Output on MagicTextGadget_BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
SetWindowColor(window_ID, $909090)
AddWindowTimer(window_ID, 1, 40) ; You can change

CompilerIf #PB_Compiler_OS=#PB_OS_Windows : font_1_ID=LoadFont(#PB_Any, "Arial", 7) : CompilerEndIf ; Select a suitable font
CompilerIf #PB_Compiler_OS=#PB_OS_Linux : font_1_ID=LoadFont(#PB_Any, "Arial", 7) : CompilerEndIf
CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : font_1_ID=LoadFont(#PB_Any, "Arial", 10) : CompilerEndIf

Define Bar_1=ProgressBarGadget(#PB_Any, 0, 0, 250, 13, 0, 100)                            ; OS Progressbars with custom output
Define Bar_2=ProgressBarGadget(#PB_Any, 0, 0, 400, 80, 0, 100)                            ; OS Progressbars with custom output
Define Bar_3=ProgressBarGadget(#PB_Any, 0, 0, 100, 400, 0, 100, #PB_ProgressBar_Vertical) ; The vertical flag, you can, but you must not set
HideGadget(Bar_1, 1) : HideGadget(Bar_2, 1) : HideGadget(Bar_3, 1)                        ; Firstly we hidden the not needed empty ProgressBars

Global text_1$="GFX_Wizzard_BF"+#LF$+
               "MagicTextGadget_BF"+#LF$+
               "With integrated ProgressBar_BF"

Global text_2$=text_1$+#LF$+"_"

Global Gadget_1_ID=MagicTextGadget_BF(0,                ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                      text_2$,          ; Text
                                      100,              ; Gadget output x pos
                                      50,               ; Gadget output y pos
                                      450,              ; Gadget width
                                      90,               ; Gadget height
                                      400,              ; Text width
                                      80,               ; Text height
                                      2,                ; Text stretching x - Headline mode
                                      2,                ; Text stretching y - Headline mode
                                      30,               ; padding_x
                                      10,               ; Padding y
                                      #Black,           ; Text color - Alpha channel supported
                                      #Yellow,          ; Background color - Alpha channel supported - For invisible background set to -1
                                      1,                ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                      "Georgia",        ; Font type - more is not needed - accept also ""
                                      #PB_Font_Bold ,   ; #PB_Font_Bold - Font style
                                      #PB_Image_Raised) ; #PB_Image_Border, #PB_Image_Raised ; Border flag)

Global Gadget_2_ID=MagicTextGadget_BF(0,                ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                      text_1$,          ; Text
                                      100,              ; Gadget output x pos
                                      150,              ; Gadget output y pos
                                      450,              ; Gadget width
                                      90,               ; Gadget height
                                      400,              ; Text width
                                      80,               ; Text height
                                      0,                ; Text stretching x - Headline mode
                                      0,                ; Text stretching y - Headline mode
                                      40,               ; padding_x
                                      10,               ; Padding y
                                      #Black,           ; Text color - Alpha channel supported
                                      #Yellow,          ; Background color - Alpha channel supported - For invisible background set to -1
                                      1,                ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                      "Georgia",        ; Font type - more is not needed - accept also ""
                                      0,                ; #PB_Font_Bold - Font style
                                      #PB_Image_Raised) ; #PB_Image_Border, #PB_Image_Raised ; Border flag)

Global Gadget_3_ID=MagicTextGadget_BF(0,                ; 0 = ButtonImageGadget - 1 = CanvasGadget - 2 = ImageGadget
                                      text_1$,          ; Text
                                      100,              ; Gadget output x pos
                                      250,              ; Gadget output y pos
                                      450,              ; Gadget width
                                      90,               ; Gadget height
                                      600,              ; Text width
                                      100,              ; Text height
                                      0,                ; Text stretching x - Headline mode
                                      0,                ; Text stretching y - Headline mode
                                      90,               ; padding_x
                                      10,               ; Padding y
                                      #Black,           ; Text color - Alpha channel supported
                                      #Yellow,          ; Background color - Alpha channel supported - For invisible background set to -1
                                      1,                ; Text flag - Text center=1 - Text right=2 - Text vertical=3
                                      "Georgia",        ; Font type - more is not needed - accept also ""
                                      0,                ; #PB_Font_Bold - Font style
                                      #PB_Image_Raised) ; #PB_Image_Border, #PB_Image_Raised ; Border flag)
HideWindow(window_ID, 0)

Repeat
  If win_event=#PB_Event_Timer And EventTimer()=1
    i_1=(i_1+1)%101
    ; Output a progressbar as hidden image - So you can post process how ever you want
    
    If i_1<88
      Define offset=2
    Else
      offset=-31
    EndIf  
    
    CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
      SetFrontText_0_Progressbar_BF(Str(i_1)+"%" ,Calculate_SliderPos_Progressbar_BF(Bar_1, i_1, #PB_ProgressBar_Horizontal)+offset ,1, 0, 0, 1, font_1_ID) ; Add text
    CompilerElse
      SetFrontText_0_Progressbar_BF(Str(i_1)+"%" ,Calculate_SliderPos_Progressbar_BF(Bar_1, i_1, #PB_ProgressBar_Horizontal)+offset ,1, 0, 0, 1, font_1_ID) ; Add text
    CompilerEndIf
    
    image_1_ID=SetGadgetState_Progressbar_BF(Bar_1, i_1, #PB_ProgressBar_Horizontal, -1, $578B2E, $CCCCCC, #Green, 0, #Blue, -90) ; Replace the OS progressbar
    image_2_ID=SetGadgetState_Progressbar_BF(Bar_2, i_1, #PB_ProgressBar_Horizontal, -1, $578B2E, #Yellow, #Green, 0, #Blue, -110); Replace the OS progressbar
    image_3_ID=SetGadgetState_Progressbar_BF(Bar_3, i_1, #PB_ProgressBar_Vertical, -2, #Red, #Yellow, $578B2E, 5*DPI_ResizeFactor_BF(), $AAAAAA, -50) ; Replace the OS progressbar
    
    MagicStretchText_Add_Image_BF(image_1_ID,               ; Image ID - deactivate = -1
                                  52*DPI_ResizeFactor_BF(), ; x
                                  68*DPI_ResizeFactor_BF(), ; y
                                  100,                      ; Image width  - percent
                                  20,                       ; Image height - percent
                                  255,                      ; Image alpha
                                  1)                        ; Sticky image)  
    SetMagicTextGadget_BF(gadget_1_ID)
    
    MagicStretchText_Add_Image_BF(image_2_ID, ; Image ID - deactivate = -1
                                  0,          ; x
                                  0,          ; y
                                  100,        ; Image width  - percent
                                  100,        ; Image height - percent
                                  230,        ; Image alpha
                                  0)          ; Sticky image)
    SetMagicTextGadget_BF(gadget_2_ID)
    
    MagicStretchText_Add_Image_BF(image_3_ID,               ; Image ID - deactivate = -1
                                  10*DPI_ResizeFactor_BF(), ; x
                                  7*DPI_ResizeFactor_BF(),  ; y
                                  100,                      ; Image width  - percent
                                  85,                       ; Image height - percent
                                  255,                      ; Image alpha
                                  0)                        ; Sticky image)
    SetMagicTextGadget_BF(gadget_3_ID)
    
    Repeat  ; After output get all window events - Linux need this here
      win_event=WindowEvent() 
      If win_event=#PB_Event_CloseWindow
        End
      EndIf
    Until Not win_event
    
  EndIf
  
  win_event=WaitWindowEvent(1)
Until win_event=#PB_Event_CloseWindow
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 120
; FirstLine = 114
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger