﻿
; Compactness demo - Rotate large sprite on a windowed screen

XIncludeFile("./GFX_Wizzard_BF.pbi")

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Macro output_sprites
  degree=(degree+1)%359+1
  Free_PB_Sprite_BF(sprite_PB)
  sprite_PB=CreateSprite_simple_BF(1, sprite_ID, -2, 0, degree, 1, 700, 100) ; Create a resized and rotated PB sprite from a other
  DisplaySprite(background_sprite, 0, 0)
  DisplayTransparentSprite(sprite_PB, 28, -50)
EndMacro

window_ID=OpenWindow(#PB_Any, 0, 0, 768, 600, "Rotate large sprite on windowed screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(window_ID), 0, 0, 768, 600)

sprite_ID=CreateSprite(#PB_Any, 256, 256)
StartDrawing(SpriteOutput(sprite_ID))
Box(0,0,128,128,$FF0000) : Box(128,0,128,128,$00FF00) : Box(0,128,128,128,$0000FF) : Box(128,128,128,128,$00FFFF)
StopDrawing()

background_sprite=CreateSprite(#PB_Any, 768, 600)
ErrorCheck_BF(BF(-2, background_sprite, sprite_ID)) ; Create a tilled background

NoCaching_BF(1) ; The BF sprite change persistent, so a caching has not a positive effect - This deactivate the BF texture caching

Repeat
  
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      End
    EndIf
  Until Not win_event
  
  ClearScreen(0)
  output_sprites
  FlipBuffers()
  
ForEver
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 13
; Folding = -
; EnableXP
; DisableDebugger