﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling demo - Create and scroll a isometric patterned background on a windowed screen - Method 2 - BF direct sprite access - simple

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
Define i, ii, sprite_ID, output_x, output_y
Define output_width=DesktopWidth_UserScaled_BF()*0.90, output_height=DesktopHeight_UserScaled_BF()*0.90
Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, output_width, output_height, "Scrolling Demo on windowed Screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, output_width, output_height) : End : EndIf ;  Create a windowed screen for output

Macro create_sprite
  If IsSprite(sprite_ID) : FreeSprite(sprite_ID) : EndIf
  sprite_ID=CreateSprite(#PB_Any, Random(300, 20), Random(300, 20))
  StartDrawing(SpriteOutput(sprite_ID))
  Box(0, 0, SpriteWidth(sprite_ID), SpriteHeight(sprite_ID), $FF0000)
  LineXY(0, 0, SpriteWidth(sprite_ID), SpriteHeight(sprite_ID), $FFFFFF)
  LineXY(0, SpriteHeight(sprite_ID), SpriteWidth(sprite_ID), 0, $FFFFFF)
  StopDrawing()
EndMacro
create_sprite

Macro draw_PB_sprites
  FlipBuffers()
  ClearScreen(RGB(0, 0, 0))
  For i=0 To output_width : For ii=0 To output_height
      DisplaySprite(sprite_ID, i, ii) : ii+SpriteHeight(sprite_ID)-1
    Next
    i+SpriteWidth(sprite_ID)-1
  Next
EndMacro

Repeat

  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      FreeTextures_BF() ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(1, 3000) : create_sprite : EndIf
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    ErrorCheck_BF(BF(1, sprite_ID, sprite_ID, -1, -1, output_x, output_y)) ; Scroll the sprite
    draw_PB_sprites
    ; You can change simple the direction and moving speed, how ever you want
    ; output_x-2 : If output_x=<-SpriteWidth(sprite_ID) : output_x=0 : EndIf ; Moving direction left
    ; output_y-2 : If output_y=<-SpriteHeight(sprite_ID) : output_y=0 : EndIf ; Moving direction up
    output_x+2 : If output_x=>0: output_x=-SpriteWidth(sprite_ID) : EndIf ; Moving direction right
    output_y+2 : If output_y=>0: output_y=-SpriteHeight(sprite_ID) : EndIf; Moving direction down
  EndIf
  
ForEver
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 34
; FirstLine = 22
; Folding = -
; EnableXP
; DisableDebugger