﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling demo - Create and scroll a isometric patterned background on a windowed screen - Method 2 - BF hardware sprite direct access - simple

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
Define i, ii, win_event, sprite_ID, sprite_1_ID, sprite_2_ID, sprite_3_ID, sprite_4_ID, output_x, output_y
Define output_x_1, output_y_1, output_x_2, output_y_2, output_y_3, output_x_3, arc, fps
Define pattern_size_x=200, pattern_size_y=200
Define output_width=DesktopWidth_UserScaled_BF()*0.90, output_height=DesktopHeight_UserScaled_BF()*0.90
Define texture_ID=LoadImage(#PB_Any, "./Image_Set/Hubble.jpg")
Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Lion.jpg")
Define milliseconds.q=ElapsedMilliseconds()-1e3

ResizeImage(texture_ID, 256, 256)

Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, output_width, output_height, "Scrolling Demo on windowed Screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, output_width-300, output_height) : End : EndIf ;  Create a windowed screen for output
Define canvas_ID=CanvasGadget(#PB_Any, output_width-280, 0, ImageWidth(texture_ID), ImageHeight(texture_ID))
Define canvas_1_ID=CanvasGadget(#PB_Any, output_width-280, 300, 80, 20)

Define pattern_size_x_1=ImageWidth(texture_ID), pattern_size_y_1=ImageHeight(texture_ID)
Define pattern_size_x_2=pattern_size_x_1, pattern_size_y_2=pattern_size_y_1
Define pattern_size_x_3=pattern_size_x, pattern_size_y_3=pattern_size_y

sprite_ID=CreateSprite(#PB_Any, pattern_size_x, pattern_size_y)
StartDrawing(SpriteOutput(sprite_ID))
LineXY(0, 0, SpriteWidth(sprite_ID), SpriteHeight(sprite_ID), $FFFFFF)
LineXY(0, SpriteHeight(sprite_ID), SpriteWidth(sprite_ID), 0, $FFFFFF)
StopDrawing()

sprite_1_ID=CreateSprite(#PB_Any, ImageWidth(texture_ID), ImageHeight(texture_ID))

Define txt$="This is a text output directly as sprite"+#LF$+
            "Maked with DrawText_BF"+#LF$+
            "You have phantastic abilities for text output on BF"
Define font_ID=LoadFont(#PB_Any, "Arial", 18/DPI_ResizeFactor_BF())
sprite_2_ID=DrawTextCreate_PB_Sprite_BF(txt$, #White, #Black, 1, 0, font_ID, 2, 2, 10)
SpriteQuality(#PB_Sprite_BilinearFiltering)

Macro add_text
  StartDrawing(ImageOutput(Get_animation_buffer_hidden_image_ID_BF(0)))
  DrawingMode(#PB_2DDrawing_Transparent)
  DrawText_BF(20, 10, "GFX_Wizzard_BF", $FF00)
  StopDrawing()
EndMacro

Macro draw_PB_sprites
  FlipBuffers()
  ClearScreen(RGB(0, 0, 0))
  For i=0 To output_width : For ii=0 To output_height 
      DisplaySprite(sprite_1_ID, i, ii) : ii+SpriteHeight(sprite_1_ID)-1
    Next
    i+SpriteWidth(sprite_1_ID)-1
  Next
  For i=0 To output_width : For ii=0 To output_height 
      DisplayTransparentSprite(sprite_ID, i, ii, 255) : ii+SpriteHeight(sprite_ID)-1
    Next
    i+SpriteWidth(sprite_ID)-1
  Next
  DisplayTransparentSprite(sprite_2_ID, 50, 50)
  
  Free_selected_Texture_BF(sprite_3_ID)
  
  sprite_3_ID=CreateSprite_simple_BF(1, canvas_ID,
                                         -1,    ; Grab transparence color from input pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                                         $FF00, ; Grab transparence color from input pos y - For preset set ..y= the color you want - as sample $FF00FF
                                         arc,   ; Rotating degree - The sprite rotates around its center point - With the rotating_offsets you can relocate this point
                                         1,     ; mode=0 deactivate rotating - mode=1 create a quadratic sprite for on demand rotation mode=2create a exactely resized sprite with minimized mask
                                         400,   ; You can here resize the output x - On demand
                                         250,   ; You can here resize the output y - On demand
                                         0,     ; Rotating offset x - For mode 1 - Do not make offsets too big - Bigger = slower, but I will give you not a limit
                                         0,     ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple
                                         30,    ; Color distance sprite mask - Mask cleaning - Important                                  
                                         0,     ; Delete the input 
                                         0,     ; Mirroring - 0=without - 1=horizontal - 2=vertical - 3=horizontal and vertical
                                         0)     ; Flags for CreateSprite - same PB function call
                                                ; The function accepts as input a image, a PB sprite or a canvas (ID)
  
  TransparentSpriteColor(sprite_3_ID, GetUsedInvisibleColor_BF())
  DisplayTransparentSprite(sprite_3_ID, 600, 300)
  
  Free_selected_Texture_BF(sprite_4_ID)

  sprite_4_ID=CreateSprite_simple_BF(1, texture_1_ID,
                                         0,   ; Grab transparence color from input pos x - For preset set ..x=-1 - x=-2 ignore the invisible color and set image_get_color_y as mask color
                                         0,   ; Grab transparence color from input pos y - For preset set ..y= the color you want - as sample $FF00FF
                                         arc, ; Rotating degree - The sprite rotates around its center point - With the rotating_offsets you can relocate this point
                                         1,   ; mode=0 deactivate rotating - mode=1 create a quadratic sprite for on demand rotation mode=2create a exactely resized sprite with minimized mask
                                         300, ; You can here resize the output x - On demand
                                         200, ; You can here resize the output y - On demand
                                         30,  ; Rotating offset x - For mode 1 - Do not make offsets too big - Bigger = slower, but I will give you not a limit
                                         30,  ; Rotating offset y - You can also set negative values for the rotating offsets - As sample x=50 - y=-50 - This works very easy and simple
                                         36,  ; Color distance sprite mask - Mask cleaning - Important                                  
                                         0,   ; Delete the input 
                                         0,   ; Mirroring - 0=without - 1=horizontal - 2=vertical - 3=horizontal and vertical
                                         0)   ; Flags for CreateSprite - same PB function call
                                              ; The function accepts as input a image, a PB sprite or a canvas (ID)
  
  TransparentSpriteColor(sprite_4_ID, GetUsedInvisibleColor_BF())
  DisplayTransparentSprite(sprite_4_ID, 100, 100)
  
EndMacro

Macro draw_BF_sprites_on_canvas
  ; Additional output a pattern separately on canvas - With triple buffering 
  FlipBuffers_BF(0) ; Activate BF triple buffering
  ErrorCheck_BF(BF(1, Get_animation_buffer_background_image_ID_BF(0), texture_ID, 0, 10, output_x_2, output_y_2)) ; Add and scroll background image
  ErrorCheck_BF(BF(1, Get_animation_buffer_hidden_image_ID_BF(0), sprite_ID, 0, 10, output_x_3, output_y_3))      ; Add and scroll isometric pattern
  
  add_text ; Add text
  
  ; Add a rotating output
  SetColorDistanceSpriteMask_BF(25) ; This remove mask artifacts from the rotated output
  RotateSprite_simple_BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID, -1, $FF0000, 65, 135, arc, 1, 80, 80) ; Add a rotated output
  
  ;Get the result
  CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Put the hidden animation buffer in the canvas
EndMacro

Macro sprite_output 
  ErrorCheck_BF(BF(1, sprite_1_ID, texture_ID, -1, -1, output_x_1, output_y_1)) ; Create the output
  ErrorCheck_BF(BF(1, sprite_ID, sprite_ID, -1, -1, output_x, output_y))        ; and scroll the sprites
  draw_BF_sprites_on_canvas
  draw_PB_sprites
EndMacro

Create_animation_buffers_BF(canvas_ID, 0) ; Activate BF triple buffering for flicker free animation

Repeat

  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      FreeTextures_BF() ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10)
    fps+1 : If ElapsedMilliseconds()>milliseconds+1e3 : milliseconds=ElapsedMilliseconds() ; Set Delay_BF=(0, 0) to test the highest available speed
      StartDrawing(CanvasOutput(canvas_1_ID))
      Box(0, 0, 100, 80, 0)
      DrawText(0, 0, " "+Str(fps)+" fps ")
      StopDrawing()
      fps=0
    EndIf
  EndIf
  
  sprite_output
  
  output_x-2 : If output_x=<-pattern_size_x : output_x=0 : EndIf ; Moving direction left - All moving directions and speed you can change how ever you want
  output_y-1 : If output_y=<-pattern_size_y : output_y=0 : EndIf ; Moving direction up
  
  output_x_1+2 : If output_x_1=>0: output_x_1=-pattern_size_x_1 : EndIf  ; Moving direction right
  output_y_1+1 : If output_y_1=>0: output_y_1=-pattern_size_y_1 : EndIf  ; Moving direction down
  
  output_x_2-2 : If output_x_2=<-pattern_size_x_2 : output_x_2=0 : EndIf ; Moving direction left - All moving directions and speed you can change how ever you want
  output_y_2-1 : If output_y_2=<-pattern_size_y_2 : output_y_2=0 : EndIf ; Moving direction 
  
  output_x_3+2 : If output_x_3=>0: output_x_3=-pattern_size_x_3 : EndIf ; Moving direction right
  output_y_3+1 : If output_y_3=>0: output_y_3=-pattern_size_y_3 : EndIf ; Moving direction down
  
  arc=(arc+1)%360

ForEver
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 132
; FirstLine = 118
; Folding = -
; EnableXP
; DisableDebugger