﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling demo - Create and scroll over a textured background

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define texture_ID, result, output_x, output_y, win_event
Define texture_ID=LoadImage(#PB_Any, "./Image_Set/Caisse.png")
Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/Clouds.jpg")

Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 700, 500, "Scrolling Demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
Define canvas_ID=CanvasGadget(#PB_Any, 50, 50, 600, 400) ; Create a canvas for output
Define image_ID=CreateImage(#PB_Any, 600, 400)

result=BF(1, image_ID, texture_1_ID, -1, -1) ; Create a textured tiled background
ErrorCheck_BF(result)

Repeat
   Delay(1)
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    result=BF(1, image_ID, texture_ID, -1, -1, output_x, 150, 0, ImageHeight(texture_ID)) ; Scroll and duplicate the sprite up to output max
    ErrorCheck_BF(result)
    output_x+1 : If output_x>0 : output_x=-ImageWidth(texture_ID) : EndIf
  EndIf
  
  StartDrawing(CanvasOutput(canvas_ID))
  DrawImage(ImageID(image_ID), 0, 0)
  StopDrawing()
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      FreeTextures_BF()            ; Free grabbed textures
      End
    EndIf
  Until Not win_event
  
ForEver
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 18
; FirstLine = 6
; Folding = -
; EnableXP
; DisableDebugger