﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling and text demo - Create and scroll textured text - simple

EnableExplicit

Activate_DPI_aware_BF(1)

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
Define texture_ID, output_x, output_y
Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 900, 700, "Scrolling Demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
Define canvas_ID=CanvasGadget(#PB_Any, 10, 10, 880, 680) ; Create a canvas for output
Define txt_x, txt_y, mode, stretch_x, stretch_y, result, font_ID, win_event, txt$
Define f_col=#Black, b_col=#White, flag=1

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")
CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : result=52 : CompilerElse : result=40 : CompilerEndIf
font_ID=LoadFont(#PB_Any, "Arial", result/DPI_ResizeFactor_BF(), #PB_Font_Bold)

txt$="This is DrawText_BF"+#LF$+#LF$+"  Maked for GFX_Wizzard_BF  "+#LF$+#LF$+
     "Author : Werner Albus"+#LF$+#LF$+"Have Fun"+#LF$+#LF$

Macro create_sprite
  If IsImage(texture_ID) : FreeImage(texture_ID) : EndIf
  texture_ID=DrawTextCreateImage_BF(txt$, f_col, b_col, 1, 0, font_ID, stretch_x, stretch_y) 
  ErrorCheck_BF(BF(-2, texture_ID, texture_1_ID, -1, -1, output_x, output_y )) ; Create textured text
EndMacro
create_sprite

SetColorDistanceFill_BF(29)
SetColor_BF(#Black)
ErrorCheck_BF(BF(-2, texture_ID, texture_1_ID, -1, -1, output_x, output_y)) ; Create textured text
SetColor_BF(-1)

NoCaching_BF(1)

Repeat
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    ErrorCheck_BF(BF(1, canvas_ID, texture_ID, -1, -1, output_x, output_y)) ; Scroll and duplicate the sprite up to output max
    
    ; You can change simple the direction and moving speed, how ever you want
    ; output_x-1 : If output_x<-ImageWidth(texture_ID) : output_x=0 : EndIf  ; Moving direction left
    ; output_y-1 : If output_y<-ImageHeight(texture_ID) : output_y=0 : EndIf ; Moving direction up
    output_x+1 : If output_x>0: output_x=-ImageWidth(texture_ID) : EndIf     ; Moving direction right
    output_y+1 : If output_y>0: output_y=-ImageHeight(texture_ID)  : EndIf   ; Moving direction down
  EndIf
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow : FreeTextures_BF() : End : EndIf
  Until Not win_event
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 37
; FirstLine = 24
; Folding = -
; EnableXP
; DisableDebugger