﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling and text demo - Create and scroll texture inside text - simple

EnableExplicit
CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
Define texture_ID, output_x, output_y,  output_x_1, output_y_1, image_ID, arc, i, win_event
Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 900, 700, "Scrolling Demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
Define canvas_ID=CanvasGadget(#PB_Any, 10, 10, 880, 680) ; Create a canvas for output
Define mode, stretch_x, stretch_y, result, font_ID, txt$, txt1$
Define f_col=#Black, b_col=$13458B
Define flag=1
Define txt_x=150, txt_y=100 

Define texture_1_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")
Define texture_2_ID=LoadImage(#PB_Any, "./Image_Set/soil_wall.jpg")
Define texture_3_ID=LoadImage(#PB_Any, "./Image_Set/Background.bmp")

CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : result=160 : CompilerElse : result=120 : CompilerEndIf
font_ID=LoadFont(#PB_Any, "Arial", result/DPI_ResizeFactor_BF(), #PB_Font_Bold)

txt$="Hello"+#LF$+"World"+#LF$+"BF is cool"
txt1$=#LF$ ; Preset #LF$ - A centric output needs more as one line
Macro create_sprite
  If IsImage(texture_ID) : FreeImage(texture_ID) : EndIf
  texture_ID=DrawTextCreateImage_BF(txt1$, f_col, b_col, 1, 0, font_ID, stretch_x, stretch_y)
  If IsImage(texture_ID)
    ErrorCheck_BF(BF(-2, texture_ID, texture_1_ID, -1, -1, output_x, output_y )) ; Create texture
    ErrorCheck_BF(BF(-2, texture_ID, texture_2_ID, -1, -1, output_x_1, output_y_1 )) ; Create texture
  EndIf
EndMacro

SetColorDistanceFill_BF(20)

SetColorDistanceSpriteMask_BF(5)

SetColor_BF(#Black)

NoCaching_BF(1)

PresetLineWidth_BF(880) ; Max text len - Preset for centric output

Create_animation_buffers_BF(canvas_ID, 0) ; Init animation buffers - Triple buffering - Flicker free animation

Repeat
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    
    If Delay_BF(1, 150)
      i+1
      txt1$+Mid(txt$, i, 1)
      If i>Len(txt$)
        txt1$=#LF$
        i=0
      EndIf
      Debug txt1$
    EndIf
    
    ErrorCheck_BF(BF(1, Get_animation_buffer_background_image_ID_BF(0), texture_3_ID, -1, -1, output_x_1, output_y_1)) ; Make background
    create_sprite
    
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function 
    
    SpriteSimple_fast_BF(1, Get_animation_buffer_hidden_image_ID_BF(0), texture_ID, 0, 0, 0, -130) ; Hint : Sprite simple has further cool parameters !
    
    CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Put the hidden animation buffer in the canvas
    
    ; You can change simple the direction and moving speed, how ever you want
    output_x-1 : If output_x<-ImageWidth(texture_1_ID) : output_x=0 : EndIf  ; Moving direction left
    output_y-1 : If output_y<-ImageHeight(texture_1_ID) : output_y=0 : EndIf ; Moving direction up
    
    output_x_1+1 : If output_x_1>0: output_x_1=-ImageWidth(texture_2_ID) : EndIf ; Moving direction right
    output_y_1+1 : If output_y_1>0: output_y_1=-ImageHeight(texture_2_ID) : EndIf; Moving direction down
    
    arc=(arc+1)%360
    
  EndIf
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow : FreeTextures_BF() : End : EndIf
  Until Not win_event
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableXP
; DisableDebugger