﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Load a image with mask as sprite
;   This works not with sprites or pictures without mask
;   For some other pictures it is available you must change the color distance for the sprite mask

EnableExplicit

Define window_ID, win_event, image_ID, texture_ID, background_ID
Define image_x, image_y, image_width, image_height, point
Define path$, path_1$

#SoilWall="./Image_Set/soil_wall.jpg"

; Presets
image_width=600 : image_height=475

path_1$=OpenFileRequester("Select a sprite", "", "", 0)
If path_1$="" : End : EndIf

image_ID=LoadImage(#PB_Any, #SoilWall)

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

; - Call function #1 -
path$=#SoilWall
texture_ID=LoadImage(#PB_Any, path$)
ErrorCheck_BF(BF(-2, background_ID, texture_ID))

Define mode=1                ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
Define image_get_color_x=0   ; Grab transparence color from sprite pos x  
Define image_get_color_y=0   ; Grab transparence color from sprite pos y 
Define output_pos_x          ; Grab transparence color from sprite pos x  
Define output_pos_y          ; Grab transparence color from sprite pos y   
Define output_width          ; Output width  - For original output width set width = 0
Define output_height         ; Output height - For original output height set height = 0
Define alpha=1               ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
Define texture_width=0       ; Endposition texture output       - Preset 0 = Clipping is automatic To image width 
Define texture_height=0      ; Endposition texture output       - Preset 0 = Clipping is automatic To image height 
Define texture_clip_x=0      ; Startposition inside the texture - Preset 0
Define texture_clip_y=0      ; Startposition inside the texture - Preset 0
Define texture_clip_width=0  ; Endposition inside the texture   - Preset 0 = full texture width
Define texture_clip_height=0 ; Endposition inside the texture   - Preset 0 = full texture height

output_width=ImageWidth(texture_ID)/2
output_height=ImageHeight(texture_ID)/2
output_pos_x=image_width/2-output_width/2
output_pos_y=image_height/2-output_height/2

SetColorDistanceSpriteMask_BF(25) ; percent

; SetInvisibleColor_BF($FF00FF) ; Set the invisible color - Use this with care for sprites without a invisible color, or you can get "holes" in your output frames
; This use a QUAD, deactivate again with SetInvisibleColor_BF(-1) - For white set $FFFFFF - This is a globale function
; This deactivate "Grab transparence color from the frame pos" x, y
; -2 deactivate the invisible color
; - Call function #2 -
texture_ID=LoadImage(#PB_Any, path_1$) ; Sprite mode

; ActivateAlphaChannel_BF(1) ; You can use this function for output images with alpha channel as sprites - Also GIF frames

ErrorCheck_BF(SpriteSimple_BF(mode, background_ID, texture_ID, ; Function for simple using any images as sprites 
                              image_get_color_x,               ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                              image_get_color_y,               ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF      
                              output_pos_x,                    ; Output pos x
                              output_pos_y,                    ; Output pos y
                              output_width,                    ; You can here resize the output x
                              output_height,                   ; You can here resize the output y
                              alpha,                           ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
                              texture_width,                   ; Endposition texture output       - Preset 0 = Clipping is automatic to image width 
                              texture_height,                  ; Endposition texture output       - Preset 0 = Clipping is automatic to image height 
                              texture_clip_x,                  ; Startposition inside the texture - Preset 0
                              texture_clip_y,                  ; Startposition inside the texture - Preset 0
                              texture_clip_width,              ; Endposition inside the texture   - Preset 0 = full texture width
                              texture_clip_height))            ; Endposition inside the texture   - Preset 0 = full texture height
                                                               ; You use clipping, "image_get_color.." get the invisible color from the clipped texture
                                                               ; Mode 0 deactivate the invisible color- mode 1 activate the invisible color
                                                               ; For using pictures with alpha channel use mode=2
                                                               ; For using JPG based masked sprites, pre use SetColorDistanceSpriteMask_BF(percent) 
                                                               ; Resizing can change the colors a little,
                                                               ; so it is available a presetted invisible color works after resizing not longer correct

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0)
StopDrawing() 

Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    End
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 4
; EnableXP