﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Load a image with alpha channel as sprite - Also GIF supported
;   This works not with sprites or pictures with mask

EnableExplicit

Define window_ID, win_event, image_ID, texture_ID, background_ID, result
Define image_x, image_y, image_width, image_height, point
Define path$, path_1$

#SoilWall="./Image_Set/soil_wall.jpg"

; Presets
image_width=600 : image_height=475

path_1$=OpenFileRequester("Select a picture with alpha channel", "", "", 0)
If path_1$="" : End : EndIf

image_ID=LoadImage(#PB_Any, #SoilWall)

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

; - Call function #1 -
path$=#SoilWall
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, background_ID, texture_ID)
ErrorCheck_BF(result)

; - Call function #2 -
texture_ID=LoadImage(#PB_Any, path_1$) ; Sprite mode
ResizeImage(texture_ID, image_width/2, image_height/2)

result=AlphaChannelSprite_BF(background_ID, texture_ID, ; Function for using any images with alpha channel as sprites
                             image_width/2-ImageWidth(texture_ID)/2, ; Use this function only for pictures with alpha channel, or you see nothing
                             image_height/2-ImageHeight(texture_ID)/2)
; texture_width,
; texture_height,
; texture_clip_x,
; texture_clip_y,
; texture_clip_width,
; texture_clip_height)

ErrorCheck_BF(result)

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0)
StopDrawing() 

Repeat
    win_event=WaitWindowEvent()
    If win_event=#PB_Event_CloseWindow
      FreeTextures_BF() ; Free grabed textures
      End
    EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 3
; EnableXP
; DisableDebugger