﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - Create gradient color sprites
;   This works primary not with sprites or pictures without mask
;   But you can use it for coloring any images with gradient colors - For this deactivate color distance and the invisible color
;   For some other pictures it is available you must change the color distance for the sprite mask

EnableExplicit

NoCaching_BF(1)

Define window_ID, win_event, image_ID, texture_ID, texture_1_ID, background_ID, canvas_ID, result
Define image_x, image_y, image_width, image_height, point, x, y
Define path$, path_1$

#SoilWall="./Image_Set/soil_wall.jpg"

; Presets
image_width=600 : image_height=475

path_1$=OpenFileRequester("Select a sprite", "", "", 0)
If path_1$="" : End : EndIf

image_ID=LoadImage(#PB_Any, #SoilWall)

background_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

; - Call function #1 -
path$=#SoilWall
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, background_ID, texture_ID)
ErrorCheck_BF(result)
FreeImage(texture_ID)

SetColorDistanceSpriteMask_BF(25) ; percent - You can change or deactivate

texture_ID=LoadImage(#PB_Any, path_1$) ; Sprite mode
ResizeImage(texture_ID, image_width/2, image_height/2)

; This functions works equal the PB function
; activate_...<>0 activate a function - For the other parameters looking in the PB guidance
; You must deactivate again
; FrontColor_BF(1, $FF)
; BackColor_BF(1, $FFFF) 
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FF0000)
GradientColor_Array_BF(1, 2, 0.3, $FF00)
GradientColor_Array_BF(1, 3, 0.5, $FFFF)
GradientColor_Array_BF(1, 4, 0.7, $FF)
GradientColor_Array_BF(1, 5, 0.9, $FF0000)

LinearGradient_BF(1, 0, 0, ImageWidth(texture_ID), ImageHeight(texture_ID))

GradientColor_Alpha_BF(120) ; Gradient color intensity 0 > 255
GradientColor_Contrast_BF(50) ; Enhance the contrast - This influence the output speed

texture_1_ID=CreateSpriteGradientColor_BF(texture_ID, 0, 0)

DeactivateGradientColors_BF() ; This deactivate all gradient color functions after using
                              ; Deactivate you not the functions, it can influence other outputs

; ActivateAlphaChannel_BF(1) ; Activate the alpha channel - Mostly you need this not
; Only for handling sources with alpha channel (PNG) or GIF
; You must deactivate again <>0 = activated

result=BF(1, background_ID, texture_1_ID,
          0, ; For deactivating the invisible color set this parameter to -1                                  
          0,                                 
          image_width/2-image_width/4,                           
          image_height/2-image_height/4,                             
          image_width/2,                           
          image_height/2)
ErrorCheck_BF(result)

canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0)
StopDrawing()

Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    End
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 6
; EnableXP
; DisableDebugger