﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - PB sprite enhancing - High quality sprite output using lossly compressed images or with interpolation resized images

; Looking in the code for the needed settings

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

EnableExplicit

Define window_ID, texture_ID, background_ID

Define path_0$="./Image_Set/Space.jpg"
Define texture_ID=LoadImage(#PB_Any, "./Image_Set/soil_wall.jpg")

; ------------------------------------------------------------------------------

window_ID=OpenWindow(#PB_Any, 0, 0,
                     900, 540, "GFX_Wizzard_BF - Windowed Screen output demo",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, 900, 540) : End : EndIf ; Create a windowed screen for output

Define sprite_1_ID=LoadSprite(#PB_Any, path_0$)
Define sprite_2_ID=CopySprite(sprite_1_ID, #PB_Any)

ZoomSprite(sprite_1_ID, 400, 400) ; ZoomSprite change not the physically sprite size, only the output size
ZoomSprite(sprite_2_ID, 400, 400) ; But, SpriteWidth, SpriteHeight, give back the changed size
                                  ; OutputWidth, OutputHeight give back the unchanged physically sprite size
                                  ; This looks a little strange - BF handle this internal automatic

CleanMask_BF(sprite_2_ID, 0, 0, 45)
; ReplaceColor_BF(sprite_2_ID, $A9A9A9, 35) ; This function works at the same CleanMask_BF, but the function can change also the mask color


background_ID=CreateSprite(#PB_Any, 900, 540)

; - Call function #1 -
ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a background

#text$="This is a lossly compressed JPG Image"+#LF$+"Output as PB Sprite directly on a windowed Screen"+#LF$+
       "Left the original PB Output - Right the GFX_Wizzard_BF (BF) enhanced Output"
Define output_x_pos=DrawTextScreenOutput_BF(200, 460, #text$, $FFFFFF, 0, 1, 3)>>1

SpriteQuality(#PB_Sprite_BilinearFiltering)

While WaitWindowEvent()<>#PB_Event_CloseWindow
  FlipBuffers()
  ClearScreen(RGB(0, 0, 0))
  DisplaySprite(background_ID, 0, 0)
  TransparentSpriteColor(sprite_1_ID, Get_PB_SpriteColor_BF(sprite_1_ID, 0, 0))
  DisplayTransparentSprite(sprite_1_ID, 40, 20)
  TransparentSpriteColor(sprite_2_ID, Get_PB_SpriteColor_BF(sprite_2_ID, 0, 0))
  DisplayTransparentSprite(sprite_2_ID, 460, 20)
  DrawTextScreenOutput_BF(450-output_x_pos, 460, #text$, $FFFFFF, 0, 1)
Wend 

; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 7
; Folding = -
; EnableXP
; Executable = ..\test.exe
; DisableDebugger