﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Demo - TextGadget_BF() & Text image creating with CreateFittedTextImage_BF()
; Automatic text size
; Automatic text adjustment
; Stepless text adjustment
; High text quality outputs - Works with and without DPI aware
; Outputs all fonts with edge smoothing
; Can handle GradientColor_BF
; font_ID you must not set
; Use ever a large font size - Then the function adjust the needed font size automatically (about 60 for the mostly large buttons)
; flag : Text center=1 - Text right=2 - Text vertical=3
; mode : Revers text mode=1 - RTL text mode=2
; stretch = Headline text stretcheng function
; TextGadget_BF(text$,
;               x,
;               y,
;               button_width,
;               button_height,
;               text_color=0,
;               background_color=$F0F0F0,
;               font_ID=-1,
;               stretch_x=0,
;               stretch_y=0,
;               flag=0,
;               mode=0,
;               canvas_flag=0)

; Change the TextGadget_BF
; The function can handle GradientColor_BF
; You must not set position, size, stretch, font, but you can
; Use ever a large font size - Then the function adjust the needed font size automatically (about 60 for the mostly large buttons)
; stretch = Headline text stretcheng function
; SetTextGadget_BF(gadget_ID,
;                  text$,
;                  text_color,
;                  background_color,
;                  x=-1,
;                  y=-1,
;                  button_width=-1,
;                  button_height=-1,
;                  stretch_x=-1,
;                  stretch_y=-1,
;                  font_ID=-1)

; FreeGadget_BF(gadget_ID) ; This function free a Gadget_BF

EnableExplicit

Activate_DPI_aware_BF(1) ; Activate the Wizzard DPI aware enhancement

Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore , 800, 490, "GFX_Wizzard_BF",
                            #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

HideWindow(window_ID, 1)

; ManualPadding_DrawTextCreateImage_X_BF(30) ; You can also preset global a manual padding for DrawTextCreateImage_BF
; ManualPadding_DrawTextCreateImage_Y_BF(30) ; Presetted default padding is TextWidth(Space(3))

; Use ever a large font for the buttons
; Then the function adjust the needed font size automatically (about 60 For the mostly large buttons)
Define font_ID=LoadFont(#PB_Any, "Arial", 60, #PB_Font_Bold) ; Smaller is faster - Look for the max needed size to your outputs
                                                              ; You can also activate upscaling fonts, similar Windows OS do this
                                                              ; This is very fast, but on large font output not so clear

; Add to the FitImage functions a automatically upscaling for little images - 1=activated - 0=deactivated
; -You must deactivate again
; -As sample also for ColorButtonGadget_BF, TextGadget_BF, ImageGadget_BF, ButtonImageGadget_BF
FitImageActivateUpscaling_BF(1) ; This will automatically enlarge fonts that are too small, it's very fast 

; ==================== Button 1 =====================
Define button_width=400
Define button_height=120
Define text_color=#White
Define background_color=#Blue
Define text_1$="TextGadget_BF &"+#LF$+"CreateFittedTextImage_BF"+#LF$+"Create very nice Text Outputs"+#LF$+"GFX_Wizzard_BF - Simple a little more"
Define text_2$="Works with all OS and subsystems"+#LF$+
               "No more font sizes for different button sizes needed"+#LF$+
               "Texts are automatically adapted to the button size"+#LF$+
               "The text is centered and displayed in several lines"+#LF$+
               "Any text is automatically fitted into any TextGadget_BF"+#LF$+
               "Text and background color selectable"+#LF$+
               "GradientColor support"+#LF$+
               "Works with any available fonts"+#LF$+
               "Linux gtk2 centered multiline button text supported"+#LF$+
               "Output all texts with edge smoothing"
Define stretch_x=5 ; Text stretching
Define stretch_y=5
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define canvas_flag=#PB_Canvas_Border

Define gadget_1_ID=TextGadget_BF(text_2$,
                                 WindowWidth(window_ID)/2-button_width/2,
                                 10,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag)

; ==================== Button 2 ====================
Define button_width=420
Define button_height=200
Define text_color=#White
Define background_color=#Red
Define stretch_x=5 ; Text stretching
Define stretch_y=5
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4

Define gadget_2_ID=TextGadget_BF(text_1$,
                                 WindowWidth(window_ID)/2-button_width/2,
                                 140,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag)

; ================ Button 3 ========================
Define button_width=250
Define button_height=60
Define text_color=#Blue
Define background_color=#Yellow
Define text$="This are all fully automatic created"+#LF$+"TextGadet_BF"
Define gadget_3_ID=TextGadget_BF(text$,
                                 WindowWidth(window_ID)/2-button_width/2,
                                 350,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag)
; FreeGadget_BF(gadget_3_ID) ; This function free a Gadget_BF

; ==================== Button 4 - RAW ==============
Define button_width=230
Define button_height=60
Define text_color=#Blue
Define background_color=#Green
Define text$="It's magic"+#LF$+"All OS"
Define stretch_x=60 ; Text stretching
Define stretch_y=5
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4

Define image_1_ID=CreateFittedTextImage_BF(text$,
                                           button_width*DPI_ResizeFactor_BF(),
                                           button_height*DPI_ResizeFactor_BF(),
                                           text_color,
                                           background_color,
                                           font_ID,
                                           stretch_x,
                                           stretch_y,
                                           flag,
                                           mode)

Define canvas_1_ID=CanvasGadget(#PB_Any, WindowWidth(window_ID)/2-button_width/2, 420, button_width, button_height)
StartDrawing(CanvasOutput(canvas_1_ID))
DrawingMode(#PB_2DDrawing_Outlined)
CompilerIf#PB_Compiler_OS=#PB_OS_MacOS 
  DrawImage(ImageID(image_1_ID), 2, 2)
  Box(1, 1, button_width-1, button_height-1, #Blue)
  Box(2, 2, button_width-3, button_height-3, #Blue)
CompilerElse
  DrawImage(ImageID(image_1_ID), 0, 0)
  Box(0, 0, (button_width-1)*DPI_ResizeFactor_BF(), (button_height-1)*DPI_ResizeFactor_BF(), #Blue)
  Box(DPI_ResizeFactor_BF(), DPI_ResizeFactor_BF(), (button_width-1)*DPI_ResizeFactor_BF(), (button_height-1)*DPI_ResizeFactor_BF(), #Blue)
CompilerEndIf
StopDrawing()

; ==================== Button 5 ====================
Define button_width=80
Define button_height=40
Define text_color=#White
Define background_color=$2F6B55
Define text$="Hi"
Define canvas_flag=0
Define gadget_4_ID=TextGadget_BF(text$,
                                 WindowWidth(window_ID)-button_width-20,
                                 WindowHeight(window_ID)-button_height-10,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag)

; ============= Button 6 - vertical ===============
Define button_width=60
Define button_height=400
Define text_color=#White
Define background_color=$645345
Define text$="Vertical Text available"
Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=3 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_5_ID=TextGadget_BF(text$,
                                 WindowWidth(window_ID)-button_width-20,
                                 10,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag)

; ================== Button 7 =====================
Define button_width=40
Define button_height=330
Define text_color=#Red
Define background_color=#Green
Define text$="Vertical Text available"
Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=3 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=2 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_6_ID=TextGadget_BF(text$,
                                 WindowWidth(window_ID)-150,
                                 10,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag)

; ================== Button 8 =====================
Define button_width=230
Define button_height=100
Define text_color=#White
Define background_color=$365456
Define text$="Simplest use the enhanced TextGadgets_BF"+#LF$+
             "Centered, right and vertical Text"+#LF$+
             "Revers and RTL Text"+#LF$+
             "Fully automatically Text adjustment"+#LF$+
             "Or incredible Text output as sprite on canvas"

Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_7_ID=TextGadget_BF(text$,
                                 10,
                                 WindowHeight(window_ID)-button_height-10,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag)

; ================== Button 9 =====================
Define button_width=170
Define button_height=100
Define text_color=#White
Define background_color=$464375
Define text$="Headline"+#LF$+
             "centered right, Vertical,"+#LF$+
             "Revers and RTL Text"

Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=2 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=2 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_8_ID=TextGadget_BF(text$,
                                 10,
                                 10,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag)

; ================== Button 10 ====================
Define button_width=160
Define button_height=80
Define text_color=#White
Define background_color=$267834
Define text$="Headline"+#LF$+
             "Centered, right, vertical,"+#LF$+
             "Revers and RTL Text"

Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=0 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_9_ID=TextGadget_BF(text$,
                                 10,
                                 150,
                                 button_width,
                                 button_height,
                                 text_color,
                                 background_color,
                                 font_ID,
                                 stretch_x,
                                 stretch_y,
                                 flag,
                                 mode,
                                 canvas_flag)

; ================== Button 11 ====================
Define button_width=120
Define button_height=70
Define text_color=#White
Define background_color=$135467
Define text$="BF is cool"

Define stretch_x=5 ; Text stretching
Define stretch_y=0
Define flag=0 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_10_ID=TextGadget_BF(text$,
                                  550,
                                  380,
                                  button_width,
                                  button_height,
                                  text_color,
                                  background_color,
                                  font_ID,
                                  stretch_x,
                                  stretch_y,
                                  flag,
                                  mode,
                                  canvas_flag)

; ================== Button 12 ====================
Define button_width=120
Define button_height=80
Define text_color=#White
Define background_color=0
Define text$="Envy"+#LF$+"is the higgest"+#LF$+"form of recognition"+#LF$+":-)"

Define stretch_x=5 ; Text stretching
Define stretch_y=0
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define gadget_11_ID=TextGadget_BF(text$,
                                  30,
                                  270,
                                  button_width,
                                  button_height,
                                  text_color,
                                  background_color,
                                  font_ID,
                                  stretch_x,
                                  stretch_y,
                                  flag,
                                  mode,
                                  canvas_flag)

; =============== Get the result ===================

HideWindow(window_ID, 0)

AddWindowTimer(window_ID, 0, 2000)
Repeat
  Define win_event=WaitWindowEvent()
  If win_event=#PB_Event_Timer
    Break
  EndIf
ForEver

Define font_1_ID=LoadFont(#PB_Any, "Arial", 60, #PB_Font_Bold | #PB_Font_Italic)

; The function can handle GradientColor_BF
; BF create internal text outputs for TextGadget_BF and ColorButtonGadget_BF with automatic downsizing / upsizing and interpolation
; So you set for manipulating the text output the for this gadget presetted fontsize 
Define text_width=GetTextWidth_BF(text_1$,
                                  font_ID, ; The presetted max font size for this gadget
                                  0,       ; vertical
                                  0,       ; stretch_x=0,
                                  0)       ; padding_x=0
Define text_height=GetTextHeight_BF(text_1$,
                                    font_ID, ; The presetted max font size for this gadget
                                    0,       ; vertical
                                    0,       ; stretch_x=0,
                                    0)       ; padding_x=0 

; Raw sample
; Define text_width=DrawTextCreateImage_BF(text_1$, 0, 0, 1, 3, font_ID, 0, 0, -1) ; Get the real text size from the used font
; Define text_height=DrawTextCreateImage_BF(text_1$, 0, 0, 1, 4, font_ID, 0, 0, -1)

BackColor_BF(1, $00FF7F)
GradientColor_Array_BF(1, 1, 0.3, $FFFF)
GradientColor_Array_BF(1, 2, 0.8, $00FF7F)
LinearGradient_BF(1, 0, 0, text_width*1.6, text_height*1)
background_color=#Black
; Simple you can change the TextGadget_BF - You must only set used parameters
; SetTextGadget_BF(gadget_ID, text$, text_color, background_color, x, y, button_width, button_height, stretch_x, stretch_y, font_ID)
; Ignored parameters you can set To -1
SetTextGadget_BF(gadget_1_ID, text_1$, text_color, background_color, -1, -1, -1, -1, -1, -1, font_1_ID)

DeactivateGradientColors_BF()

background_color=#Blue
SetTextGadget_BF(gadget_2_ID, text_2$, text_color, background_color)

Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    Break
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 61
; FirstLine = 48
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger