﻿; StretchTextGadget_BF - A part from GFX_Wizzard_BF - (c)
; A new advanced Generation Gadget
; ButtonImageGadget and CanvasGadget based, multicolor and multiline text buttons with text zoom function and many more
; You must not load fonts, but all fonts and fontsizes automatically available, any text is pasted in

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Define button_width=400, button_height=100

Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 400, "Advanced StretchTextGadget_BF", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)

Define x_pos=WindowWidth(window_ID)/2-button_width/2, y_pos=WindowHeight(window_ID)/2.4-button_height/2

; This function deactivate the automatically text stretching for vector text based Gadgets_BF,
; - as sample ToggleGadget_BF, StretchTextGadget_BF, MagicTextGadget_BF, MessageRequester_Magic_BF
; This is a mighty feature - you must activate again text stretching
; With an unsymmetrical padding the stretching becomes active on MagicText, positive values reduce the output, negative values increase it
Deactivate_TextStretching_BF(1) ; Deactivate text stretching

; Output gadget_1
SetTextFlagsStretchTextGadget_BF(#PB_VectorParagraph_Left)
Define text_gadget_1$="This is a ImageGadget based"+#LF$+"StretchTextGadget_BF"+#LF$+#LF$+"Automatic TextStretching OFF"
Define gadget_1_ID=StretchTextGadget_BF(text_gadget_1$,
                                        x_pos-145-Get_gtk3_button_x_offset_BF(),
                                        y_pos-50,
                                        button_width-105,
                                        button_height-25,
                                        15*DPI_ResizeFactor_BF(), ; padding_x
                                        15*DPI_ResizeFactor_BF(), ; padding_y
                                        #Blue,                    ; text_color - Alpha channel supported
                                        #Green,                   ; back_color
                                        "Times New Roman",
                                        #PB_Font_Bold)

; Output gadget_2
Deactivate_TextStretching_BF(0) ; Activate text stretching
SetTextFlagsStretchTextGadget_BF(#PB_VectorParagraph_Left)
Define text_gadget_2$="This is a ImageGadget based"+#LF$+"StretchTextGadget_BF"+#LF$+#LF$+"Automatic TextStretching ON"
Define gadget_2_ID=StretchTextGadget_BF(text_gadget_2$,
                                        x_pos+250,
                                        y_pos-50,
                                        button_width-105,
                                        button_height-25,
                                        15*DPI_ResizeFactor_BF(), ; padding_x
                                        15*DPI_ResizeFactor_BF(), ; padding_y
                                        #Blue,                    ; text_color - Alpha channel supported
                                        #Green,                   ; back_color
                                        "Times New Roman",
                                        #PB_Font_Bold)
Deactivate_TextStretching_BF(1) ; Deactivate text stretching

Define text_gadget_3$="Hello World"+#LF$+"This is a ImageGadget based"+#LF$+"StretchTextGadget_BF"
Define gadget_3_ID=StretchTextGadget_BF(text_gadget_3$,
                                        x_pos-40-Get_gtk3_button_x_offset_BF(),
                                        y_pos+100,
                                        button_width+80,
                                        button_height,
                                        35*DPI_ResizeFactor_BF(),  ; padding_x
                                        115*DPI_ResizeFactor_BF(), ; padding_y
                                        #Blue,                     ; text_color - Alpha channel supported
                                        #Yellow,                   ; back_color
                                        "Times New Roman",
                                        #PB_Font_Bold)

; Function similar #PB_Ignore available - set simple -1
Macro animate_gadget_3
  Define i
  ; This function deactivate the automatically text stretching for vector text based Gadgets_BF, as sample ToggleGadget_BF and StretchTextGadget_BF
  ; This is a mighty feature - you must activate again text stretching
  Deactivate_TextStretching_BF(1) ; Deactivate text stretching
  For i=80 To 0 Step -1
    FitImage_Offset_BF(i*2, i)
    SetStretchTextGadget_BF(gadget_3_ID,                ; Gadget_ID
                            "",                         ; Text
                            -1,                         ; Gadget output x pos
                            -1,                         ; Gadget output x pos
                            -1,                         ; Gadget width
                            -1,                         ; Gadget height
                            -1,                         ; padding_x
                            35+i*DPI_ResizeFactor_BF(), ; padding_y
                            -1,                         ; text_color
                            -1)                         ; back_color
    Delay(3)
    While WindowEvent() : Wend
  Next
  FitImage_Offset_BF(0, 0)
EndMacro

animate_gadget_3

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
; IDE Options = PureBasic 5.71 LTS (Linux - x64)
; CursorPosition = 55
; FirstLine = 39
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger