﻿
; Base Demo DrawText_BF - DPI aware

EnableExplicit

XIncludeFile("./GFX_Wizzard_BF.pbi")

Define result, move, win_h, font_ID, window_ID, canvas_ID

CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : result=14 : win_h=780 : CompilerElse : result=11 : win_h=700 : CompilerEndIf
font_ID=LoadFont(#PB_Any, "Arial", result)
window_ID=OpenWindow(#PB_Any, 0, 0, 1220, win_h, "GFX_Wizzard_BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
SetWindowColor(window_ID, $FF00)
canvas_ID=CanvasGadget(#PB_Any, 5, 5 , WindowWidth(window_ID)-10, WindowHeight(window_ID)-10)

Define txt$="This is DrawText_BF"+#LF$+#LF$+"Maked from the Author of GFX_Wizzard_BF"+#LF$+#LF$+
     "Author : Werner Albus"+#LF$+"www.nachtoptik.de"+#LF$+#LF$+"Have Fun"

Define txt1$="Hey, cool, with vertical Text"

; This are special functions for text output, directly, as image, or as sprite - The functions works equal the PB function ------
; activate_...<>0 activate a function - For the other parameters looking in the PB guidance
BackColor_BF(1, $FF) 

; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.3, $FF0000)
GradientColor_Array_BF(1, 2, 0.5, $FF00)
GradientColor_Array_BF(1, 3, 0.8, $FF)

LinearGradient_BF(1, 150*DPI_ResizeFactor_BF(), 0, 500*DPI_ResizeFactor_BF(), 0)

StartDrawing(CanvasOutput(canvas_ID)) : DrawingFont(FontID(font_ID))
DrawText_BF(30*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), txt1$, #Red, #White, 3, 0)
DrawText_BF(70*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), txt1$, #Black, #White, 3, 2)
DrawText_BF(110*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), txt1$, #Black, #White, 3, 1)

result=DrawText_BF(150*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), txt$, #Black, #White, 1)
result/DPI_ResizeFactor_BF()
result=DrawText_BF(150*DPI_ResizeFactor_BF(), (result+40)*DPI_ResizeFactor_BF(), txt$, #Black, #White, 2)
result/DPI_ResizeFactor_BF()
DrawText_BF(150*DPI_ResizeFactor_BF(), (result+40)*DPI_ResizeFactor_BF(), txt$, #Black, #White, 1)
StopDrawing()

LinearGradient_BF(0)
StartDrawing(CanvasOutput(canvas_ID)) : DrawingFont(FontID(font_ID))

result=DrawText_BF(490*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), txt$, #Black, #White, 0, 1)
result/DPI_ResizeFactor_BF()
result=DrawText_BF(490*DPI_ResizeFactor_BF(), (result+40)*DPI_ResizeFactor_BF(), txt$, #Black, #White, 2, 1)
result/DPI_ResizeFactor_BF()
DrawText_BF(490*DPI_ResizeFactor_BF(), (result+40)*DPI_ResizeFactor_BF(), txt$, #Black, #White, 1, 1) 

result=DrawText_BF(830*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), txt$, #Black, #White, 0, 2)
result/DPI_ResizeFactor_BF()
result=DrawText_BF(830*DPI_ResizeFactor_BF(), (result+40)*DPI_ResizeFactor_BF(), txt$, #Black, #White, 2, 2)
result/DPI_ResizeFactor_BF()
DrawText_BF(830*DPI_ResizeFactor_BF(), (result+40)*DPI_ResizeFactor_BF(), txt$, #Black, #White, 1, 2)

DrawText_BF(1170*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), "Stretching available", #Red, #White, 3, 0, 0, 8)
StopDrawing()

; PresetLineWidth_BF(300) ; This preset the min output length, try simple how it works

Define txt2$="A very nice Tool"+#LF$+"DrawText_BF"+#LF$+"Simple a little more"

StartDrawing(CanvasOutput(canvas_ID))
DrawingFont(FontID(font_ID))
DrawingMode(#PB_2DDrawing_Transparent)
DrawText_BF(470*DPI_ResizeFactor_BF(), (win_h-135)*DPI_ResizeFactor_BF(), txt2$, #Black, #White, 1, 0, 10*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF())
StopDrawing()

txt2$="This is a output as image"+#LF$+"For nice resizing"+#LF$+"Using as sprite"+#LF$+
      "Or many other things"+#LF$+"BucketFill advanced handle images"+#LF$+
      "as sprites with phantastic abilities"

; This are special functions for text output, directly, as image, or as sprite ------
; activate_...<>0 activate a function - For the other parameters looking in the PB guidance
; You must deactivate again

GradientColor_Array_BF(0, 1, 0.3, $FF0000)

LinearGradient_BF(1, 0, 0, 400*DPI_ResizeFactor_BF(), 0)

GradientColor_contrast_BF(50)

Define image_ID=DrawTextCreateImage_BF(txt2$, #White, $C0C0C0, 1, 0, font_ID, 2, 2, -1)

If IsImage(image_ID)
  StartDrawing(CanvasOutput(canvas_ID))
  DrawImage(ImageID(image_ID), 30*DPI_ResizeFactor_BF(), (win_h-160)*DPI_ResizeFactor_BF())
  DrawImage(ImageID(image_ID), 910*DPI_ResizeFactor_BF(), (win_h-150)*DPI_ResizeFactor_BF(), 200*DPI_ResizeFactor_BF(), 95*DPI_ResizeFactor_BF())
  StopDrawing()
EndIf

ActivateLineGoBackcolor_BF(1, $FFFFFF)

While WaitWindowEvent(1)<>#PB_Event_CloseWindow
  If Delay_BF(1, 40) 
    StartDrawing(CanvasOutput(canvas_ID))
    DrawingFont(FontID(font_ID))
    BoxGo_8_BF(144*DPI_ResizeFactor_BF(), 5*DPI_ResizeFactor_BF(), DrawText_BF(0, 0, txt$, 0, 0, 0, 3)+25, DrawText_BF(0, 0, txt$, 0, 0, 0, 4)+10, $FF0000, move, %0001111)
    move=(move+1)%8
    StopDrawing()
  EndIf
Wend

; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 100
; FirstLine = 73
; Folding = -
; EnableXP
; DPIAware