﻿; Demo - Draw text with DrawText_BF directly output on a screen - Stretched

XIncludeFile("./GFX_Wizzard_BF.pbi")

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

ExamineDesktops()

InitSprite()

EnableExplicit

LoadFont(1, "Arial", 24, #PB_Font_Bold)

#text$=#LF$+"Hello"+#LF$+
       "  This text is created with DrawText_BF  "+#LF$+
       "BF - simple a little more"+#LF$+
       "Stretched"+#LF$

Define width, height

Define texture_ID=LoadImage(#PB_Any, "./Image_Set/Background.bmp")

Define window_ID=OpenWindow(#PB_Any, 1, 1, 1, 1, "Draw Text directly on a screen", #PB_Window_SystemMenu)

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, 1, 1)

Define width=DrawTextCreateImage_BF(#text$, 0, 0, 0, 3, 1, 10, 10, 10)  ; Calculate the needed width

Define height=DrawTextCreateImage_BF(#text$, 0, 0, 0, 4, 1, 10, 10, 10) ; Calculate the needed height

ResizeGadget(canvas_ID, 0, 0, width, height)

ResizeWindow(window_ID, DesktopWidth_UserScaled_BF()/2-width/2, DesktopHeight_UserScaled_BF()/2-height/2, width, height)

ErrorCheck_BF(BF(-2, canvas_ID, texture_ID)) ; Make a background texture

Define image_ID=DrawTextCreateImage_BF(#text$, #White, #Red, 1, 0, 1, 10, 10, 10)

StartDrawing(CanvasOutput(canvas_ID))
DrawImage(ImageID(texture_ID), 0, 0)
StopDrawing()

TextureBrush_canvas_BF(2, canvas_ID, image_ID, ; For canvas
                       25,                     ; Output pos x
                       25,                     ; Output pos y
                       width-50,               ; Texture or image width
                       height-50,              ; Texture or image height
                       40,                     ; Percent visibility
                       50)                     ; Delay for animation      

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
FreeTextures_BF() ; Free grabed textures
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 46
; FirstLine = 18
; Folding = -
; EnableXP
; DisableDebugger