﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Define output_width=600
Define output_height=400

Define window_ID=OpenWindow(#PB_Any, 0, 0, output_width+20, output_height+20, "Fitted text demo", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)

Define canvas_ID=CanvasGadget(#PB_Any, 10, 10, output_width, output_height, #PB_Canvas_Border)
SetGadgetColor(canvas_ID, #PB_Gadget_BackColor, #Yellow)

Define image_ID=CreateImage(#PB_Any, output_width, output_height, 24, 0)

Global Font_1_ID=LoadFont(#PB_Any, "Georgia", 20, #PB_Font_Bold)

Define text_1$="A GFX_Wizzard_BF function"+#LF$+#LF$+
               "Fitted_DrawText_Vector_BF"+#LF$+
               "Incredible"+#LF$+
               "Headline mode"+#LF$+
               "Stepless free scaled"+#LF$+
               "stretchable & proportional"
Define x_pos=0
Define y_pos=0
Define text_color=#Black
Define text_stretching_x=8
Define text_stretching_y=5
Define padding_factor_x.d=15
Define padding_factor_y.d=25
Define flag=1 ; Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
Define output_offset_factor_x.d=1 ; Needed for proportional output - Default=1 = 100%
Define output_offset_factor_y.d=1 ; Needed for proportional output - Default=1 = 100%

Activate_DPI_aware_BF(1) ; Gadgets_BF supports the DPI aware PB compiler option

If StartVectorDrawing(CanvasVectorOutput(Canvas_ID))
  
  VectorFont(FontID(Font_1_ID))  
  
  ; StartVectorDrawing needed
  Fitted_DrawText_Vector_BF(text_1$,                  ; Text - Multiline supported
                            x_pos,                    ; Output x pos
                            y_pos,                    ; Output y pos
                            output_width,             ; Output width
                            output_height,            ; output height
                            text_color,               ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel 
                            text_stretching_x,        ; Text stretching x - Headline mode
                            text_stretching_y,        ; Text stretching y - Headline mode
                            padding_factor_x.d,       ; Padding x - This is a virtuell padding for resizing and boxed output
                            padding_factor_y.d,       ; Padding y - This is a virtuell padding for resizing and boxed output
                            flag,                     ; Text center=1 - Text right=2 - Text vertical=3
                            mode,                     ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                            output_offset_factor_x.d, ; This is the resizing factor for proportional dynamic GUI output - Look the Dynamic GUI demo codes for set_x
                            output_offset_factor_y.d) ; This is the resizing factor for proportional dynamic GUI output - Look the Dynamic GUI demo codes for set_y
  
  StopVectorDrawing()
  
EndIf

; Demonstrate outline calculation
GrabSpriteOffsets_BF(Canvas_ID, 4, 4, 4, 4) ; 4 = Offsets for canvas border - Crash protection
Define get_x=GetSprite_X_BF()
Define get_y=GetSprite_Y_BF()
Define get_width=GetSprite_width_BF()
Define get_height=GetSprite_height_BF()
Define i
If StartDrawing(CanvasOutput(Canvas_ID))
  DrawingMode(#PB_2DDrawing_Outlined)
  For i=0 To DPI_ResizeFactor_BF()*2
    Box(get_x-5*DPI_ResizeFactor_BF()-i,
        get_y-5*DPI_ResizeFactor_BF()-i,
        (get_width)+10*DPI_ResizeFactor_BF()+i*2,
        (get_height)+10*DPI_ResizeFactor_BF()+i*2,
        $FF)
  Next
  StopDrawing()
EndIf

Repeat
Until WaitWindowEvent()=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 16
; EnableXP
; DPIAware