﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
  MessageRequester("Info", "PB5.72 - Direct output not supported on MacOS")
  End
CompilerEndIf

Define window_ID=OpenWindow(#PB_Any, 0, 0, 1000, 650, "DrawVectorParagraph on WindowedScreen", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
OpenWindowedScreen(WindowID(window_ID) ,0 ,0 ,WindowWidth(window_ID)*DPI_ResizeFactor_BF(), WindowHeight(window_ID)*DPI_ResizeFactor_BF())
ClearScreen($FFFFFF)

Define font=LoadFont(#PB_Any, "Times New Roman", #PB_Font_Bold)

Define text$="This is a"+#LF$+
             "DrawVectorParagraph"+#LF$+
             "text output"+#LF$+
             "with gradient colors"+#LF$+
             "DPI aware"+#LF$+
             "On windowed screen"
Define text_color=$FF
Define text_alpha=255
Define x=90*DPI_ResizeFactor_BF()
Define y=10*DPI_ResizeFactor_BF()

CompilerIf #PB_Compiler_OS=#PB_OS_Linux
  Define scale_width.d=7.0
  Define scale_height.d=7.0
CompilerElse
  Define scale_width.d=8.0
  Define scale_height.d=8.0
CompilerEndIf

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($00, $FF, $00, $FF))
GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($00, $00, $FF, $FF))

Repeat
  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event = #PB_Event_CloseWindow
      FreeTextures_BF() ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10) ; Output
    
    ; Activate linear gradient
    LinearGradient_BF(1, 0, 0, 150, 150)
    VectorText_Screen_BF(text$, 70*DPI_ResizeFactor_BF(), 20*DPI_ResizeFactor_BF(), #Blue, 255, font)
    
    LinearGradient_BF(1, 0, 0, 1000, 600)
    VectorText_Screen_BF(text$, x, y, text_color, text_alpha, font, scale_width, scale_height, #PB_VectorParagraph_Center)
    
    FlipBuffers()
    ClearScreen($FFFFFF) 
  EndIf
ForEver
; IDE Options = PureBasic 5.73 beta 3 (Windows - x64)
; CursorPosition = 62
; FirstLine = 27
; Folding = -
; EnableXP
; DPIAware
; Executable = ..\aa.exe