﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - BucketFill demo - simple -

EnableExplicit

Define window_ID, win_event, image_ID, texture_ID, sprite_ID, result
Define i, image_x, image_y, image_width, image_height, point
Define path$

  #GeeBee="./Image_Set/Geebee2.bmp"
  #Clouds="./Image_Set/Clouds.jpg"
  #SoilWall="./Image_Set/soil_wall.jpg"
  #RustySteel="./Image_Set/RustySteel.jpg"
  #Caisse="./Image_Set/Caisse.png"
  #Dirt="./Image_Set/Dirt.jpg"
  #Background="./Image_Set/Background.bmp"
  #Cat_1="./Image_Set/Cat_01.jpg"

; Presets
image_width=600 : image_height=475

image_ID=LoadImage(#PB_Any, #SoilWall)

sprite_ID=CreateImage(#PB_Any, image_width, image_height)

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

OpenWindowedScreen(WindowID(window_ID), 0, 0, image_width, image_height)

sprite_ID=CreateSprite(#PB_Any, image_width, image_height)

StartDrawing(SpriteOutput(sprite_ID))
Box (40, 10, 128 , 400, $CCCC00)
RoundBox (185, 80, 133 , 250 , 20, 20, $AAAAA2)
Box (300, 280, 150 , 150, $AAA3)
Circle(460, 260, 125, $AAAAA4)
StopDrawing()

; Hint - So you can replace global a color on a source with a texture - This line replace the color red with a texture
; SetColor_BF(#Red) : ErrorCheck_BF(BF(-2, 0, texture_ID, -1, -1))

; - Call function #1 -
path$=#SoilWall
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, sprite_ID, texture_ID) ; Full size output, not more settings needed
ErrorCheck_BF(result)


; - Call function #2 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-50, sprite_ID, texture_ID,
          40,
          10)
ErrorCheck_BF(result)

; - Call function #3 -
path$=#GeeBee
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, sprite_ID, texture_ID,
          185,
          100,
          60, ; Startposition texture output x
          80) ; y
ErrorCheck_BF(result)

; - Call function #4 -
path$=#Clouds
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, sprite_ID, texture_ID,
          185, ; Get a color point for replacing with bucket fill x
          100) ; y
ErrorCheck_BF(result)

; - Call function #5 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
result=BF(-2, sprite_ID, texture_ID,
          300, 
          280,
          0, ; All zeros to default
          0,
          0,
          0,
          0,
          0,
          30, ; Reduce texture width
          30) ; Reduce texture height
ErrorCheck_BF(result)

; - Call function #6 -
path$=#Cat_1
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, 300, 260)
result=BF(-2, sprite_ID, texture_ID,
          450,
          250,
          0,
          135) ; Adjust photo
ErrorCheck_BF(result)

Repeat
  
  If Delay_BF(0, 10)
    FlipBuffers() ; Draw PB sprite
    ClearScreen(RGB(0, 0, 0))
    DisplaySprite(sprite_ID, i, 0)
    DisplaySprite(sprite_ID, i-image_width, 0) 
    i=(i+1)%image_width
    
    Repeat
      win_event=WindowEvent()
      If win_event=#PB_Event_CloseWindow
        FreeTextures_BF() ; Free grabed textures
        End
      EndIf
    Until Not win_event
  EndIf
  
ForEver

; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 27
; FirstLine = 21
; EnableXP
; DisableDebugger