﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Demo - ImageGadget_BF - FadeIn > FadeOut

EnableExplicit

; Workaround Linux PB570 window background color
CompilerIf #PB_Compiler_OS=#PB_OS_Linux And Not Subsystem("gtk2") And Not Subsystem("qt")
  Macro SetWindowColor(window_ID, color)
    Window_SetCssBackColor(window_ID, color)
  EndMacro
  ImportC "" ; By Oma
    gtk_css_provider_load_from_data(*css_provider, data_.p-utf8, length, *error.GError)
    gtk_css_provider_new()
    gtk_style_context_add_provider(*context, *provider, priority)
    gtk_widget_get_style_context(*widget.GtkWidget)
  EndImport
  Procedure Window_SetCssBackColor(Window_ID, color)
    #GTK_STYLE_PROVIDER_PRIORITY_USER=800
    Protected color$, *gProvider=gtk_css_provider_new()
    ; Protected color$="#"+RSet(Hex(color), 6, "000000")
    color$="#"+RSet(Hex(Red(color)), 2, "00")+RSet(Hex(Green(color)), 2, "00")+RSet(Hex(Blue(color)), 2, "00")   
    Protected.s WinBkGndCSS="window.background{background-color: "+color$+";" + #LF$ + "}"
    gtk_css_provider_load_from_data(*gProvider, WinBkGndCSS, -1, #Null)
    gtk_style_context_add_provider(gtk_widget_get_style_context(WindowID(window_ID)), *gProvider, #GTK_STYLE_PROVIDER_PRIORITY_USER)
  EndProcedure
CompilerEndIf

; CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define button_width=450
Define button_height=300
Define text_color_a=#Yellow
Define text_color_b=#Red
Define background_color=#Blue
Define window_color=$228B22
Define canvas_flag=#PB_Canvas_Border ; Flags same the PB function
Define animation_delay=2
Define animation_alpha_step=9

Define text_a$="This is a ColorButtonGadget_BF"+#LF$+#LF$+
               "- Click me -"+#LF$+#LF$+
               "It's cool Man"
Define text_b$="GFX_Wizzard_BF"+#LF$+#LF$+
               "- WOW -"+#LF$+#LF$+
               "Simple a little more"

Define stretch_x=0 ; Text stretching
Define stretch_y=0
Define flag=1 ; Flags : Text center=1 - Text right=2 - Text vertical=3
Define mode=0 ; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4

; Use ever a large font for the buttons - Then the function adjust the needed font size automatically (about 60 for the mostly large buttons)
Define font_ID=LoadFont(#PB_Any, "Arial", 60, #PB_Font_Bold)

Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 600, "Klick me - FadeIn and FadeOut Demo with ImageGadget_BF", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
SetWindowColor(window_ID, window_color)

Define x_pos=WindowWidth(window_ID)/2-button_width/2
Define y_pos=WindowHeight(window_ID)/2-button_height/2+60

FitImageActivateUpscaling_BF(1) ; Activate upscaling - For little images

Define text_gadget_1_ID=ColorButtonGadget_BF(text_a$,
                                             x_pos,
                                             y_pos,
                                             button_width,
                                             button_height,
                                             text_color_a,
                                             background_color,
                                             font_ID,
                                             stretch_x,
                                             stretch_y,
                                             flag,
                                             mode,
                                             canvas_flag)

Define text_gadget_2_ID=ColorButtonGadget_BF(text_a$,
                                             WindowWidth(window_ID)/2-150,
                                             y_pos-190,
                                             300,
                                             160,
                                             text_color_a,
                                             $B48246,
                                             font_ID,
                                             stretch_x,
                                             stretch_y,
                                             flag,
                                             mode)

; =================== Main Loop ===================

Repeat
  
  Define win_event=WaitWindowEvent()
  If win_event=#PB_Event_Gadget
    If (EventGadget()=text_gadget_1_ID Or EventGadget()=text_gadget_2_ID)
      
      ; Method 1
      ; SetColorButtonGadget_BF_AutoFade_BF(text_gadget_1_ID, ; Gadget 1
      ;                                     text_a$,
      ;                                     text_b$,
      ;                                     animation_delay,
      ;                                     animation_alpha_step)
      ;       
      ; SetColorButtonGadget_BF_AutoFade_BF(text_gadget_2_ID, ; Gadget 2
      ;                                     text_a$,
      ;                                     text_b$,
      ;                                     animation_delay,
      ;                                     animation_alpha_step)
      
      ; Method 2
      ; If GetGadgetData(text_gadget_1_ID) ; Toggle from b to a
      ;         
      ;   SetColorButtonGadget_BF_Fade_ChangeTextColor_BF(text_gadget_1_ID, ; Gadget 1
      ;                                                   text_a$,
      ;                                                   text_b$,
      ;                                                   text_color_a,
      ;                                                   text_color_b,
      ;                                                   background_color,
      ;                                                   animation_delay,
      ;                                                   animation_alpha_step)
      ;         
      ;   SetColorButtonGadget_BF_Fade_ChangeTextColor_BF(text_gadget_2_ID, ; Gadget 2
      ;                                                   text_a$,
      ;                                                   text_b$,
      ;                                                   text_color_a,
      ;                                                   text_color_b,
      ;                                                   $B48246,
      ;                                                   animation_delay,
      ;                                                   animation_alpha_step)
      ;         
      ;   SetGadgetData(text_gadget_1_ID, 0)  
      ;         
      ; Else
      ;         
      ;   SetColorButtonGadget_BF_Fade_ChangeTextColor_BF(text_gadget_1_ID, ; Gadget 1
      ;                                                   text_b$,
      ;                                                   text_a$,
      ;                                                   text_color_b,
      ;                                                   text_color_a,
      ;                                                   background_color,
      ;                                                   animation_delay,
      ;                                                   animation_alpha_step)
      ;         
      ;   SetColorButtonGadget_BF_Fade_ChangeTextColor_BF(text_gadget_2_ID, ; Gadget 2
      ;                                                   text_b$,
      ;                                                   text_a$,
      ;                                                   text_color_b,
      ;                                                   text_color_a,
      ;                                                   $B48246,
      ;                                                   animation_delay,
      ;                                                   animation_alpha_step) 
      ;         
      ;   SetGadgetData(text_gadget_1_ID, 1)        
      ;
      ; EndIf 
      
      ; Method 3
      SetColorButtonGadget_BF_Fading_BF(text_gadget_1_ID, ; Gadget 1
                                        text_a$,
                                        text_b$,
                                        text_color_a,
                                        text_color_b,
                                        animation_delay,
                                        animation_alpha_step)
      
      SetColorButtonGadget_BF_Fading_BF(text_gadget_2_ID, ; Gadget 2
                                        text_a$,
                                        text_b$,
                                        text_color_a,
                                        text_color_b,
                                        animation_delay,
                                        animation_alpha_step) 
      
    EndIf
  EndIf
  
Until win_event=#PB_Event_CloseWindow

FitImageActivateUpscaling_BF(0)
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 181
; FirstLine = 146
; Folding = -
; EnableXP