﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse

XIncludeFile("./GFX_Wizzard_BF.pbi")

; Create a CSS sprite sheet from a GIF image PB 5.60 => needed

; This code generate a complete sheet from a GIF and a sheet data file

; You can create the sheets in all picture formats, also lossly formats
; For using lossly formats, you must output the sheets with the BF color distance function for cleaning the sprite mask
; For best results use PNG format and a color distance mostly from about 20 percent

EnableExplicit

Define invisible_gif_color=$A7A8A9 ; Preset here a invisible color - Best a color nearly the GIF content color, but not the same or you become "Holes"
                                   ; For many things gray colors looking the best
                                   ; Also you can use a very different invisible color for better differentiation
                                   ; the GIF output from a textured background or image

Define path$=OpenFileRequester("Select a GIF picture", "", "", 0)
If path$="" Or UCase(GetExtensionPart(path$))<>"GIF": End : EndIf

ActivateAlphaChannel_BF(1) ; Is this function activated, the created sheet is a PNG with invisible color
                           ; You must deactivate this function after using or it influence all BF core based functions

; This call create a CSS sheet with a sheet info file and include the same file to the end from the sheet image
CreateCSSandDataSheet_BF(path$, 0, invisible_gif_color, 2, 1)

CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 25
; Folding = -
; EnableXP