﻿
EnableExplicit

; Hidde your images and textures - Simple 'on place' image crypter

Procedure EncryptImageSimple_BF(image_ID, seed=0)
  Protected i : RandomSeed(seed) ; By Saki
  If Not IsImage(image_ID) Or Not StartDrawing(ImageOutput(image_ID)) : ProcedureReturn 0 : EndIf
  Protected image_length=DrawingBufferPitch()*ImageHeight(image_ID)-1
  Protected *buffer=DrawingBuffer() : StopDrawing()
  For i=0 To image_length : PokeA(*buffer+i, PeekA(*buffer+i)+Random(255)) : Next : ProcedureReturn 1
EndProcedure

Procedure DecryptImageSimple_BF(image_ID, seed=0)
  Protected i : RandomSeed(seed) ; By Saki
  If Not IsImage(image_ID) Or Not StartDrawing(ImageOutput(image_ID)) : ProcedureReturn 0 : EndIf
  Protected image_length=DrawingBufferPitch()*ImageHeight(image_ID)-1
  Protected *buffer=DrawingBuffer() : StopDrawing()
  For i=0 To image_length : PokeA(*buffer+i, PeekA(*buffer+i)-Random(255)) : Next : ProcedureReturn 1
EndProcedure

; ######## Get the result ########

UsePNGImageDecoder() : UseJPEGImageDecoder() : UseTIFFImageDecoder()

Define path$=OpenFileRequester("Select a image", "", "", 0) : If path$="" : End : EndIf

Define image_ID=LoadImage(#PB_Any, path$)

ResizeImage(image_ID, 300, 300)

Define window_ID=OpenWindow(#PB_Any, 0, 0, 660, 340, "Left=encrypted  - Right=decrypted", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)

; #### Encrypt a image ####
Define seed_as_password=1000
EncryptImageSimple_BF(image_ID, seed_as_password)
Define image_gadget_ID=ImageGadget(#PB_Any, 20, 20, 0, 0, ImageID(image_ID))

; #### Decrypt a image ####
Define seed_as_password=1000
DecryptImageSimple_BF(image_ID, seed_as_password)
Define image_gadget_1_ID=ImageGadget(#PB_Any, 340, 20, 0, 0, ImageID(image_ID))

Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 43
; FirstLine = 7
; Folding = -
; EnableXP