﻿DeclareModule Data_Tool_Decoder_BF
  EnableExplicit
  ; Sakis data Generator - © Decoder
  ; This code is free for use, changing and enhancing
  ; character_offset - Base character offset - As sample 30, 160, 230 - Try what ever you want
  ; Seed - set as a integer - This works as password for the integrated data crypter
  Declare Data_Decoder_BF(*data_start_pointer, *data_end_pointer, seed=0)
EndDeclareModule

Module Data_Tool_Decoder_BF
   ; You can remove what you not want
  UsePNGImageDecoder() : UseJPEGImageDecoder() : UseGIFImageDecoder() : UseTIFFImageDecoder()
  
  Procedure Data_Decoder_BF(*data_start_pointer, *data_end_pointer, seed=0)
    ; Sakis data Generator - This function give back a pointer to a allocated memory with your data
    Protected i, ii, breaks, *buffer, *catch_buffer, len_buffer, len_line
    Protected len_data.q, data_size, *catch_buffer_new : len_line=Len(PeekS(*data_start_pointer))
    data_size=*data_end_pointer-*data_start_pointer : len_buffer=data_size/2 : RandomSeed(seed)
    *buffer=AllocateMemory(data_size) : CopyMemory(*data_start_pointer, *buffer, data_size)
     Repeat : If Not PeekW(*buffer+i) : PokeW(*buffer+i, 2560) : breaks+1 : EndIf : i+2 : Until i>data_size
    *catch_buffer=AllocateMemory(data_size/2-breaks)
    For i=0 To len_buffer-breaks-1 : If Not i%len_line And i : ii+2 : EndIf
      PokeA(*catch_buffer+i, PeekA(*buffer+ii)-Random(254, 1)) : ii+2
    Next
    ii=14 : For i=0 To 5 : PokeA(@len_data+i, PeekA(*data_end_pointer-ii)) : ii-2 : Next i
    *catch_buffer_new=AllocateMemory(len_data)
    CopyMemory(*catch_buffer, *catch_buffer_new, MemorySize(*catch_buffer_new))
    FreeMemory(*catch_buffer) : FreeMemory(*buffer)
    ProcedureReturn *catch_buffer_new
  EndProcedure 
EndModule
UseModule Data_Tool_Decoder_BF

; #################### Decoder Demo part ########################
CompilerIf #PB_Compiler_IsMainFile
  EnableExplicit
  
  Define *catch_buffer=Data_Decoder_BF(?image_1_start, ?image_1_end)
  
  Define image_ID=CatchImage(#PB_Any, *catch_buffer)
  FreeMemory(*catch_buffer)
  
  Define window_ID=OpenWindow(#PB_Any, 0, 0, 600, 400, "", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
  If IsImage(image_ID)
    Define image_gadget_ID=ImageGadget(#PB_Any,
                                       WindowWidth(window_ID)/2-ImageWidth(image_ID)/2,
                                       WindowHeight(window_ID)/2-ImageHeight(image_ID)/2,
                                       0,
                                       0,
                                       ImageID(image_ID))
  Else
    CloseWindow(window_ID)
    MessageRequester("Hint", "Embedded image not usable")
    End
  EndIf
  
  Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
  
  DataSection
    image_1_start:
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    Data.s ""
    image_1_end:
  EndDataSection
CompilerEndIf

; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 21
; FirstLine = 6
; Folding = -
; EnableXP