﻿DeclareModule Data_Tool_InCode_Decoder_BF
  EnableExplicit
  ; Sakis data InCode Generator © - Decoder - This code is free For use, changing And enhancing
  ; character_offset - Base character offset - As sample 30, 160, 230 - Try what ever you want
  ; Seed - set as a integer - This works as password for the integrated data crypter
  Declare Data_InCode_Decoder_BF(Data_BF$, seed=0)
  Declare ChatchImageInCode_BF(Data_01$) ; Catch a image
EndDeclareModule

Module Data_Tool_InCode_Decoder_BF
  ; You can remove what you not want
  UsePNGImageDecoder() : UseJPEGImageDecoder() : UseGIFImageDecoder() : UseTIFFImageDecoder()
  
  Procedure Data_InCode_Decoder_BF(Data_BF$, seed=0)
    ; Sakis data Generator - This function give back a pointer to a allocated memory with your data
    Protected *data_start_pointer=@Data_BF$, len_line=Len(Data_BF$), len_data.q, data_size=len_line*2-2
    Protected i, ii, offset, *buffer, *catch_buffer, len_buffer=data_size/2 , *catch_buffer_new
    *buffer=AllocateMemory(data_size) : CopyMemory(*data_start_pointer, *buffer, data_size)
    *catch_buffer=AllocateMemory(data_size/2-offset) : RandomSeed(seed)
    For i=0 To len_buffer-offset-1 : If Not i%len_line And i : ii+2 : EndIf
      PokeA(*catch_buffer+i, PeekA(*buffer+ii)-Random(254, 1)) : ii+2
    Next
    ii=12 : For i=0 To 5 : PokeA(@len_data+i, PeekA(*data_start_pointer+StringByteLength(Data_BF$)-ii)) : ii-2 : Next
    *catch_buffer_new=AllocateMemory(len_data)
    CopyMemory(*catch_buffer, *catch_buffer_new, MemorySize(*catch_buffer_new))
    FreeMemory(*catch_buffer) : FreeMemory(*buffer)
    ProcedureReturn *catch_buffer_new
  EndProcedure
  Procedure ChatchImageInCode_BF(Str_01$)
    If Str_01$="" : ProcedureReturn 0 : EndIf
    Protected *catch_buffer=Data_InCode_Decoder_BF(Str_01$)
    If *catch_buffer : Protected image_ID=CatchImage(#PB_Any, *catch_buffer) : FreeMemory(*catch_buffer)
    ProcedureReturn image_ID : EndIf
  EndProcedure
EndModule
UseModule Data_Tool_InCode_Decoder_BF

; #################### Decoder Demo part ########################
CompilerIf #PB_Compiler_IsMainFile
  EnableExplicit
  
  Define Str_01$
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  Str_01$+""
  
  ; Standard procedre
  ; Define *catch_buffer=Data_InCode_Decoder_BF(Str_01$) 
  ; Define image_ID=CatchImage(#PB_Any, *catch_buffer)
  ; FreeMemory(*catch_buffer)
  
  ; Simplificated
  Define image_ID=ChatchImageInCode_BF(Str_01$)
  
  Define window_ID=OpenWindow(#PB_Any, 0, 0, 600, 400, "", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
  If IsImage(image_ID)
    Define image_gadget_ID=ImageGadget(#PB_Any,
                                       WindowWidth(window_ID)/2-ImageWidth(image_ID)/2,
                                       WindowHeight(window_ID)/2-ImageHeight(image_ID)/2,
                                       0,
                                       0,
                                       ImageID(image_ID))
  Else
    CloseWindow(window_ID)
    MessageRequester("Hint", "Embedded image not usable")
    End
  EndIf
  
  Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
  
CompilerEndIf
; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; FirstLine = 52
; Folding = -
; EnableXP
; Optimizer