﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define output_width=1200 ; Preset
Define output_height=800

Define window_ID=OpenWindow(#PB_Any, 0, 0, output_width, output_height, "GFX_Wizzard_BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
SetWindowColor(window_ID, $808080)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, output_width, output_height)

Define texture_ID=LoadPhoto_BF("./Image_Set/soil_wall.jpg")
ErrorCheck_BF(BF(-2, canvas_ID, texture_ID)) ; Make a background texture

Define path$=OpenFileRequester("Select a Image", "", "", 0)
If path$="" : End : EndIf

Define image_ID=LoadPhoto_BF(path$) ; This function rotate automaticaly a Photo with EXIF data - Important as sample for many "Handy" Photos

Define win_event, i, image_ID, output_ID

Define mode=0
; mode 0 = image output
; mode 1 = Without background
; mode 2 = PB sprite output

; ----------------------------------------------------------
Define padding=34           ; Padding
Define fit_width=500        ; Fit image to this width
Define fit_height=400       ; Fit image to this height
Define background_color=$FF ; Background color
Define grid_color=$DCDCDC   ; Grid color
Define grid_size=8          ; Grid size
Define grid_tiling=10       ; Grid tiling
Define frame_color=$FF      ; Frame color
Define frame_size=8         ; Frame size
Define sprite_mode=0        ; Sprite mode for PB sprite output

Define output_0_ID=FitImage_BF(mode, image_ID,
                               fit_width,
                               fit_height,
                               background_color,
                               padding,
                               grid_color,
                               grid_size,
                               grid_tiling,
                               frame_color,
                               frame_size,
                               sprite_mode)

; Hint :
; Fit a source rectangle proportional in to a destination rectangle
; You can use for proportional resizing with many BF functions
; GetFitSize_BF(ImageWidth(image_ID), ImageHeight(image_ID), fit_width, fit_height)
; Debug GetFitOffset_X_BF() ; Give back the x offset for the fitted output
; Debug GetFitOffset_Y_BF() ; Give back the y offset for the fitted output
; Debug GetFitSize_Width_BF() ; Give back the calculated proportional width for the fitted output
; Debug GetFitSize_Height_BF() ; Give back the calculated proportional height for the fitted output
; Also FitImage_BF give back this both parameters

; ----------------------------------------------------------
Define padding=20               ; Padding
Define fit_width=300            ; Fit image to this width
Define fit_height=200           ; Fit image to this height
Define background_color=$FF0000 ; Background color
Define grid_color=$DCDCDC       ; Grid color
Define grid_size=3              ; Grid size
Define grid_tiling=10           ; Grid tiling
Define frame_color=$FFFF        ; Frame color
Define frame_size=5             ; Frame size

Define output_1_ID=FitImage_BF(mode, image_ID,
                               fit_width,
                               fit_height,
                               background_color,
                               padding,
                               grid_color,
                               grid_size,
                               grid_tiling,
                               frame_color,
                               frame_size,
                               sprite_mode)

; ----------------------------------------------------------
Define padding=30                ; Padding
Define fit_width=300             ; Fit image to this width
Define fit_height=200            ; Fit image to this height
Define background_color=$FF0000  ; Background color
Define grid_color=$DCDCDC        ; Grid color
Define grid_size=5               ; Grid size
Define grid_tiling=10            ; Grid tiling
Define frame_color=$FF00         ; Frame color
Define frame_size=3              ; Frame size

Define output_2_ID=FitImage_BF(mode, image_ID,
                               fit_width,
                               fit_height,
                               background_color,
                               padding,
                               grid_color,
                               grid_size,
                               grid_tiling,
                               frame_color,
                               frame_size,
                               sprite_mode)

; ----------------------------------------------------------
Define padding=70              ; Padding
Define fit_width=200           ; Fit image to this width
Define fit_height=200          ; Fit image to this height
Define background_color=$FFFF  ; Background color
Define grid_color=$DCDCDC      ; Grid color
Define grid_size=0             ; Grid size
Define grid_tiling=10          ; Grid tiling
Define frame_color=$FF         ; Frame color
Define frame_size=3            ; Frame size

Define output_3_ID=FitImage_BF(mode, image_ID,
                               fit_width,
                               fit_height,
                               background_color,
                               padding,
                               grid_color,
                               grid_size,
                               grid_tiling,
                               frame_color,
                               frame_size,
                               sprite_mode)

; ----------------------------------------------------------
Define padding=10             ; Padding
Define fit_width=350          ; Fit image to this width
Define fit_height=200         ; Fit image to this height
Define background_color=$FFFF ; Background color
Define grid_color=$DCDCDC     ; Grid color
Define grid_size=0            ; Grid size
Define grid_tiling=10         ; Grid tiling
Define frame_color=$FF        ; Frame color
Define frame_size=2           ; Frame size

Define output_4_ID=FitImage_BF(mode, image_ID,
                               fit_width,
                               fit_height,
                               background_color,
                               padding,
                               grid_color,
                               grid_size,
                               grid_tiling,
                               frame_color,
                               frame_size,
                               sprite_mode)

; ----------------------------------------------------------
Define padding=6              ; Padding
Define fit_width=400          ; Fit image to this width
Define fit_height=300         ; Fit image to this height
Define background_color=$FF00 ; Background color
Define grid_color=$DCDCDC     ; Grid color
Define grid_size=0            ; Grid size
Define grid_tiling=10         ; Grid tiling
Define frame_color=0          ; Frame color
Define frame_size=3           ; Frame size

Define output_5_ID=FitImage_BF(mode, image_ID,
                               fit_width,
                               fit_height,
                               background_color,
                               padding,
                               grid_color,
                               grid_size,
                               grid_tiling,
                               frame_color,
                               frame_size,
                               sprite_mode)

; ----------------------------------------------------------
Define padding=6                ; Padding
Define fit_width=250            ; Fit image to this width
Define fit_height=250           ; Fit image to this height
Define background_color=$FF0000 ; Background color
Define grid_color=$DCDCDC       ; Grid color
Define grid_size=0              ; Grid size
Define grid_tiling=10           ; Grid tiling
Define frame_color=$DCDCDC      ; Frame color
Define frame_size=3             ; Frame size

Define output_6_ID=FitImage_BF(mode, image_ID,
                               fit_width,
                               fit_height,
                               background_color,
                               padding,
                               grid_color,
                               grid_size,
                               grid_tiling,
                               frame_color,
                               frame_size,
                               sprite_mode)

; ----------- Get the result ------------------------

StartDrawing(CanvasOutput(canvas_ID))
DrawAlphaImage(ImageID(output_0_ID), 20, 20)
DrawAlphaImage(ImageID(output_1_ID), 550, 50)
DrawAlphaImage(ImageID(output_2_ID), 880, 10)
DrawAlphaImage(ImageID(output_3_ID), 850, 300)
DrawAlphaImage(ImageID(output_4_ID), 30, 500)
DrawAlphaImage(ImageID(output_5_ID), 390, 450)
DrawAlphaImage(ImageID(output_6_ID), 850, 540)
StopDrawing()


Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    End
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableXP
; DisableDebugger