﻿; FontWizzard_BF on WindowedScreen - Demo code

XIncludeFile("./FontWizzard_BF.pbi")

; ##############  Simple WindowedScreen FontWizzard_BF Demo - DPI aware - All OS ############
EnableExplicit

Define DR.f=DesktopResolutionX()

Define image_1_ID=LoadImage(#PB_Any, "./Image_Set//PureBasicLogo.bmp")
Define window_ID=OpenWindow(#PB_Any, 0, 0, 500, 370, "FW Text on a WindowedScreen", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
Define gadget_ID=OpenWindowedScreen(WindowID(window_ID), 0, 0, WindowWidth(window_ID)*DR, WindowHeight(window_ID)*DR)

; ----------------------------------------------------------

; Activate screen output for DrawText_FW - You must deactivate again
ActivateScreenOutput_FW(1)

Repeat
  Delay(10) 
  
  Repeat
    Define win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow 
      End
    EndIf
  Until Not win_event
  
  FlipBuffers()
  ClearScreen (#Blue)
  
  ; Set the text color for a line - You must deactivate again (Set LineColor_FW=-1) - First 1000 Lines supported
  TextColor_Line_FW(1, #White)
  ; Add a frame to all outputs - Padding is automatically adjusted - Alpha channel sensitive - Sample $8000FFFF
  AddFrame_FW(2*DR, #Red, 4*DR) ; AddFrame_Size_FW, AddFrame_Color_FW, AddFrame_Rounding_FW
  Define text$="Hello World"+#LF$+"This is a advanced text output"
  DrawText_FW(-1,            ; Ignored
              "",            ; Font
              #PB_Font_Bold, ; Font flag
              100*DR,        ; Output x pos
              20*DR,         ; Output y pos
              300*DR,        ; Output width
              60*DR,         ; Output height
              #Red,          ; Text color
              1,             ; Text adjustment - 0=center - 1=left - 2=right
              -1,            ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
              text$,         ; Text
              12*DR,         ; Padding x
              2*DR,          ; Padding y
              1.0)           ; Resize factor
  
  AddFrame_FW(5*DR, #Red, 5) ; AddFrame_Size_FW, AddFrame_Color_FW, AddFrame_Rounding_FW
  text$="Hello World"+#LF$+"This is a automaticaly fitted text output"+#LF$+"Try any Text"
  DrawText_FW(-1,            ; Ignored
              "Georgia",     ; Font
              #PB_Font_Bold, ; Font flag
              10*DR,         ; Output x pos
              110*DR,        ; Output y pos
              480*DR,        ; Output width
              90*DR,         ; Output height
              #Red,          ; Text color
              0,             ; Text adjustment - 0=center - 1=left - 2=right
              -1,            ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
              text$,         ; Text
              -25/DR,        ; Padding x
              2*DR,          ; Padding y
              1.0)           ; Resize factor
  
  ; Set the text color for a line - You must deactivate again (Set LineColor_FW=-1) - First 1000 Lines supported
  TextColor_Line_FW(1, #Red)
  AddFrame_FW(5*DR, #Yellow, 6*DR) ; AddFrame_Size_FW, AddFrame_Color_FW, AddFrame_Rounding_FW
  text$+#LF$+#LF$+"Have fun"
  AddImage_1_FW(image_1_ID,
                250*DR, ; x pos
                86*DR,  ; y pos
                140*DR, ; Width
                25*DR,  ; Height
                255)    ; Alpha
  
  DrawText_FW(-1,            ; Ignored
              "Georgia",     ; Font
              #PB_Font_Bold, ; Font flag
              50*DR,         ; Output x pos
              230*DR,        ; Output y pos
              400*DR,        ; Output width
              120*DR,        ; Output height
              #Blue,         ; Text color
              0,             ; Text adjustment - 0=center - 1=left - 2=right
              #Green,        ; Background_color - Ignore = -1 - Alpha channel sensitive - Sample $8000FFFF
              text$,         ; Text
              12*DR,         ; Padding x
              2*DR,          ; Padding y
              1.0)           ; Resize factor
  
  AddImage_1_FW()            ; Remove additional image 1
  
ForEver
; IDE Options = PureBasic 5.73 LTS (Linux - x64)
; CursorPosition = 51
; FirstLine = 29
; EnableXP
; EnableUser
; DPIAware