﻿CompilerIf #PB_Compiler_Version<560
  MessageRequester ("Hint" , "PureBasic Version =>560 needed for this demo Code")
  End
CompilerElse

; - Demo - Use a GIF with mask or without mask as PB sprite on screen  - Compactness demo
XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Define window_ID, win_event, texture_ID, gif_ID, background_ID, image_width, image_height, frame, i, invisible_color, frame_sprite_ID, path$

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

path$=OpenFileRequester("Select a GIF", "", "", 0)

If path$="" : End : EndIf

If UCase(GetExtensionPart(path$))<>"GIF"
  MessageRequester("Hint", "This is not a GIF !")
  End
EndIf

gif_ID=LoadImage(#PB_Any, path$)

texture_ID=CreateImage(#PB_Any, 100, 100) ; Create a texture for the background
StartDrawing(ImageOutput(texture_ID))
For i=1 To ImageWidth(texture_ID)-1 Step 7 : LineXY(i, 0, i, ImageHeight(texture_ID), $DCDCDC) : Next i
For i=1 To ImageHeight(texture_ID)-1 Step 7 : LineXY(0, i, ImageWidth(texture_ID), i, $DCDCDC) : Next i
StopDrawing()

Define alpha=255 ; Here you can set alpha blending - Set 255 for full visible, 0 for full transparence

Define frame_width=ImageWidth(gif_ID), frame_height=ImageHeight(gif_ID), output_width=frame_width+80, output_height=frame_height+80
; ------------------------------------------------------------------------------

window_ID=OpenWindow(#PB_Any, 0, 0, output_width, output_height, "GFX_Wizzard_BF - Gif on Windowed Screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

If Not OpenWindowedScreen(WindowID(window_ID), 0, 0, output_width, output_height) : End : EndIf ; Create a windowed screen for output

background_ID=CreateSprite(#PB_Any, output_width, output_height)

ErrorCheck_BF(BF(-2, background_ID, texture_ID)) ; Create a tilled background with the BF core function

Repeat
  Delay(1)
  
  Repeat ; Get all window events before FlipBuffers
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow : End : EndIf
  Until Not win_event

  FlipBuffers() : ClearScreen(0)
  
  DisplaySprite(background_ID, 0, 0) ; Draw a textured background
  
  Gif_on_Screen_BF(gif_ID, output_width/2-frame_width/2, output_height/2-frame_height/2, frame, alpha) ; Draw the Gif frame - Resizing available
  
  If Delay_BF(1, Get_Gif_FrameDelay_BF(gif_ID, frame)) : frame+1 : If frame=ImageFrameCount(gif_ID) : frame=0 : EndIf : EndIf  ; Frame delay - Using timer 1
ForEver

CompilerEndIf
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 16
; Folding = -
; EnableXP
; Executable = ..\test.exe
; DisableDebugger