; Demo - ImageGadget_BF

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Activate_DPI_aware_BF(1) ; Activate DPI aware

; Workaround Linux PB570 window background color
CompilerIf #PB_Compiler_OS=#PB_OS_Linux And Not Subsystem("gtk2") And Not Subsystem("qt")
  Macro SetWindowColor(window_ID, color)
    Window_SetCssBackColor(window_ID, color)
  EndMacro
  ImportC "" ; By Oma
    gtk_css_provider_load_from_data(*css_provider, data_.p-utf8, length, *error.GError)
    gtk_css_provider_new()
    gtk_style_context_add_provider(*context, *provider, priority)
    gtk_widget_get_style_context(*widget.GtkWidget)
  EndImport
  Procedure Window_SetCssBackColor(Window_ID, color)
    #GTK_STYLE_PROVIDER_PRIORITY_USER=800
    Protected color$, *gProvider=gtk_css_provider_new()
    ; Protected color$="#"+RSet(Hex(color), 6, "000000")
    color$="#"+RSet(Hex(Red(color)), 2, "00")+RSet(Hex(Green(color)), 2, "00")+RSet(Hex(Blue(color)), 2, "00")   
    Protected.s WinBkGndCSS="window.background{background-color: "+color$+";" + #LF$ + "}"
    gtk_css_provider_load_from_data(*gProvider, WinBkGndCSS, -1, #Null)
    gtk_style_context_add_provider(gtk_widget_get_style_context(WindowID(window_ID)), *gProvider, #GTK_STYLE_PROVIDER_PRIORITY_USER)
  EndProcedure
CompilerEndIf

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define output_width=1200 ; Preset
Define output_height=800

Define window_ID=OpenWindow(#PB_Any, 0, 0, output_width, output_height, "GFX Wizzard BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
SetWindowColor(window_ID, $808080)

Define path$=OpenFileRequester("Select a Image", "", "", 0)
If path$="" : End : EndIf

Define image_ID=LoadPhoto_BF(path$) ; This function rotate automaticaly a Photo with EXIF data - Important as sample for many "Handy" Photos

Define image_1_ID=LoadImage(#PB_Any, "./Image_Set/Lion.jpg")

#Sheet_1="./Image_Set/Hound_1.png"
Define sheet_1_ID=LoadImage(#PB_Any, #Sheet_1) : LoadFrameData_BF(#Sheet_1) ; Hound

Define win_event

; Hints :
; Use a invisible background only For images With invisible color Or you see nothing

; You can activate also a automatically image upscaling
FitImageActivateUpscaling_BF(1) ; Add to the FitImage functions a automatically upscaling for little images
                                ; With this function too small fonts and images are automatically enlarged for the Gadgets_BF
                                ; The use of very large maximum font sizes slows down the calculation of the gadgets
                                ; So it can make sense to use smaller pictures and fonts to enlarge them a little if necessary

; 1 ----------------------------------------------------------
Define x=40                ; Output pos x
Define y=20                ; Output pos y
Define padding=34          ; Padding - Deactivate with -1
Define width=480           ; Fit image to this width
Define height=400          ; Fit image to this height
Define background_color=0  ; Background color - For a invisible background set background_color=-2
Define grid_color=$D0D0D0  ; Grid color
Define grid_size=8         ; Grid size
Define grid_tiling=0       ; Grid tiling
Define frame_color=$505050 ; Frame color
Define frame_size=8        ; Frame size
Define flags= #PB_Image_Raised   ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_1_ID=ImageGadget_BF(image_ID,
                                  x,
                                  y,
                                  width,
                                  height,
                                  background_color,
                                  padding,
                                  grid_color,
                                  grid_size,
                                  grid_tiling,
                                  frame_color,
                                  frame_size,
                                  flags)

; 2 ----------------------------------------------------------
Define x=550                    ; Output pos x
Define y=50                     ; Output pos y
Define padding=20               ; Padding - Deactivate with -1
Define width=300                ; Fit image to this width
Define height=200               ; Fit image to this height
Define background_color=$FF0000 ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC       ; Grid color
Define grid_size=3              ; Grid size
Define grid_tiling=10           ; Grid tiling
Define frame_color=$FFFF        ; Frame color
Define frame_size=5             ; Frame size
Define flags=#PB_Image_Raised   ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_2_ID=ImageGadget_BF(image_ID,
                                  x,
                                  y,
                                  width,
                                  height,
                                  background_color,
                                  padding,
                                  grid_color,
                                  grid_size,
                                  grid_tiling,
                                  frame_color,
                                  frame_size,
                                  flags)

; 3 ----------------------------------------------------------
Define x=880                    ; Output pos x
Define y=10                     ; Output pos y
Define padding=30               ; Padding - Deactivate with -1
Define width=300                ; Fit image to this width
Define height=200               ; Fit image to this height
Define background_color=$FF0000 ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC       ; Grid color
Define grid_size=5              ; Grid size
Define grid_tiling=300          ; Grid tiling
Define frame_color=$FF00        ; Frame color
Define frame_size=3             ; Frame size
Define flags=#PB_Image_Raised   ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_3_ID=ImageGadget_BF(image_ID,
                                  x,
                                  y,
                                  width,
                                  height,
                                  background_color,
                                  padding,
                                  grid_color,
                                  grid_size,
                                  grid_tiling,
                                  frame_color,
                                  frame_size,
                                  flags)

; 4 ----------------------------------------------------------
Define x=810                  ; Output pos x
Define y=270                  ; Output pos y
Define padding=70             ; Padding - Deactivate with -1
Define width=300              ; Fit image to this width
Define height=200             ; Fit image to this height
Define background_color=$FFFF ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC     ; Grid color
Define grid_size=10           ; Grid size
Define grid_tiling=10         ; Grid tiling
Define frame_color=$FF        ; Frame color
Define frame_size=3           ; Frame size
Define flags=0                ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_4_ID=ImageGadget_BF(image_ID,
                                  x,
                                  y,
                                  width,
                                  height,
                                  background_color,
                                  padding,
                                  grid_color,
                                  grid_size,
                                  grid_tiling,
                                  frame_color,
                                  frame_size,
                                  flags)

; 5 ----------------------------------------------------------
Define x=50                   ; Output pos x
Define y=560                  ; Output pos y
Define padding=10             ; Padding - Deactivate with -1
Define width=350              ; Fit image to this width
Define height=230             ; Fit image to this height
Define background_color=$FFFF ; Background color - For a invisible background set background_color=-2
Define grid_color=$606060     ; Grid color
Define grid_size=10           ; Grid size
Define grid_tiling=0          ; Grid tiling
Define frame_color=$606060    ; Frame color
Define frame_size=6           ; Frame size
Define flags=#PB_Image_Raised ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_5_ID=ImageGadget_BF(image_ID,
                                  x,
                                  y,
                                  width,
                                  height,
                                  background_color,
                                  padding,
                                  grid_color,
                                  grid_size,
                                  grid_tiling,
                                  frame_color,
                                  frame_size,
                                  flags)

; 6 ----------------------------------------------------------
Define x=430                  ; Output pos x
Define y=490                  ; Output pos y
Define padding=6              ; Padding - Deactivate with -1
Define width=400              ; Fit image to this width
Define height=300             ; Fit image to this height
Define background_color=$FF00 ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC     ; Grid color
Define grid_size=0            ; Grid size
Define grid_tiling=10         ; Grid tiling
Define frame_color=0          ; Frame color
Define frame_size=3           ; Frame size
Define flags=#PB_Image_Raised ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_6_ID=ImageGadget_BF(image_ID,
                                  x,
                                  y,
                                  width,
                                  height,
                                  background_color,
                                  padding,
                                  grid_color,
                                  grid_size,
                                  grid_tiling,
                                  frame_color,
                                  frame_size,
                                  flags)

; 7 ----------------------------------------------------------
Define x=850                    ; Output pos x
Define y=540                    ; Output pos y
Define padding=6                ; Padding - Deactivate with -1
Define width=250                ; Fit image to this width
Define height=250               ; Fit image to this height
Define background_color=$FF0000 ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC       ; Grid color
Define grid_size=0              ; Grid size
Define grid_tiling=10           ; Grid tiling
Define frame_color=$DCDCDC      ; Frame color
Define frame_size=3             ; Frame size
Define flags=#PB_Image_Raised   ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_7_ID=ImageGadget_BF(image_ID,
                                  x,
                                  y,
                                  width,
                                  height,
                                  background_color,
                                  padding,
                                  grid_color,
                                  grid_size,
                                  grid_tiling,
                                  frame_color,
                                  frame_size,
                                  flags)

; 8 ----------------------------------------------------------
CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : Define result=14 : CompilerElse : Define result=11 : CompilerEndIf
Define font_ID=LoadFont(#PB_Any, "Arial", result/DPI_ResizeFactor_BF(), #PB_Font_Bold)
Define txt1$="ImageGadget_BF"+#LF$+#LF$+"A function from"+#LF$+"GFX_Wizzard_BF"+#LF$+#LF$+"Simple a little more"
BackColor_BF(1, $FFFF)
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FFFF)
GradientColor_Array_BF(1, 2, 0.7, $FFFF00)
EllipticalGradient_BF(1, 100, 70, 200 , 160)
GradientColor_contrast_BF(50)
Define text_1_ID=DrawTextCreateImage_BF(txt1$, #White, #Blue, 1, 0, font_ID, 2, 2, -1)

SetColorDistanceSpriteMask_BF(28) ; Add a BF sprite to the text output
ErrorCheck_BF(SpriteSimple_BF(1, text_1_ID, image_1_ID,
                              0,                         ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                              0,                         ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 
                              ImageWidth(text_1_ID)-90,  ; Output pos x
                              ImageHeight(text_1_ID)-60, ; Output pos y
                              90,                        ; You can here resize the output x
                              60,                        ; You can here resize the output y
                              80))                       ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
SetColorDistanceSpriteMask_BF(0)

Define x=540                    ; Output pos x
Define y=290                    ; Output pos y
Define padding=6                ; Padding - Deactivate with -1
Define width=250                ; Fit image to this width
Define height=150               ; Fit image to this height
Define background_color=$FF0000 ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC       ; Grid color
Define grid_size=0              ; Grid size
Define grid_tiling=10           ; Grid tiling
Define frame_color=$DCDCDC      ; Frame color
Define frame_size=3             ; Frame size
Define flags=#PB_Image_Raised   ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_8_ID=ImageGadget_BF(text_1_ID,
                                  x,
                                  y,
                                  width,
                                  height,
                                  background_color,
                                  padding,
                                  grid_color,
                                  grid_size,
                                  grid_tiling,
                                  frame_color,
                                  frame_size,
                                  flags)

; 9 ----------------------------------------------------------
Define font_ID=LoadFont(#PB_Any, "Arial", 24/DPI_ResizeFactor_BF(), #PB_Font_Bold)
Define txt2$="ImageGadget_BF - A function from GFX_Wizzard_BF - Simple a little more - WOW - BF is cool - Amazing features"
BackColor_BF(1, $FFFF)
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FFFF)
GradientColor_Array_BF(1, 2, 0.7, $FFFF00)
EllipticalGradient_BF(1, 850, 0, 800, 200)
GradientColor_contrast_BF(50)
Define text_2_ID=DrawTextCreateImage_BF(txt2$, #White, #Blue, 1, 0, font_ID, 0, 10, -1)

Define x=40                     ; Output pos x
Define y=430                    ; Output pos y
Define padding=5                ; Padding - Deactivate with -1
Define width=478                ; Fit image to this width
Define height=53                ; Fit image to this height
Define background_color=$FF0000 ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC       ; Grid color
Define grid_size=0              ; Grid size
Define grid_tiling=10           ; Grid tiling
Define frame_color=$DCDCDC      ; Frame color
Define frame_size=2             ; Frame size
Define flags=#PB_Image_Raised   ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_9_ID=ImageGadget_BF(0,
                                  x,
                                  y,
                                  width,
                                  height,
                                  background_color,
                                  padding,
                                  grid_color,
                                  grid_size,
                                  grid_tiling,
                                  frame_color,
                                  frame_size,
                                  flags)

; 10 ---------------------------------------------------------
CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : Define result=14 : CompilerElse : Define result=11 : CompilerEndIf
Define font_ID=LoadFont(#PB_Any, "Arial", result/DPI_ResizeFactor_BF(), #PB_Font_Bold)
Define txt3$="ImageGadget_BF"+#LF$+"A function from GFX_Wizzard_BF"+#LF$+"Simple a little more"+#LF$+"WOW"+#LF$+"BF is cool"+#LF$+"Amazing features"
BackColor_BF(1, $FFFF)
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FFFF)
GradientColor_Array_BF(1, 2, 0.7, $FFFF00)
EllipticalGradient_BF(1, 125, 100, 160, 200)
GradientColor_contrast_BF(50)
Define text_3_ID=DrawTextCreateImage_BF(txt3$, #White, #Blue, 1, 0, font_ID, 0, 10, 15)

Define x=100                    ; Output pos x
Define y=500                    ; Output pos y
Define padding=6                ; Padding - Deactivate with -1
Define width=256                ; Fit image to this width
Define height=50                ; Fit image to this height
Define background_color=$FF0000 ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC       ; Grid color
Define grid_size=0              ; Grid size
Define grid_tiling=10           ; Grid tiling
Define frame_color=$DCDCDC      ; Frame color
Define frame_size=2             ; Frame size
Define flags=#PB_Image_Raised   ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_10_ID=ImageGadget_BF(0,
                                   x,
                                   y,
                                   width,
                                   height,
                                   background_color,
                                   padding,
                                   grid_color,
                                   grid_size,
                                   grid_tiling,
                                   frame_color,
                                   frame_size,
                                   flags)

; 11 ---------------------------------------------------------
Define font_ID=LoadFont(#PB_Any, "Arial", 24/DPI_ResizeFactor_BF(), #PB_Font_Bold)
Define txt4$="ImageGadget BF - A function from GFX Wizzard BF - Simple a little more - WOW - BF is cool - Amazing features"
BackColor_BF(1, $FFFF)
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FFFF)
GradientColor_Array_BF(1, 2, 0.7, $FFFF00)
EllipticalGradient_BF(1, 50, 1800, 80, 1400)
GradientColor_contrast_BF(50)
Define text_4_ID=DrawTextCreateImage_BF(txt4$, #White, #Blue, 3, 0, font_ID, 0, 0, -1)

Define x=1130                   ; Output pos x
Define y=250                    ; Output pos y
Define padding=3                ; Padding - Deactivate with -1
Define width=50                 ; Fit image to this width
Define height=500               ; Fit image to this height
Define background_color=$FF0000 ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC       ; Grid color
Define grid_size=0              ; Grid size
Define grid_tiling=10           ; Grid tiling
Define frame_color=$DCDCDC      ; Frame color
Define frame_size=2             ; Frame size
Define flags=#PB_Image_Raised   ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_11_ID=ImageGadget_BF(0,
                                   x,
                                   y,
                                   width,
                                   height,
                                   background_color,
                                   padding,
                                   grid_color,
                                   grid_size,
                                   grid_tiling,
                                   frame_color,
                                   frame_size,
                                   flags)

; 12 ---------------------------------------------------------
Define font_ID=LoadFont(#PB_Any, "Arial", 14/DPI_ResizeFactor_BF(), #PB_Font_Bold)
Define txt5$="ImageGadget BF - A function from GFX Wizzard BF - Simple a little more - WOW - BF is cool - Amazing features"
BackColor_BF(1, $FFFF)
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FFFF)
GradientColor_Array_BF(1, 2, 0.7, $FFFF00)
EllipticalGradient_BF(1, 25, 1400, 80, 1200)
GradientColor_contrast_BF(50)
Define text_5_ID=DrawTextCreateImage_BF(txt5$, #White, $808080, 3, 0, font_ID, 0, 0, -1)

CompilerIf #PB_Compiler_Version=>560
  text_5_ID=CreateAlphaImage_from_Sprite_BF(text_5_ID,
                                            0,   ; You can set a color distance for the mask color in percent
                                            -1,  ; The hidden color from the mask - -1 grabb the sprite mask color from sprite pos x=0 / y=0 and set the resulted color to 0
                                            256, ; Alpha blending - 1 is full visible - 256 invisible (BF specific)
                                            1)   ; Set delete_old_image <>0 for deleting the source image after creating a new image
CompilerEndIf    

Define x=0                            ; Output pos x
Define y=1                            ; Output pos y
Define padding=0                      ; Padding - Deactivate with -1
Define width=40                       ; Fit image to this width
Define height=WindowHeight(window_ID) ; Fit image to this height
Define background_color=$808080       ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC             ; Grid color
Define grid_size=0                    ; Grid size
Define grid_tiling=10                 ; Grid tiling
Define frame_color=$DCDCDC            ; Frame color
Define frame_size=0                   ; Frame size
Define flags=0                        ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Define gadget_12_ID=ImageGadget_BF(0,
                                   x,
                                   y,
                                   width,
                                   height,
                                   background_color,
                                   padding,
                                   grid_color,
                                   grid_size,
                                   grid_tiling,
                                   frame_color,
                                   frame_size,
                                   flags)

; ----------- Get the result ------------------------

Define output_x, output_y, output_y_1, output_y_2, temporary_image_ID, alpha=256, flip

; Workaround PB 562 Windows with FlickerFix
; Under Windows OS 24Bit images are not automatically cached using ImageGadget, 32Bit images are cached, but flicker on animation
; This mean, leave a 24Bit image the desktop, then the image is not cached, you come back, you must refresh the image self
; For Windows OS you can cache self with BF the images you display in the ImageGadget_BF
; You must deactivate this function when you don't need it anymore or you get a memory leak
; CacheImageGadgetImage_BF(1, image_ID) ; Activate BF 24Bit image caching and give free image_ID
; CacheImageGadgetImage_BF(0, image_ID) ; Deactivate BF 24Bit image caching and give free image_ID
; For static outputs you need this not
; This is not a BF issue - Look the demo code ImageGadget_BF.pb
; Declare CacheImageGadgetImage_BF(cache_image_gadget_image_, image_ID)

HideWindow(window_ID, 0)

Repeat
  win_event=WaitWindowEvent(0)
  
  If Delay_BF(1, 25)
    
    ; --- Text 9 ---
    ErrorCheck_BF(BF(1, text_2_ID, text_2_ID, -1, -1, output_x)) ; Scroll the sprite in it self
    
    output_x-2 : If output_x<-ImageWidth(text_2_ID) : output_x=0 : EndIf
    
    CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
      temporary_image_ID=GrabImage(text_2_ID, #PB_Any, 0, 16, GadgetWidth(gadget_9_ID), GadgetHeight(gadget_9_ID)-12)
    CompilerElse
      temporary_image_ID=GrabImage(text_2_ID, #PB_Any, 0, 28, GadgetWidth(gadget_9_ID), GadgetHeight(gadget_9_ID)-16)
    CompilerEndIf
    
    SetColorDistanceSpriteMask_BF(28) ; Add a BF sprite sheet to the text output
    Define frame_count
    ErrorCheck_BF(Sprite_CSS_sheet_BF(70, temporary_image_ID, sheet_1_ID,
                                      0,                              ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                      0,                              ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                      -output_x-500,                  ; Output position x
                                      3,                              ; Output position y
                                      GetGIFandCSS_Frames_BF(),       ; Numbers of frames
                                      frame_count,                    ; Selected frame - For GIF compatibility the first frame is 0
                                      GetGIFandCSS_Frame_width_BF(),  ; Frame width
                                      GetGIFandCSS_Frame_height_BF(), ; Frame height
                                      0,                              ; Frames in a row - Preset 0, then BF calculate self
                                      75,                             ; Resizing - Define the output width - Preset zero = without resizing 
                                      36))                            ; Resizing - Define the output height
    If Delay_BF(2, 55)
      frame_count+1 : If frame_count=GetGIFandCSS_Frames_BF()-1 : frame_count=0 : EndIf
      If alpha<1 Or alpha>256 : flip=1-flip : EndIf : If flip : alpha+16 : Else : alpha-16 : EndIf
    EndIf
    SetColorDistanceSpriteMask_BF(0)
    
    ; This function works with inheritance, parameters do not have to be set if nothing is to be changed
    SetImageGadget_BF(gadget_9_ID, temporary_image_ID)
    
    FreeImage_BF(temporary_image_ID)
    
    ; --- Text 10 ---
    ErrorCheck_BF(BF(1, text_3_ID, text_3_ID, -1, -1, 0, output_y)) ; Scroll the sprite in it self
    
    output_y-1 : If output_y<-ImageHeight(text_3_ID) : output_y=0 : EndIf
    
    CompilerIf #PB_Compiler_OS=#PB_OS_Linux
      temporary_image_ID=GrabImage(text_3_ID, #PB_Any, 4, 0, GadgetWidth(gadget_10_ID), GadgetHeight(gadget_10_ID)-12)
    CompilerElse
      temporary_image_ID=GrabImage(text_3_ID, #PB_Any, 0, 0, GadgetWidth(gadget_10_ID), GadgetHeight(gadget_10_ID)-12)
    CompilerEndIf
    
    SetColorDistanceSpriteMask_BF(28) ; Add a BF sprite to the text output
    ErrorCheck_BF(SpriteSimple_BF(1, temporary_image_ID, image_1_ID,
                                  0,   ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                                  0,   ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 
                                  10,  ; Output pos x
                                  0,   ; Output pos y
                                  60,  ; You can here resize the output x
                                  40,  ; You can here resize the output y
                                  80)) ; Set alpha blending from 2 to 256 - BF set 1=full visible - 256=invisible (BF specific)
    SetColorDistanceSpriteMask_BF(0)
    
    ; This function works with inheritance, parameters do not have to be set if nothing is to be changed
    SetImageGadget_BF(gadget_10_ID, temporary_image_ID)
    
    FreeImage_BF(temporary_image_ID)
    
    ; --- Text 11 ---
    ErrorCheck_BF(BF(1, text_4_ID, text_4_ID, -1, -1, 0, output_y_1)) ; Scroll and the sprite in it self
    
    output_y_1-3 : If output_y_1<-ImageHeight(text_4_ID) : output_y_1=0 : EndIf
    
    CompilerIf #PB_Compiler_OS=#PB_OS_Linux
      temporary_image_ID=GrabImage(text_4_ID, #PB_Any, 24, 0, GadgetWidth(gadget_11_ID)-9, GadgetHeight(gadget_11_ID)-5)
    CompilerElseIf #PB_Compiler_OS=#PB_OS_Windows
      temporary_image_ID=GrabImage(text_4_ID, #PB_Any, 21, 0, GadgetWidth(gadget_11_ID)-9, GadgetHeight(gadget_11_ID)-5)
    CompilerElse
      temporary_image_ID=GrabImage(text_4_ID, #PB_Any, 13, 0, GadgetWidth(gadget_11_ID)-9, GadgetHeight(gadget_11_ID)-5)
    CompilerEndIf
    
    ; This function works with inheritance, parameters do not have to be set if nothing is to be changed
    SetImageGadget_BF(gadget_11_ID, temporary_image_ID)
    
    FreeImage_BF(temporary_image_ID)
    
    ; --- Text 12 ---
    ErrorCheck_BF(BF(1, text_5_ID, text_5_ID, -1, -1, 0, output_y_2)) ; Scroll the sprite in it self
    
    output_y_2-3 : If output_y_2<-ImageHeight(text_5_ID) : output_y_2=0 : EndIf
    
    CompilerIf #PB_Compiler_OS=#PB_OS_Linux
      temporary_image_ID=GrabImage(text_5_ID, #PB_Any, 14, 0, GadgetWidth(gadget_12_ID)-15, GadgetHeight(gadget_12_ID))
    CompilerElseIf #PB_Compiler_OS=#PB_OS_Windows
      temporary_image_ID=GrabImage(text_5_ID, #PB_Any, 12, 0, GadgetWidth(gadget_12_ID)-9, GadgetHeight(gadget_12_ID))
    CompilerElse
      temporary_image_ID=GrabImage(text_5_ID, #PB_Any, 9, 0, GadgetWidth(gadget_12_ID)-12, GadgetHeight(gadget_12_ID))
    CompilerEndIf
    
    CompilerIf #PB_Compiler_Version=>560
      temporary_image_ID=CreateAlphaImage_from_Sprite_BF(temporary_image_ID,
                                                         0,     ; You can set a color distance for the mask color in percent
                                                         -1,    ; The hidden color from the mask - -1 grabb the sprite mask color from sprite pos x=0 / y=0 and set the resulted color to 0
                                                         alpha, ; Alpha blending - 1 is full visible - 256 invisible (BF specific)
                                                         1)     ; Set delete_old_image <>0 for deleting the source image after creating a new image
    CompilerEndIf
    
    ; This function works with inheritance, parameters do not have to be set if nothing is to be changed
    SetImageGadget_BF(gadget_12_ID, temporary_image_ID)
    
    FreeImage_BF(temporary_image_ID)
    
  EndIf
  
  Repeat ; Get all window events
    win_event=WaitWindowEvent(1)
    If win_event=#PB_Event_CloseWindow
      FreeTextures_BF() ; BF cache all used textures for highspeed sprite output
                        ; 0=give all free (Preset) - 1=Get amount cached textures - 2=Get required size for caching all textures in bytes
                        ; This refresh the cache and can so primary fix for your eyes strange animation problems
                        ; Temporary used textures free selective with the function Free_selected_Texture_BF, this is the recommended way
                        ; This function works also with PB sprites and canvas
                        ; Exit give free automatically all used textures
                        ; Works with all BF core function based functions - "Fast output" functions are not BF core based
      End
    EndIf
  Until Not win_event
  
ForEver
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 6
; FirstLine = 4
; Folding = ---
; EnableXP
; DPIAware
; Executable = ..\SpriteTool_BF.exe
; DisableDebugger