﻿; On-demand resize a window with a ImageGadget_BF - Image EXIF Data supported

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Global source_path_image$="./Image_Set/Sunset.jpg"

Define image_ID=LoadPhoto_BF(source_path_image$)

Global window_ID=OpenWindow(#PB_Any, 0, 0, 900*DPI_ResizeFactor_BF(), 600*DPI_ResizeFactor_BF() ,
                            "On-demand resizable Window and Image",
                            #PB_Window_SizeGadget|#PB_Window_ScreenCentered|#PB_Window_SystemMenu)

Define min_width=160
Define min_height=120
Define max_width=1600
Define max_height=1200

WindowBounds(window_ID, min_width, min_height, max_width, max_height)

; Create a pre resized image for fast on demand resizing also very large source images
Define resized_image_ID=FitImage_BF(1, image_ID, 1200, 900)

Define x=10                              ; Output pos x
Define y=10                              ; Output pos y
Define padding=20                        ; Padding - Deactivate with -1
Define width=WindowWidth(window_ID)-20   ; Fit image to this width
Define height=WindowHeight(window_ID)-20 ; Fit image to this height
Define background_color=$FFFF            ; Background color - For a invisible background set background_color=-2
Define grid_color=$DCDCDC                ; Grid color
Define grid_size=10                      ; Grid size
Define grid_tiling=10                    ; Grid tiling
Define frame_color=$FF                   ; Frame color
Define frame_size=3                      ; Frame size
Define flags=0                           ; #PB_Image_Raised - #PB_Image_Border - Frame flags

Global ImageGadget_BF_1_ID=ImageGadget_BF(resized_image_ID,
                                          x,
                                          y,
                                          width,
                                          height,
                                          background_color,
                                          padding,
                                          grid_color,
                                          grid_size,
                                          grid_tiling,
                                          frame_color,
                                          frame_size,
                                          flags)

Procedure WindowResizing_BindEvent_1()
  ResizeGadget_BF(ImageGadget_BF_1_ID, -1, -1, WindowWidth(window_ID)-20, WindowHeight(window_ID)-20)
EndProcedure
BindEvent(#PB_Event_SizeWindow, @WindowResizing_BindEvent_1())

Repeat
  Define win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    ; =============================== Bye ====================================
    FreeGadget_BF(ImageGadget_BF_1_ID)     ; This function free a Gadget_BF with all resources
                                           ; You can free Gadgets_B, but you must not
    If FreeAllGadgets_bf(1)                ; After releasing you can check if all have been released
      MessageRequester("Warning", "You haven't released all the gadgets BF"+#LF$+#LF$+
                                  "Not released : "+Str(FreeAllGadgets_bf(1)))
    EndIf
    End
  EndIf
ForEver

; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableXP