﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

UsePNGImageDecoder()
UsePNGImageEncoder()
UseJPEGImageDecoder()
UseTIFFImageDecoder()
CompilerIf #PB_Compiler_Version=>560
  UseGIFImageDecoder()
CompilerEndIf

EnableExplicit

ExamineDesktops()

Define source_ID, win_event

Define path$=OpenFileRequester("Select a image", "", "", 0)
If path$="" : End : EndIf

source_ID=LoadImage(#PB_Any, path$)

Define window_width=ImageWidth(source_ID)
Define window_height=ImageHeight(source_ID)

If window_width>DesktopWidth(0)-150: window_width=DesktopWidth(0)-150 : EndIf
If window_height>DesktopHeight(0)-150: window_height=DesktopHeight(0)-150 : EndIf

Define image_width=ImageWidth(source_ID)
Define image_height=ImageHeight(source_ID)

; --- Calculate the needed output window and temporary image ---
If image_width>window_width Or image_height>window_height ; Calculate a proportional resized output - Tipp : Look for ORBO GIF
  GetFitSize_BF(image_width, image_height, window_width, window_height)
  Define output_width=GetFitSize_Width_BF() ; Give back the calculated proportional width for the fitted output
  Define output_height=GetFitSize_Height_BF() ; Give back the calculated proportional height for the fitted output
Else
  output_width=image_width
  output_height=image_height
EndIf

If image_width<400 : image_width=400 : EndIf
If image_height<250 : image_height=250 : EndIf

ResizeImage(source_ID, output_width, output_height)

Define window_ID=OpenWindow(#PB_Any, 0, 0, window_width+140, window_height+80, "GFX_Wizzard_BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, window_width+140, window_height+80)

Define change_red.f=70 ; Add more red for demonstrating
Define change_green.f=0
Define change_blue.f=0
Define change_contrast.f=0
Define change_brightness.f=0
Define change_intensity.f=0
Define mode_grey=0
Define mode=0
Define sprite_mode=0

; This function change the brightness, color, contrast - The function works with images, PB sprites, canvas
; The parameters are percent based - positive and negative values
; Source and destination must have the same size
; mode 0 = without creating a new output - mode 1 create a image - mode 2 create a PB sprite
; sprite_mode - Same PB function call for PB sprite creating
; Tree grey modes available mode=1, mode=2, mode=3 - mode=1 is more neutral
Image_coloring_BF(source_ID, source_ID,
                  change_red,
                  change_green,
                  change_blue,
                  change_contrast,
                  change_brightness,
                  change_intensity,
                  mode_grey,
                  mode,
                  sprite_mode)

StartDrawing(CanvasOutput(canvas_ID))
Box(0,0, window_width+140, window_height+80, $808080)
StopDrawing()

CopyContent_Image_Canvas_BF(source_ID, canvas_ID, GetFitOffset_X_BF()+70, GetFitOffset_Y_BF()+40)
Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    
    End
  EndIf
ForEver
; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 45
; FirstLine = 30
; Folding = -
; EnableXP
; DisableDebugger