﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Write the color distance value to a file - As sample to a jpeg based sprite
; And remove a old value before write a new
; On sprite sheets color distance info is automatically included directly in the sheet data

EnableExplicit

Define color_distance=20

If MessageRequester("Hint", "Are you sure ?"+#LF$+#LF$+
                            "This change the file",
                    #PB_MessageRequester_YesNo)<>#PB_MessageRequester_Yes
  End
EndIf

Define path$=OpenFileRequester("Select a file to add a color distance value", "", "", 0)
If path$="" : End : EndIf

Define result=ReadColorDistanceValue_BF(path$)

Debug result ; OK = 1 - Fail = a negative value

; BF Error values
; Fail reading = -21
;  Fail writen = -22
;           OK =   1

Debug "---"

If result>-1
  Debug  RemoveColorDistanceValue_BF(path$) ; OK = 1 - Fail = a negative value
EndIf

Debug WriteColorDistanceValue_BF(path$, color_distance) ; OK = 1 - Fail = 0 a negative value

Debug "---"

Debug ReadColorDistanceValue_BF(path$) ; OK = 1 - Fail = a negative value

; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 14
; FirstLine = 6
; EnableXP