﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Demo - Migrate a ButtonImageGadget PB to a ButtonImageGadget_BF & FadeIn > FadeOut demo
; Click the Button
EnableExplicit

Activate_DPI_aware_BF(1) ; This activate DPI_aware

Define button_width=350
Define button_height=350
Define background_color=#Blue
Define padding_x=16
Define padding_y=5
Define button_flag=0
Define overlay_color=#Blue
Define animation_delay=6
Define animation_alpha_step=9

Define image_a_ID=LoadImage(#PB_Any, "./Image_Set/RustySteel.jpg")
Define image_b_ID=LoadImage(#PB_Any, "./Image_Set/Foxy.png")

ResizeImage(image_a_ID, button_width, button_height)

Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 600, "FadeIn and FadeOut Demo with ButtonImageGadget_BF - Migrate a Gadget PB to a Gadget_BF", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)

StartDrawing(ImageOutput(image_a_ID))
DrawingMode(#PB_2DDrawing_Transparent)
DrawText_BF(20, 20, "GFX WIZZARD BF"+#LF$+"Simple a little more"+#LF$+#LF$+"Klick this image")
StopDrawing()

Define x_pos=WindowWidth(window_ID)/2-button_width/2
Define y_pos=WindowHeight(window_ID)/2-button_height/2

; Create ButtonImageGadget PB
Define button_image_gadget_1_ID=ButtonImageGadget(#PB_Any,
                                                  x_pos,
                                                  y_pos,
                                                  button_width,
                                                  button_height,
                                                  ImageID(image_a_ID))

; Migrate a ButtonImageGadget PB to a ButtonImageGadget_BF

FitImageActivateUpscaling_BF(1) ; Add to the FitImage functions a automatically upscaling for little images, as sample also for ColorButtonGadget_BF, TextGadget_BF, ImageGadget_BF

button_image_gadget_1_ID=ButtonImageGadget_BF(image_a_ID,
                                              background_color,
                                              -2,                       ; Replace x_pos with -2
                                              button_image_gadget_1_ID, ; Replace y_pos with the PB Gadget ID
                                              button_width,
                                              button_height,
                                              padding_x,
                                              padding_y,
                                              button_flag)

FitImageActivateUpscaling_BF(1) ; Add to the FitImage functions a automatically upscaling for little images, as sample also for ColorButtonGadget_BF, TextGadget_BF, ImageGadget_BF

If Not IsGadget(button_image_gadget_1_ID) ; You can check the result >0 is OK
  MessageRequester("ERROR", "Can not create a Gadget_BF")
  End
EndIf

Repeat
  Define win_event=WaitWindowEvent()
  
  If win_event=#PB_Event_Gadget
    
    Select EventGadget()
      Case button_image_gadget_1_ID
        
        SetButtonImageGadget_BF_AutoFade_BF(button_image_gadget_1_ID,
                                            image_a_ID,
                                            image_b_ID,
                                            background_color,
                                            overlay_color,
                                            animation_delay,
                                            animation_alpha_step)
        
    EndSelect
  EndIf
  
Until win_event=#PB_Event_CloseWindow

FreeGadget_BF(button_image_gadget_1_ID) ; Free all used resources
                                        ; Ending the thread free automatically all resources, so you must not free a Gadget_BF

; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 56
; FirstLine = 49
; EnableXP
; DPIAware