﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Demo - Migrate a ImageGadget PB to a ImageGadget_BF

EnableExplicit

Activate_DPI_aware_BF(1) ; This activate DPI_aware

Define button_width=450
Define button_height=300

Define image_ID=LoadImage(#PB_Any, "./Image_Set/Foxy.png")

Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 600, "Migrate a Gadget PB to a Gadget_BF", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
SetWindowColor(window_ID, $808080)

Define x_pos=WindowWidth(window_ID)/2-button_width/2
Define y_pos=WindowHeight(window_ID)/2-button_height/2

; Create a ImageGadget PB
Define button_gadget_1_ID=ImageGadget(#PB_Any,
                                      x_pos,
                                      y_pos,
                                      button_width,
                                      button_height,
                                      0)

; Migrate the ImageGadget PB to a ImageGadget_BF

FitImageActivateUpscaling_BF(1) ; Add to the FitImage functions a automatically upscaling for little images, as sample also for ColorButtonGadget_BF, TextGadget_BF, ImageGadget_BF

button_gadget_1_ID=ImageGadget_BF(image_ID,
                                  -2,                 ; Replace x_pos with -2
                                  button_gadget_1_ID) ; Replace y_pos with the PB Gadget ID

FitImageActivateUpscaling_BF(0) ; Add to the FitImage functions a automatically upscaling for little images, as sample also for ColorButtonGadget_BF, TextGadget_BF, ImageGadget_BF
If Not IsGadget(button_gadget_1_ID) ; You can check the result >0 is OK
  MessageRequester("ERROR", "Can not create a Gadget_BF")
  End
EndIf

Repeat
  Define win_event=WaitWindowEvent()
  
  If win_event=#PB_Event_Gadget
    
    Select EventGadget()
      Case button_gadget_1_ID
        
    EndSelect
    
  EndIf
  
Until win_event=#PB_Event_CloseWindow

FreeGadget_BF(button_gadget_1_ID) ; Free all used resources
                                  ; Ending the thread free automatically all resources, so you must not free a Gadget_BF

; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 7
; EnableXP
; DPIAware