﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Progressbar_BF using  - DPI aware

; Look in the Wizzard declare part or on Progressbar_BF demo code 1 or 2 for parameter descriptions

EnableExplicit

Define win_event, canvas_ID, canvas_Bar_ID, font_1_ID, image_ID, i, i_1, i_2, i_3, i_4, i_5, i_6

CompilerIf #PB_Compiler_OS=#PB_OS_Windows : font_1_ID=LoadFont(#PB_Any, "Arial", 11) : CompilerEndIf ; Select a suitable font
CompilerIf #PB_Compiler_OS=#PB_OS_Linux : font_1_ID=LoadFont(#PB_Any, "Arial", 10) : CompilerEndIf
CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : font_1_ID=LoadFont(#PB_Any, "Arial", 14) : CompilerEndIf

OpenWindow(0, #PB_Ignore, #PB_Ignore, 650, 420, "ProgressBar_BF - Simple create Progressbars as Canvas Gadgets or images", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
SetWindowColor(0, $909090)
AddWindowTimer(0, 1, 40) ; You can change

canvas_ID=CanvasGadget(#PB_Any, 380, 55, 200, 305) ; For output bars as image

Define Bar_0=ProgressBarGadget(#PB_Any, 70, 55, 250, 25, 0, 100)
Define Bar_1=ProgressBarGadget(#PB_Any, 70, 100, 50, 200, 0, 100, #PB_ProgressBar_Vertical) ; OS Progressbars with custom output
Define Bar_2=ProgressBarGadget(#PB_Any, 50, 320, 295, 40, 0, 100)
Define Bar_3=ProgressBarGadget(#PB_Any, 170, 100, 50, 200, 0, 100, #PB_ProgressBar_Vertical) ; The vertical flag, you can, but you must not set
Define Bar_4=ProgressBarGadget(#PB_Any, 270, 100, 50, 200, 0, 100, #PB_ProgressBar_Vertical) ; The SetGadgetState_Progressbar_BF call set the vertical flag, more is not needed
Define Bar_5=ProgressBarGadget(#PB_Any, 140, 380, 360, 20, 0, 100)
Define Bar_6=ProgressBarGadget(#PB_Any, 240, 10, 200, 25, 0, 100)
Define Bar_7=ProgressBarGadget(#PB_Any, 0, 0, 30, 250, 0, 100, #PB_ProgressBar_Vertical)    ; Hidden Progressbar with output as image
Define Bar_8=ProgressBarGadget(#PB_Any, 0, 0, 30, 240, 0, 100, #PB_ProgressBar_Vertical)    ; Hidden Progressbar with output as image

; This function calculate a pixel based slider position from a Progressbar_BF for text positioning
; Debug Calculate_SliderPos_Progressbar_BF(Bar_0, 70, #PB_ProgressBar_Horizontal)

HideWindow(0, 0)

Repeat
  If win_event=#PB_Event_Timer And EventTimer()=1
    i_1=(i_1+1)%201 : i_2+0.6 : If i_2>100 : i_2=0 : EndIf : i_3=(i_3+2)%102
    i_4+1.3 : If i_4>100 : i_4=0 : EndIf : i_5=(i_5+1)%101 : i_6=(i_6+1)%101
    
    For i=0 To 1 ; Speed up *2
      CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
        SetFrontText_0_Progressbar_BF("Please wait" ,89 ,1, 0, 0, 180, font_1_ID) ; Add text
      CompilerElse
        SetFrontText_0_Progressbar_BF("Please wait" ,88 ,4, 0, 0, 180, font_1_ID) ; Add text
      CompilerEndIf
      SetGadgetState_Progressbar_BF(Bar_0, #PB_ProgressBar_Unknown, #PB_ProgressBar_Horizontal, 2, #Green, $E6E6E6, -1, 2, $AAAAAA) ; Replace the OS progressbar #0  
    Next
    
    If i_1>100
      For i=0 To 1 ; Speed up *2
        SetGadgetState_Progressbar_BF(Bar_1, #PB_ProgressBar_Unknown, #PB_ProgressBar_Vertical, 2, #Green, $E6E6E6, $228B22, 4, $AAAAAA) ; Replace the OS progressbar #1
      Next 
    Else
      SetGadgetState_Progressbar_BF(Bar_1, i_1, #PB_ProgressBar_Vertical, 0, #Green, $E6E6E6, $228B22, 4, $6BB7BD, 10) ; Replace the OS progressbar #1
    EndIf
    If i_2>30
      Set_DividingLine_Progressbar_BF(i_2, #Red, 100) ; Set a dividing line on a Progressbar_BF - -1 is presetted for ignore
    Else
      Set_DividingLine_Progressbar_BF(30, #Red, 100) ; Set a dividing line on a Progressbar_BF - -1 is presetted for ignore
    EndIf
    SetFrontText_0_Progressbar_BF(Str(i_2)+"%", Calculate_SliderPos_Progressbar_BF(Bar_2, i_2, #PB_ProgressBar_Horizontal)+7, 20, 0, 0, 0, font_1_ID) ; Add text
    If i_2>60
      canvas_Bar_ID=SetGadgetState_Progressbar_BF(Bar_2, i_2, #PB_ProgressBar_Remove, 2, $FFBF00, $E6E6E6, 0, 3, $AAAAAA) ; Replace the OS progressbar #2
      If i_2<51 : HideGadget(Bar_2, 1) : Else : HideGadget(Bar_2, 0) : EndIf
    Else
      canvas_Bar_ID=SetGadgetState_Progressbar_BF(Bar_2, i_2, #PB_ProgressBar_Horizontal, 2, $FFBF00, $E6E6E6, 0, 1, $AAAAAA) ; Replace the OS progressbar #2
    EndIf
    
    If i_3>69
      CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
        SetFrontText_0_Progressbar_BF("ALERT" ,4 ,85, 0, 0, 0, font_1_ID) ; Add text
      CompilerElse
        SetFrontText_0_Progressbar_BF("ALERT" ,2 ,85, 0, 0, 0, font_1_ID) ; Add text
      CompilerEndIf
      SetGadgetState_Progressbar_BF(Bar_3, i_3, #PB_ProgressBar_Vertical, 2, #Red, $AAAAAA, $2222B2, 7, $6BB7BD) ; Replace the OS progressbar #3
    ElseIf i_3>40 And i_3<70
      SetGadgetState_Progressbar_BF(Bar_3, i_3, #PB_ProgressBar_Vertical, 2, #Yellow, $AAAAAA, $20A5DA, 7, $6BB) ; Replace the OS progressbar #3
    Else
      SetGadgetState_Progressbar_BF(Bar_3, i_3, #PB_ProgressBar_Vertical, 2, #Green, $AAAAAA, $228B22, 7, $6BB7BD) ; Replace the OS progressbar #3
    EndIf
    
    CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
      SetFrontText_0_Progressbar_BF(RSet(Str(i_4), 3, "  ")+"%", 8, 175, 0, #Black, 150, font_1_ID) ; Add text
    CompilerElse
      SetFrontText_0_Progressbar_BF(RSet(Str(i_4), 3, "  ")+"%", 7, 180, 0, #Black, 150, font_1_ID) ; Add text
    CompilerEndIf
    If i_4<60
      SetFrontText_1_Progressbar_BF("Too"+#LF$+"little"+#LF$+"water" ,5 ,70-i_4, 0, #Red, 0, SysFontBold_BF) ; Add text
    Else
      SetFrontText_1_Progressbar_BF("Water"+#LF$+"OK" ,0 ,180-i_4, 0, #Green, 0, SysFontBold_BF) ; Add text
    EndIf
    SetGadgetState_Progressbar_BF(Bar_4, i_4, #PB_ProgressBar_Vertical, 2, $FFFF00, #Yellow, #Blue) ; Replace the OS progressbar #4
    
    If i_5=30 : ResizeGadget(Bar_5, 60, #PB_Ignore, 100, 15) : EndIf
    If i_5=60 : ResizeGadget(Bar_5, 120, #PB_Ignore, 150, 15) : EndIf
    If i_5=80 : ResizeGadget(Bar_5, 140, #PB_Ignore, 360, 20) : EndIf
    
    SetGadgetState_Progressbar_BF(Bar_5, i_5, #PB_ProgressBar_Horizontal, 2, #Green, $E6E6E6, #Red, 4, $AAAAAA) ; Replace the OS progressbar #5
    
    If i_6>50 
      CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
        SetFrontText_0_Progressbar_BF(Str(i_6)+"%" ,6 ,1, 0, 0, 150, font_1_ID) ; Add text
      CompilerElse
        SetFrontText_0_Progressbar_BF(Str(i_6)+"%" ,5 ,4, 0, 0, 150, font_1_ID) ; Add text
      CompilerEndIf
    EndIf
    SetGadgetState_Progressbar_BF(Bar_6, i_6, #PB_ProgressBar_Horizontal, 2, $FFFF00, $CCCCCC, $FF0000) ; Replace the OS progressbar #6
    
    ; Output a progressbar as image - So you can post process how ever you want
    ; Progressbar_BF() self free a created image before a next creating
    image_ID=SetGadgetState_Progressbar_BF(Bar_7, i_6, #PB_ProgressBar_Vertical, -1, $FFFF00, $CCCCCC, -1, 3, #Blue) ; Replace the OS progressbar #7 
    If IsImage(image_ID)
      StartDrawing(CanvasOutput(canvas_ID))
      DrawImage(ImageID(image_ID), 10*DPI_ResizeFactor_BF(), 25*DPI_ResizeFactor_BF())
      StopDrawing()
    EndIf
    
    ; Output a progressbar as image - So you can post process how ever you want
    ; Progressbar_BF() self free a created image before a next creating
    ; Look in the Wizzard declare part for parameter description
    image_ID=SetGadgetState_Progressbar_BF(Bar_8, i_6, #PB_ProgressBar_Vertical, -1, $578B2E, $CCCCCC, #Green, 1, #Blue) ; Replace the OS progressbar #8 
    If IsImage(image_ID)
      StartDrawing(CanvasOutput(canvas_ID))
      DrawImage(ImageID(image_ID), 85*DPI_ResizeFactor_BF(), 25*DPI_ResizeFactor_BF())
      DrawImage(ImageID(image_ID), 155*DPI_ResizeFactor_BF(), 25*DPI_ResizeFactor_BF(), 30*DPI_ResizeFactor_BF(), 90*DPI_ResizeFactor_BF())
      DrawImage(ImageID(image_ID), 160*DPI_ResizeFactor_BF(), 125*DPI_ResizeFactor_BF(), 20*DPI_ResizeFactor_BF(), 150*DPI_ResizeFactor_BF())
      StopDrawing()
    EndIf
  EndIf
  
  win_event=WaitWindowEvent(1)
Until win_event=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 133
; FirstLine = 101
; Folding = --
; EnableXP
; DPIAware