﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

; Progressbar_BF using  - DPI aware

; Look in the Wizzard declare part or on Progressbar_BF demo code 1 or 2 for parameter descriptions

EnableExplicit

Activate_DPI_aware_BF(1)

Define win_event, canvas_ID, canvas_Bar_ID, font_1_ID, image_ID, i, i_1, i_2, i_3, i_4, i_5, i_6

CompilerIf #PB_Compiler_OS=#PB_OS_Windows : font_1_ID=LoadFont(#PB_Any, "Arial", 11) : CompilerEndIf ; Select a suitable font
CompilerIf #PB_Compiler_OS=#PB_OS_Linux : font_1_ID=LoadFont(#PB_Any, "Arial", 10) : CompilerEndIf
CompilerIf #PB_Compiler_OS=#PB_OS_MacOS : font_1_ID=LoadFont(#PB_Any, "Arial", 14) : CompilerEndIf

OpenWindow(0, #PB_Ignore, #PB_Ignore, 650, 420, "ProgressBar_BF - Simple create Progressbars as Canvas Gadgets or images", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
SetWindowColor(0, $909090)
AddWindowTimer(0, 1, 40) ; You can change

canvas_ID=CanvasGadget(#PB_Any, 380, 55, 200, 305) ; For output bars as image

Define Bar_0=ProgressBarGadget(#PB_Any, 70, 55, 250, 25, 0, 100)
Define Bar_1=ProgressBarGadget(#PB_Any, 70, 100, 50, 200, 0, 100, #PB_ProgressBar_Vertical) ; OS Progressbars with custom output
Define Bar_2=ProgressBarGadget(#PB_Any, 50, 320, 295, 40, 0, 100)
Define Bar_3=ProgressBarGadget(#PB_Any, 170, 100, 50, 200, 0, 100, #PB_ProgressBar_Vertical) ; The vertical flag, you can, but you must not set
Define Bar_4=ProgressBarGadget(#PB_Any, 270, 100, 50, 200, 0, 100, #PB_ProgressBar_Vertical) ; The SetGadgetState_Progressbar_BF call set the vertical flag, more is not needed
Define Bar_5=ProgressBarGadget(#PB_Any, 140, 380, 360, 20, 0, 100)
Define Bar_6=ProgressBarGadget(#PB_Any, 240, 10, 200, 25, 0, 100)
Define Bar_7=ProgressBarGadget(#PB_Any, 0, 0, 30, 250, 0, 100, #PB_ProgressBar_Vertical) ; Hidden Progressbar with output as image
Define Bar_8=ProgressBarGadget(#PB_Any, 0, 0, 30, 240, 0, 100, #PB_ProgressBar_Vertical) ; Hidden Progressbar with output as image

Define texture_0_ID=LoadImage(#PB_Any, "./Image_Set/Sunset.jpg")
; Fill the colored backgrounds with textures
ErrorCheck_BF(BucketFill_BF(-100, canvas_ID, texture_0_ID,
                            -1,       ; Grab transparence color from sprite pos x - For preset set ..x=-1  
                            $FFFFFF,  ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF 
                            -450*DPI_ResizeFactor_BF(),
                            -100*DPI_ResizeFactor_BF()))

Create_animation_buffers_BF(canvas_ID, 0) ; Init animation buffers - triple buffering - Flicker free animation

Get_animation_buffer_hidden_image_ID_BF(0)

HideWindow(0, 0)
Repeat
  If win_event=#PB_Event_Timer And EventTimer()=1
    i_1=(i_1+1)%201 : i_2+0.6 : If i_2>100 : i_2=0 : EndIf : i_3=(i_3+2)%102
    i_4+1.3 : If i_4>100 : i_4=0 : EndIf : i_5=(i_5+1)%101 : i_6=(i_6+1)%101
    
    For i=0 To 1 ; Speed up *2
      CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
        SetFrontText_0_Progressbar_BF("Please wait" ,89 ,1, 0, 0, 180, font_1_ID) ; Add text
      CompilerElse
        SetFrontText_0_Progressbar_BF("Please wait" ,88 ,4, 0, 0, 180, font_1_ID) ; Add text
      CompilerEndIf
      SetGadgetState_Progressbar_BF(Bar_0, #PB_ProgressBar_Unknown, #PB_ProgressBar_Horizontal, 2, $FF00, $E6E6E6, -1, 2, $AAAAAA) ; Replace the OS progressbar #0  
    Next
    
    If i_1>100
      For i=0 To 1 ; Speed up *2
        SetGadgetState_Progressbar_BF(Bar_1, #PB_ProgressBar_Unknown, #PB_ProgressBar_Vertical, 2, $FF00, $E6E6E6, $228B22, 4, $AAAAAA) ; Replace the OS progressbar #1
      Next 
    Else
      SetGadgetState_Progressbar_BF(Bar_1, i_1, #PB_ProgressBar_Vertical, 2, $FF00, $E6E6E6, $FF, 4, $6BB7BD) ; Replace the OS progressbar #1
    EndIf
    
    If i_2>50
      canvas_Bar_ID=SetGadgetState_Progressbar_BF(Bar_2, i_2, #PB_ProgressBar_Remove, 2, $FFBF00, $E6E6E6, 0, 3, $AAAAAA) ; Replace the OS progressbar #2
      If i_2<51 : HideGadget(Bar_2, 1) : Else : HideGadget(Bar_2, 0) : EndIf
    Else
      canvas_Bar_ID=SetGadgetState_Progressbar_BF(Bar_2, i_2, #PB_ProgressBar_Horizontal, 2, $FFBF00, $E6E6E6, 0, 1, $AAAAAA) ; Replace the OS progressbar #2
    EndIf
    
    ScaleVectorWidth_BF(0.8) ; This functions can change the SetGadgetState_Progressbar_BF() text output size
    ScaleVectorHeight_BF(0.9)
    
    If i_3>69
      CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
        SetFrontText_0_Progressbar_BF("ALERT" ,10 ,85, 0, 0, 0, font_1_ID) ; Add text
      CompilerElse
        SetFrontText_0_Progressbar_BF("ALERT" ,8 ,85, 0, 0, 0, font_1_ID) ; Add text
      CompilerEndIf
      SetGadgetState_Progressbar_BF(Bar_3, i_3, #PB_ProgressBar_Vertical, 2, $FF, $AAAAAA, $2222B2, 7, $6BB7BD) ; Replace the OS progressbar #3
    ElseIf i_3>40 And i_3<70
      SetGadgetState_Progressbar_BF(Bar_3, i_3, #PB_ProgressBar_Vertical, 2, $FFFF, $AAAAAA, $20A5DA, 7, $6BB) ; Replace the OS progressbar #3
    Else
      SetGadgetState_Progressbar_BF(Bar_3, i_3, #PB_ProgressBar_Vertical, 2, $FF00, $AAAAAA, $228B22, 7, $6BB7BD) ; Replace the OS progressbar #3
    EndIf
    
    ScaleVectorWidth_BF() ; Deactivate again
    ScaleVectorHeight_BF()
    
    CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
      SetFrontText_0_Progressbar_BF(RSet(Str(i_4), 3, "  ")+"%", 8, 175, 0, #Black, 150, font_1_ID) ; Add text
    CompilerElse
      SetFrontText_0_Progressbar_BF(RSet(Str(i_4), 3, "  ")+"%", 7, 180, 0, #Black, 150, font_1_ID) ; Add text
    CompilerEndIf
    If i_4>20 And i_4<70
      SetFrontText_1_Progressbar_BF("Tank"+#LF$+"fill" ,3 ,20, 0, #Yellow, 0, SysFontBold_BF) ; Add text
    EndIf
    
    SetFrontText_2_Progressbar_BF(" " ,0 ,60, 0, #Green, 80)   ; Add dividing line
    SetFrontText_3_Progressbar_BF(" " ,0 ,110, 0, #Yellow, 80) ; Add dividing line
    SetFrontText_4_Progressbar_BF(" " ,0 ,160, 0, #Red, 80)    ; Add dividing line
    
    SetGadgetState_Progressbar_BF(Bar_4, i_4, #PB_ProgressBar_Vertical, 2, $FFFF00, $6BB7, $FF0000) ; Replace the OS progressbar #4
    
    If i_5=30 : ResizeGadget(Bar_5, 60, #PB_Ignore, 100, 15) : EndIf
    If i_5=60 : ResizeGadget(Bar_5, 120, #PB_Ignore, 150, 15) : EndIf
    If i_5=80 : ResizeGadget(Bar_5, 140, #PB_Ignore, 360, 20) : EndIf
    
    SetGadgetState_Progressbar_BF(Bar_5, i_5, #PB_ProgressBar_Horizontal, 2, $FF00, $E6E6E6, $0045FF, 4, $AAAAAA, 30) ; Replace the OS progressbar #5
    
    If i_6>50 
      CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
        SetFrontText_0_Progressbar_BF(Str(i_6)+"%" ,6 ,1, 0, 0, 150, font_1_ID) ; Add text
      CompilerElse
        SetFrontText_0_Progressbar_BF(Str(i_6)+"%" ,5 ,4, 0, 0, 150, font_1_ID) ; Add text
      CompilerEndIf
      SetGadgetState_Progressbar_BF(Bar_6, i_6, #PB_ProgressBar_Horizontal, 2, $FFFF00, $CCCCCC, $FF0000, -1) ; Replace the OS progressbar #6
    Else
      SetGadgetState_Progressbar_BF(Bar_6, i_6, #PB_ProgressBar_Horizontal, 2, $FFFF00, $CCCCCC, $FF0000, 3) ; Replace the OS progressbar #6
    EndIf
    
    FlipBuffers_BF(0) ; This works similar the PB FlipBuffers function
    
    ; Output a progressbar as image - So you can post process how ever you want
    ; Progressbar_BF() self free a created image before a next creating
    image_ID=SetGadgetState_Progressbar_BF(Bar_7, i_6, #PB_ProgressBar_Vertical, -2, #Green, $E6E6E6, #Red, 2, $AAAAAA) ; Replace the OS progressbar #7 
    If IsImage(image_ID)
      StartDrawing(ImageOutput(Get_animation_buffer_hidden_image_ID_BF(0)))
      DrawImage(ImageID(image_ID), 10*DPI_ResizeFactor_BF(), 25*DPI_ResizeFactor_BF())
      StopDrawing()
    EndIf
    
    image_ID=SetGadgetState_Progressbar_BF(Bar_8, i_6, #PB_ProgressBar_Vertical, -1, $578B2E, $CCCCCC, #Green, 1, #Blue) ; Replace the OS progressbar #8 
    If IsImage(image_ID)
      StartDrawing(ImageOutput(Get_animation_buffer_hidden_image_ID_BF(0)))
      DrawImage(ImageID(image_ID), 160*DPI_ResizeFactor_BF(), 125*DPI_ResizeFactor_BF(), 20*DPI_ResizeFactor_BF(), 150*DPI_ResizeFactor_BF())
      StopDrawing()
      
      ErrorCheck_BF(SpriteSimple_fast_BF(-120, Get_animation_buffer_hidden_image_ID_BF(0), image_ID,
                                         0,                        ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                         0,                        ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                         85*DPI_ResizeFactor_BF(), ; Output position x
                                         30*DPI_ResizeFactor_BF(), ; Output position y
                                         0,                        ; Resizing - Define the output width - Preset zero = without resizing 
                                         0))                       ; Resizing - Define the output height
                                                                   ; Also clipping parameters available
                                                                   ; mode 0 = Without invisible color
                                                                   ; mode 1 > 256 = With invisible color and with alpha blending
                                                                   ; mode -1 > -256 = Without invisible color and with alpha blending
      
      ErrorCheck_BF(SpriteSimple_fast_BF(-150, Get_animation_buffer_hidden_image_ID_BF(0), image_ID,
                                         0,                         ; Grab transparence color from sprite pos x - For preset set ..x=-1                         
                                         0,                         ; Grab transparence color from sprite pos y - For preset set ..y= the color you want - as sample $FF00FF  
                                         155*DPI_ResizeFactor_BF(), ; Output position x
                                         25*DPI_ResizeFactor_BF(),  ; Output position y
                                         30*DPI_ResizeFactor_BF(),  ; Resizing - Define the output width - Preset zero = without resizing 
                                         90*DPI_ResizeFactor_BF())) ; Resizing - Define the output height
                                                                    ; Also clipping parameters available
                                                                    ; mode 0 = Without invisible color
                                                                    ; mode 1 > 256 = With invisible color and with alpha blending
                                                                    ; mode -1 > -256 = Without invisible color and with alpha blending 
    EndIf 
  EndIf
  CopyContent_Image_Canvas_BF(Get_animation_buffer_hidden_image_ID_BF(0), canvas_ID) ; Put the hidden animation buffer in the canvas
  win_event=WaitWindowEvent(1)
Until win_event=#PB_Event_CloseWindow
Free_animation_buffers_BF(0) ; Free animation buffers
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 14
; FirstLine = 10
; Folding = --
; EnableXP
; DPIAware
; DisableDebugger