﻿; Reduce a sprite mask demo

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

OpenWindow(1, 0, 0, 800, 600, "Reduce a sprite mask",  #PB_Window_SystemMenu | #PB_Window_ScreenCentered )

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, 800, 600)

Define image_0_ID=CreateImage(#PB_Any, 300, 300, 24, $FF00FF)
StartDrawing(ImageOutput(image_0_ID))
Circle(150, 150, 100, $FF)
StopDrawing()

Define image_1_ID=CreateImage(#PB_Any, 300, 300, 24, $FFFF00)
StartDrawing(ImageOutput(image_1_ID))
Circle(150, 150, 100, $FF)
StopDrawing()

If IsImage(image_0_ID)
  StartDrawing(CanvasOutput(canvas_ID))
  DrawImage(ImageID(image_0_ID), 0, 0)
  StopDrawing()
EndIf

If IsImage(image_1_ID)
  StartDrawing(CanvasOutput(canvas_ID))
  DrawImage(ImageID(image_1_ID), 500, 0)
  StopDrawing()
EndIf

While WindowEvent() : Wend
Delay(500)

 Define border=10
 Define ColorDistance=0 ; Try 0 and 20
 Define delete_source_ID=1

image_0_ID=ReduceSpriteMask_BF(image_0_ID, border, ColorDistance, delete_source_ID)
 
image_1_ID=ReduceSpriteMask_BF(image_1_ID, border, ColorDistance, delete_source_ID)
 
If IsImage(image_0_ID)
  StartDrawing(CanvasOutput(canvas_ID))
  DrawImage(ImageID(image_0_ID), 0, 350)
  StopDrawing()
EndIf

If IsImage(image_1_ID)
  StartDrawing(CanvasOutput(canvas_ID))
  DrawImage(ImageID(image_1_ID), GadgetWidth(canvas_ID)-ImageWidth(image_1_ID), 350)
  StopDrawing()
EndIf

While WaitWindowEvent()<>#PB_Event_CloseWindow : Wend
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 6
; EnableXP