﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; Scrolling demo - Create and scroll a isometric patterned background - simple

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf
Define texture_ID, output_x, output_y, win_event
Define window_ID=OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 700, 500, "Scrolling Demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
Define canvas_ID=CanvasGadget(#PB_Any, 50, 50, 600, 400) ; Create a canvas for output

Macro create_sprite
  If IsImage(texture_ID) : FreeImage(texture_ID) : EndIf
  texture_ID=CreateImage(#PB_Any, Random(300, 10), Random(300, 10), 24, $FF0000)
  StartDrawing(ImageOutput(texture_ID))
  LineXY(0, 0, ImageWidth(texture_ID), ImageHeight(texture_ID), $FFFFFF)
  LineXY(0, ImageHeight(texture_ID), ImageWidth(texture_ID), 0, $FFFFFF)
  StopDrawing()
EndMacro
create_sprite

Repeat
  If Delay_BF(1, 3000) : create_sprite : EndIf
  If Delay_BF(0, 10) ; Timer 0 - 100 timer available 0 - 99 - you can change
    ErrorCheck_BF(BF(1, canvas_ID, texture_ID, -1, -1, output_x, output_y)) ; Scroll and duplicate the sprite up to output max
    
    ; You can change simple the direction and moving speed, how ever you want
    ; output_x-1 : If output_x<-ImageWidth(texture_ID) : output_x=0 : EndIf  ; Moving direction left
    ; output_y-1 : If output_y<-ImageHeight(texture_ID) : output_y=0 : EndIf ; Moving direction up
    output_x+1 : If output_x>0: output_x=-ImageWidth(texture_ID) : EndIf     ; Moving direction right
    output_y+1 : If output_y>0: output_y=-ImageHeight(texture_ID)  : EndIf   ; Moving direction down
  EndIf
  
  Repeat
    win_event=WindowEvent()
    If win_event=#PB_Event_CloseWindow
      Free_animation_buffers_BF(0) ; Free animation buffers
      FreeTextures_BF()            ; Free grabbed textures
      End
    EndIf
  Until Not win_event
  
ForEver
; IDE Options = PureBasic 5.72 LTS Beta 2 (Windows - x64)
; CursorPosition = 34
; FirstLine = 14
; Folding = -
; EnableXP
; DisableDebugger