﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo 1 - Use a BF CSS sprite sheet with or without alpha channel

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define window_ID, background_ID
Define output_ID_1, output_ID_2, output_ID_3, output_ID_4, output_ID_5, output_ID_6
Define sheet_ID_1, sheet_ID_2, sheet_ID_3, sheet_ID_4, sheet_ID_5, sheet_ID_6
Define sheet_1$, sheet_2$, sheet_3$, sheet_4$, sheet_5$, sheet_6$
Define frame_1, frame_2, frame_3, frame_4, frame_5, frame_6
Define delay_1, delay_2, delay_3, delay_4, delay_5, delay_6
Define i, x

#Background="./Image_Set/Polynesia.jpg"
#Sheet_1="./Image_Set/Chicken_1_Alpha.png"
#Sheet_2="./Image_Set/morph_Alpha.png"
#Sheet_3="./Image_Set/Kid_1_Alpha.png"
#Sheet_4="./Image_Set/Bird.jpg"
#Sheet_5="./Image_Set/Hound_1_Alpha.png"
#Sheet_6="./Image_Set/Dog_1_Alpha.png"

Procedure.s LoadFrameData(path$)
  If GetFrameData_fromSheet_BF(path$)<>1
    ProcedureReturn ""
  EndIf
  ProcedureReturn SetFrameDataInString_BF()
EndProcedure

background_ID=LoadImage(#PB_Any, #Background) : ResizeImage(background_ID, 1000, 600) ; Create a background

sheet_ID_1=LoadImage(#PB_Any, #Sheet_1) : sheet_1$=LoadFrameData_BF(#Sheet_1) ; Chicken
sheet_ID_2=LoadImage(#PB_Any, #Sheet_2) : sheet_2$=LoadFrameData_BF(#Sheet_2) ; Morph
sheet_ID_3=LoadImage(#PB_Any, #Sheet_3) : sheet_3$=LoadFrameData_BF(#Sheet_3) ; Kid
sheet_ID_4=LoadImage(#PB_Any, #Sheet_4) : sheet_4$=LoadFrameData_BF(#Sheet_4) ; Bird
sheet_ID_5=LoadImage(#PB_Any, #Sheet_5) : sheet_5$=LoadFrameData_BF(#Sheet_5) ; Hound
sheet_ID_6=LoadImage(#PB_Any, #Sheet_6) : sheet_6$=LoadFrameData_BF(#Sheet_6) ; Dog

window_ID=OpenWindow(#PB_Any, 0, 0,
                     ImageWidth(background_ID), ImageHeight(background_ID), "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

StartDrawing(ImageOutput(background_ID))
DrawingMode(#PB_2DDrawing_Transparent)
DrawText(25, 25, "SheetMaster", -1)
StopDrawing()

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID)) ; Create a canvas for output the result

HideWindow(window_ID, 0)

x=-200 ; Set the hound to start position

Macro sheet_delay(value)
  If delay_#value : delay_#value=0 : frame_#value+1 : EndIf
  If frame_#value=>GetGIFandCSS_Frames_BF() : frame_#value=0 : Else : delay_#value+Delay_BF(value, GetGIFandCSS_delay_array_BF(frame_#value))
  EndIf
EndMacro

Repeat
  Delay(1)
  
  If WindowEvent()=#PB_Event_CloseWindow : Break : EndIf
  
  ; 1 Chicken ---------------------------
  GetFrameDataFromString_BF(sheet_1$) ; Grabbing a frame data string and put it in the frame datas
  output_ID_1=Sprite_CSS_sheet_grab_frame_BF(sheet_ID_1,
                                             GetGIFandCSS_Frames_BF(),       ; Number of frames
                                             frame_1,                        ; Selected frame - For GIF compatibility the first frame is 0
                                             GetGIFandCSS_Frame_width_BF(),  ; Frame width
                                             GetGIFandCSS_Frame_height_BF(), ; Frame height
                                             0,                              ; Frames in a row - Preset 0, then BF calculate self
                                             280,                            ; Output width - For original frame width set width = 0
                                             310,                            ; Output height - For original frame height set height = 0
                                             0,                              ; Startposition inside the texture - Preset 0
                                             0,                              ; Startposition inside the texture - Preset 0
                                             0,                              ; Endposition inside the texture - Preset 0 = full texture width
                                             0)                              ; Endposition inside the texture - Preset 0 = full texture width
  sheet_delay(1)
  
  ; 2 Morph -----------------------------
  GetFrameDataFromString_BF(sheet_2$) ; Grabbing a frame data string and put it in the frame datas
  output_ID_2=Sprite_CSS_sheet_grab_frame_BF(sheet_ID_2,
                                             GetGIFandCSS_Frames_BF(),       ; Number of frames
                                             frame_2,                        ; Selected frame - For GIF compatibility the first frame is 0
                                             GetGIFandCSS_Frame_width_BF(),  ; Frame width
                                             GetGIFandCSS_Frame_height_BF(), ; Frame height
                                             0,                              ; Frames in a row - Preset 0, then BF calculate self
                                             200,                            ; Output width - For original frame width set width = 0
                                             200)                            ; Output height - For original frame height set height = 0
  sheet_delay(2)
  
  ; 3 Kid -------------------------------
  GetFrameDataFromString_BF(sheet_3$) ; Grabbing a frame data string and put it in the frame datas
  output_ID_3=Sprite_CSS_sheet_grab_frame_BF(sheet_ID_3,
                                             GetGIFandCSS_Frames_BF(),       ; Number of frames
                                             frame_3,                        ; Selected frame - For GIF compatibility the first frame is 0
                                             GetGIFandCSS_Frame_width_BF(),  ; Frame width
                                             GetGIFandCSS_Frame_height_BF()) ; Frame height
  sheet_delay(3)
  
  ; 4 Bird ------------------------------
  GetFrameDataFromString_BF(sheet_4$) ; Grabbing a frame data string and put it in the frame datas
  output_ID_4=Sprite_CSS_sheet_grab_frame_BF(sheet_ID_4,
                                             GetGIFandCSS_Frames_BF(),       ; Number of frames
                                             frame_4,                        ; Selected frame - For GIF compatibility the first frame is 0
                                             GetGIFandCSS_Frame_width_BF(),  ; Frame width
                                             GetGIFandCSS_Frame_height_BF(), ; Frame height
                                             0,                              ; Frames in a row - Preset 0, then BF calculate self
                                             250,                            ; Output width - For original frame width set width = 0
                                             170)                            ; Output height - For original frame height set height = 0
  sheet_delay(4)
  
  ; 5 Hound -----------------------------
  GetFrameDataFromString_BF(sheet_5$) ; Grabbing a frame data string and put it in the frame datas
  output_ID_5=Sprite_CSS_sheet_grab_frame_BF(sheet_ID_5,
                                             GetGIFandCSS_Frames_BF(),       ; Number of frames
                                             frame_5,                        ; Selected frame - For GIF compatibility the first frame is 0
                                             GetGIFandCSS_Frame_width_BF(),  ; Frame width
                                             GetGIFandCSS_Frame_height_BF()) ; Frame height
  sheet_delay(5)
  If Delay_BF(0, 30 ) : x+2 : If x>ImageWidth(background_ID) : x=-ImageWidth(output_ID_5) : EndIf : EndIf ; Move the hound
  
  ; 6 Dog -------------------------------
  GetFrameDataFromString_BF(sheet_6$) ; Grabbing a frame data string and put it in the frame datas
  output_ID_6=Sprite_CSS_sheet_grab_frame_BF(sheet_ID_6,
                                             GetGIFandCSS_Frames_BF(),       ; Number of frames
                                             frame_6,                        ; Selected frame - For GIF compatibility the first frame is 0
                                             GetGIFandCSS_Frame_width_BF(),  ; Frame width
                                             GetGIFandCSS_Frame_height_BF()) ; Frame height
  sheet_delay(6)
  
  ; -----------------------------------
  
  Macro draw_frame(ID, x, y, alpha)
    If IsImage(output_ID_#ID) : DrawAlphaImage(ImageID(output_ID_#ID), x, y, alpha)
      FreeImage(output_ID_#ID) ; After output free the frames or you get a memory leak
    EndIf
  EndMacro
  
  ; Get the results
  StartDrawing(CanvasOutput(canvas_ID))
  DrawImage(ImageID(background_ID), 0, 0)
  draw_frame(1, 10, 100, 255)  ; Chicken
  draw_frame(2, 410, 50, 255)  ; Morph
  draw_frame(3, 750, 400, 255) ; Kid
  draw_frame(4, 720, 30, 255)  ; Bird
  draw_frame(5, x, 280, 255)   ; Hound
  draw_frame(6, 650, 250, 255) ; Dog
  StopDrawing()
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableXP
; DisableDebugger