﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - BucketFill demo - simple -

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Activate_DPI_aware_BF(1)

Define window_ID, win_event, image_ID, texture_ID, background_ID, result
Define image_x, image_y, image_width, image_height, point
Define path$

#GeeBee="./Image_Set/Geebee2.bmp"
#Clouds="./Image_Set/Clouds.jpg"
#SoilWall="./Image_Set/soil_wall.jpg"
#RustySteel="./Image_Set/RustySteel.jpg"
#Caisse="./Image_Set/Caisse.png"
#Dirt="./Image_Set/Dirt.jpg"
#Background="./Image_Set/Background.bmp"
#Cat_1="./Image_Set/Cat_01.jpg"

; Presets
image_width=600 : image_height=475

image_ID=LoadImage(#PB_Any, #SoilWall)
ResizeImage(image_ID, ImageWidth(image_ID)*DPI_ResizeFactor_BF(), ImageHeight(image_ID)*DPI_ResizeFactor_BF())

background_ID=CreateImage(#PB_Any, image_width*DPI_ResizeFactor_BF(), image_height*DPI_ResizeFactor_BF())
ResizeImage(background_ID, ImageWidth(background_ID)*DPI_ResizeFactor_BF(), ImageHeight(background_ID)*DPI_ResizeFactor_BF())

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

StartDrawing(ImageOutput(background_ID))
Box (40*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), 128*DPI_ResizeFactor_BF() , 400*DPI_ResizeFactor_BF(), $CCCC00)
RoundBox (185*DPI_ResizeFactor_BF(),
          80*DPI_ResizeFactor_BF(),
          133*DPI_ResizeFactor_BF(),
          250*DPI_ResizeFactor_BF(),
          20*DPI_ResizeFactor_BF(),
          20*DPI_ResizeFactor_BF(),
          $AAAAA2)
Box (300*DPI_ResizeFactor_BF(), 280*DPI_ResizeFactor_BF(), 150*DPI_ResizeFactor_BF(), 150*DPI_ResizeFactor_BF(), $AAA3)
Circle(460*DPI_ResizeFactor_BF(), 260*DPI_ResizeFactor_BF(), 125*DPI_ResizeFactor_BF(), $AAAAA4)
StopDrawing()

; Hint - So you can replace global a color on a source with a texture - This line replace the color red with a texture
; SetColor_BF(#Red) : ErrorCheck_BF(BF(-2, source_ID, texture_ID, -1, -1))

; - Call function #1 -
path$=#SoilWall
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
result=BF(-2, background_ID, texture_ID) ; Full size output, not more settings needed
ErrorCheck_BF(result)


; - Call function #2 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
result=BF(-50, background_ID, texture_ID,
          40*DPI_ResizeFactor_BF(),
          10*DPI_ResizeFactor_BF())
ErrorCheck_BF(result)

; - Call function #3 -
path$=#GeeBee
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
result=BF(-2, background_ID, texture_ID,
          185*DPI_ResizeFactor_BF(),
          100*DPI_ResizeFactor_BF(),
          60*DPI_ResizeFactor_BF(), ; Startposition texture output x
          80*DPI_ResizeFactor_BF()) ; y
ErrorCheck_BF(result)

; - Call function #4 -
path$=#Clouds
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
result=BF(-2, background_ID, texture_ID,
          185*DPI_ResizeFactor_BF(), ; Get a color point for replacing with bucket fill x
          100*DPI_ResizeFactor_BF()) ; y
ErrorCheck_BF(result)

; - Call function #5 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, ImageWidth(texture_ID)*DPI_ResizeFactor_BF(), ImageHeight(texture_ID)*DPI_ResizeFactor_BF())
result=BF(-2, background_ID, texture_ID,
          300*DPI_ResizeFactor_BF(), 
          280*DPI_ResizeFactor_BF(),
          0, ; All zeros to default
          0,
          0,
          0,
          0,
          0,
          30*DPI_ResizeFactor_BF(), ; Reduce texture width
          30*DPI_ResizeFactor_BF()) ; Reduce texture height
ErrorCheck_BF(result)

; - Call function #6 -
path$=#Cat_1
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, 300*DPI_ResizeFactor_BF(), 260*DPI_REsizeFactor_BF())
result=BF(-2, background_ID, texture_ID,
          450*DPI_ResizeFactor_BF(),
          250*DPI_ResizeFactor_BF(),
          0,
          135*DPI_ResizeFactor_BF()) ; Adjust photo
ErrorCheck_BF(result)

Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0)
StopDrawing() 

Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    Break
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 129
; FirstLine = 101
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger