﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

; - Demo - FloodFill demo - With gradient colors and textures - This function can output directly on images, PB sprites and canvas

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Activate_DPI_aware_BF(1)

Define win_event, window_ID, canvas_ID, image_ID, texture_ID, background_ID
Define image_x, image_y, image_width, image_height, point
Define path$

#GeeBee="./Image_Set/Geebee2.bmp"
#Clouds="./Image_Set/Clouds.jpg"
#SoilWall="./Image_Set/soil_wall.jpg"
#RustySteel="./Image_Set/RustySteel.jpg"
#Caisse="./Image_Set/Caisse.png"
#Dirt="./Image_Set/Dirt.jpg"
#Background="./Image_Set/Background.bmp"
#Cat="./Image_Set/Cat_01.jpg"

; Presets
image_width=600 : image_height=475

image_ID=LoadImage(#PB_Any, #SoilWall)

background_ID=CreateImage(#PB_Any, image_width*DPI_ResizeFactor_BF(), image_height*DPI_ResizeFactor_BF())

window_ID=OpenWindow(#PB_Any, 0, 0,
                     image_width, image_height, "GFX_Wizzard_BF",
                     #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

StartDrawing(ImageOutput(background_ID))
Box(40*DPI_ResizeFactor_BF(), 10*DPI_ResizeFactor_BF(), 128*DPI_ResizeFactor_BF() , 400*DPI_ResizeFactor_BF(), $AAA1)
RoundBox (185*DPI_ResizeFactor_BF(), 80*DPI_ResizeFactor_BF(), 133*DPI_ResizeFactor_BF() , 250*DPI_ResizeFactor_BF() , 20*DPI_ResizeFactor_BF(), 20*DPI_ResizeFactor_BF(), $AAAAA2)
Circle(230*DPI_ResizeFactor_BF(), 430*DPI_ResizeFactor_BF(), 80*DPI_ResizeFactor_BF(), $AAAAA3)
Box(300*DPI_ResizeFactor_BF(), 280*DPI_ResizeFactor_BF(), 150*DPI_ResizeFactor_BF() , 150*DPI_ResizeFactor_BF(), $AAA4)
Circle(460*DPI_ResizeFactor_BF(), 260*DPI_ResizeFactor_BF(), 125*DPI_ResizeFactor_BF(), $AAAAA5)
StopDrawing()

; - Call function #1 -
path$=#SoilWall
texture_ID=LoadImage(#PB_Any, path$)
ErrorCheck_BF(FloodFill_BF(-2, background_ID, texture_ID,
                           0,  ; x - Startpoint for FloodFill
                           0,  ; y - Startpoint for FloodFill
                           0,  ; texture_x - Startposition texture output x
                           0,  ; texture_y - Startposition texture output y
                           0,  ; texture_width
                           0,  ; texture_height
                           0,  ; texture_clip_x
                           0,  ; texture_clip_y
                           0,  ; texture_clip_width
                           0)) ; texture_clip_height

; This functions works equal the PB function
; activate_...<>0 activate a function - For the other parameters looking in the PB guidance
; You must deactivate again
; FrontColor_BF(1, $FF)
; BackColor_BF(1, $FFFF) 
; This are arrays for handling gradient colors - Available Array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FF0000)
GradientColor_Array_BF(1, 2, 0.3, $FF00)
GradientColor_Array_BF(1, 3, 0.5, $FFFF)
GradientColor_Array_BF(1, 4, 0.7, $FF)
GradientColor_Array_BF(1, 5, 0.9, $FF0000)

LinearGradient_BF(1, 0, 0, 400*DPI_ResizeFactor_BF(), 500*DPI_ResizeFactor_BF())

GradientColor_Alpha_BF(120)

; - Call function #2 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
ErrorCheck_BF(FloodFill_BF(-2, background_ID, texture_ID,
                           100*DPI_ResizeFactor_BF(),  ; x
                           150*DPI_ResizeFactor_BF())) ; y

DeactivateGradientColors_BF() ; This deactivate all gradient color functions after using
                              ; Deactivate you not the functions, it can influence other outputs

; - Call function #3 -
path$=#GeeBee
texture_ID=LoadImage(#PB_Any, path$)
ErrorCheck_BF(FloodFill_BF(-2, background_ID, texture_ID,
                           250*DPI_ResizeFactor_BF(),
                           200*DPI_ResizeFactor_BF(),
                           60*DPI_ResizeFactor_BF(),  ; Startposition texture output x
                           80*DPI_ResizeFactor_BF())) ; y

; This are arrays for handling gradient colors - Available Array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FF0000)
GradientColor_Array_BF(1, 2, 0.3, $FF00)
GradientColor_Array_BF(1, 3, 0.5, $FFFF)
GradientColor_Array_BF(1, 4, 0.7, $FF)
GradientColor_Array_BF(1, 5, 0.9, $FF0000)

LinearGradient_BF(1, 100*DPI_ResizeFactor_BF(), 0, 300*DPI_ResizeFactor_BF(), 400*DPI_ResizeFactor_BF())

GradientColor_Alpha_BF(200)

; - Call function #4 -
path$=#Clouds
texture_ID=LoadImage(#PB_Any, path$)
ErrorCheck_BF(FloodFill_BF(-2, background_ID, texture_ID,
                           220*DPI_ResizeFactor_BF(),  ; x 
                           200*DPI_ResizeFactor_BF())) ; y

DeactivateGradientColors_BF() ; This deactivate all gradient color functions after using
                              ; Deactivate you not the functions, it can influence other outputs

; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FF0000)
GradientColor_Array_BF(1, 2, 0.3, $FF00)
GradientColor_Array_BF(1, 3, 0.5, $FFFF)
GradientColor_Array_BF(1, 4, 0.7, $FF)
GradientColor_Array_BF(1, 5, 0.9, $FF0000)

LinearGradient_BF(1, 300*DPI_ResizeFactor_BF(), 300*DPI_ResizeFactor_BF(), 400*DPI_ResizeFactor_BF(), 600*DPI_ResizeFactor_BF())

GradientColor_Alpha_BF(120)

; - Call function #5 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
ErrorCheck_BF(FloodFill_BF(-2, background_ID, texture_ID,
                           300*DPI_ResizeFactor_BF(), ; x,
                           280*DPI_ResizeFactor_BF(), ; y,
                           0,                         ; texture_x, - Startposition texture output x
                           0,                         ; texture_y, - Startposition texture output y
                           0,                         ; texture_width
                           0,                         ; texture_height
                           0,                         ; texture_clip_x
                           0,                         ; texture_clip_y
                           30,                        ; texture_clip_width
                           30))                       ; texture_clip_height

DeactivateGradientColors_BF() ; This deactivate all gradient color functions after using
                              ; Deactivate you not the functions, it can influence other outputs 

;This are arrays for handling gradient colors - Available Array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.3, $FF0000)
GradientColor_Array_BF(1, 2, 0.5, $FFFF)
GradientColor_Array_BF(1, 3, 0.6, $FFFF)
GradientColor_Array_BF(1, 4, 0.7, $FF)
GradientColor_Array_BF(1, 5, 0.9, $FF0000)

CircularGradient_BF(1, 460*DPI_ResizeFactor_BF(), 260*DPI_ResizeFactor_BF(), 150*DPI_ResizeFactor_BF())

GradientColor_Alpha_BF(120)
GradientColor_Contrast_BF(50)

; - Call function #6 -
path$=#Cat
texture_ID=LoadImage(#PB_Any, path$)
ResizeImage(texture_ID, 300, 260)
ErrorCheck_BF(FloodFill_BF(-2, background_ID, texture_ID,
                           450*DPI_ResizeFactor_BF(),  ; x
                           250*DPI_ResizeFactor_BF(),  ; y
                           0,                          ; texture_x - Startposition texture output x
                           135*DPI_ResizeFactor_BF())) ; texture_y - Startposition texture output x - Adjust photo

DeactivateGradientColors_BF() ; This deactivate all gradient color functions after using
                              ; Deactivate you not the functions, it can influence other outputs

; This are arrays for handling gradient colors - Available Array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, $FF0000)
GradientColor_Array_BF(1, 2, 0.3, $FF00)
GradientColor_Array_BF(1, 3, 0.5, $FFFF)
GradientColor_Array_BF(1, 4, 0.7, $FF)
GradientColor_Array_BF(1, 5, 0.9, $FF0000)

CircularGradient_BF(1, 230*DPI_ResizeFactor_BF(), 430*DPI_ResizeFactor_BF(), 85*DPI_ResizeFactor_BF())

GradientColor_Alpha_BF(120)

; - Call function #7 -
path$=#Caisse
texture_ID=LoadImage(#PB_Any, path$)
ErrorCheck_BF(FloodFill_BF(-2, background_ID, texture_ID,
                           230*DPI_ResizeFactor_BF(),  ; x
                           430*DPI_ResizeFactor_BF())) ; y

DeactivateGradientColors_BF() ; This deactivate all gradient color functions after using
                              ; Deactivate you not the functions, it can influence other outputs

canvas_ID=CanvasGadget(#PB_Any, 0, 0, ImageWidth(background_ID), ImageHeight(background_ID))

StartDrawing(CanvasOutput(canvas_ID)) ; Get the result
DrawImage(ImageID(background_ID), 0, 0)
StopDrawing() 

Repeat
  win_event=WaitWindowEvent()
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    Break
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 200
; FirstLine = 172
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger