﻿
; Large BF sprite with alpha blending and color distance on canvas demo - fast

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

CompilerIf #PB_Compiler_Debugger : MessageRequester("Debugger", "Please deactivate firstly the debugger !") : End : CompilerEndIf

Define win_event, xx, xxx.f, alpha.f=1, x=150, y=50

Macro output_sprites
  xx+2 : If xx>450 : xx=450 : xxx+0.12 : alpha+0.6 : EndIf
  If xxx>50 : xxx=0 : xx=0 : alpha=1
  Else  
    SetColorDistanceSpriteMask_BF(40+xxx) ; percent - The used demo image has not a clean mask - Without this function you get not a invisible color
    SpriteSimple_fast_BF(alpha, background_sprite_ID, sprite_ID,                                     
                         0,  ; Grab transparence color from the frame pos x - Set to -1 for output without invisible color 
                         0,  ; Grab transparence color from the frame pos y - You can set x or y, or both parameters to -1 
                         x,  ; Output position x
                         y,  ; Output position y
                         xx, ; You can here resize the output x - On demand
                         xx) ; You can here resize the output y - On demand
    
    CopyContent_Image_Canvas_BF(background_sprite_ID, canvas_ID)
    CopyContent_Image_Image_BF(background_sprite_1_ID, background_sprite_ID)
  EndIf
EndMacro

Define window_ID=OpenWindow(#PB_Any, 0, 0, 768, 600, "Output arge sprite on canvas - Using enhanced color distance - fast", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
Define canvas_ID=CanvasGadget(#PB_Any, 0, 0, 768, 600)

Define background_sprite_ID=LoadImage(#PB_Any, "./Image_Set/Hubble.jpg")
Define background_sprite_1_ID=CopyImage(background_sprite_ID, #PB_Any)
Define texture_ID=LoadImage(#PB_Any, "./Image_Set/Space.jpg")
Define sprite_ID=CopyImage(texture_ID, #PB_Any)
Define mask_color=GetImageColor_BF(texture_ID, 0, 0)

NoCaching_BF(1) ; The BF sprite change persistent, so a caching has not a positive effect - This deactivate the BF texture caching
HideWindow(window_ID, 0)

Repeat
  
  Repeat
    win_event=WindowEvent()
    If win_event = #PB_Event_CloseWindow
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 30)
    output_sprites
  EndIf
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 8
; Folding = -
; EnableXP
; DisableDebugger