﻿; Stretched text vector 
; This function create a stretched text inside a defined rectangle
; A font you must not preset
; StartVectorDrawing() is needed

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 400, "Stretched text BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
SetWindowColor(window_ID, #Green)

Define canvas_ID=CanvasGadget(#PB_Any, 10, 10, WindowWidth(window_ID)-20, WindowHeight(window_ID)-20)

Define font_ID=LoadFont(#PB_Any, "Times New Roman", 11, #PB_Font_Bold) ; You must not change fontsize 11 

Activate_DPI_aware_BF(1)

Define text$="Hello World"+#LF$+"This is StretchedText_BF"+#LF$+"Automatic stretched text"+#LF$+"on a defined rectangle"

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($00, $FF, $00, $FF))
GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))

; Activate linear gradient
; LinearGradient_BF(1, 0, 0, 500*DPI_ResizeFactor_BF() , 500*DPI_ResizeFactor_BF())
; Activate circular gradient
CircularGradient_BF(1, 100*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF(), 150*DPI_ResizeFactor_BF())
; ==============================

Define temp_image_ID=CreateImage(#PB_Any, GadgetWidth(canvas_ID)*DPI_ResizeFactor_BF(), GadgetHeight(canvas_ID)*DPI_ResizeFactor_BF())

HideWindow(window_ID, 0)

Define i
For i=1 To 400 Step 2
  
  If StartDrawing(ImageOutput(temp_image_ID))
    Box(0, 0, GadgetWidth(canvas_ID)*DPI_ResizeFactor_BF(), GadgetHeight(canvas_ID)*DPI_ResizeFactor_BF(), #Black)
    StopDrawing()
  EndIf 
  
  ErrorCheck_BF(StretchedText_Vector_BF(temp_image_ID,               ; Output_ID
                                        font_ID,                     ; Font ID - A font you must not preset - set simple -1 as font ID
                                        text$,                       ; Text
                                        490-i,                       ; Output x pos
                                        30,                          ; Output y pos
                                        i*1.5,                       ; Output width
                                        300,                         ; Output height
                                        $01000000,                   ; Background color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                        $FF0000FF,                   ; Text color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                        #PB_VectorParagraph_Center)) ; Text flag
  
  CopyContent_Image_Canvas_BF(temp_image_ID, canvas_ID)
  
  Delay(3)
  While WindowEvent() : Wend
  
Next i
Repeat
Until WaitWindowEvent()=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 51
; FirstLine = 33
; EnableXP
; DPIAware
; DisableDebugger