﻿; Stretched text vector 
; This function create a stretched text inside a defined rectangle
; A font you must not preset

XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Define window_ID=OpenWindow(#PB_Any, 0, 0, 800, 500, "Stretched text BF", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
SetWindowColor(window_ID, #Green)

Define canvas_ID=CanvasGadget(#PB_Any, 10, 10, WindowWidth(window_ID)-20, WindowHeight(window_ID)-20)

Define font_ID=LoadFont(#PB_Any, "Times New Roman", 11, #PB_Font_Bold) ; You must not change fontsize 11 

Activate_DPI_aware_BF(1)

Define text$="Hello World"+#LF$+"This is stretched TextBox_BF"+#LF$+"Automatic stretched text"+#LF$+"on a defined rectangle"

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($00, $FF, $00, $FF))
GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))

; Activate linear gradient
; LinearGradient_BF(1, 0, 0, 500*DPI_ResizeFactor_BF() , 500*DPI_ResizeFactor_BF())
; Activate circular gradient
; CircularGradient_BF(1, 100*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF(), 180*DPI_ResizeFactor_BF())
; ==============================

Define temp_image_ID=CreateImage(#PB_Any, GadgetWidth(canvas_ID)*DPI_ResizeFactor_BF(), GadgetHeight(canvas_ID)*DPI_ResizeFactor_BF())

; Pre process - Make background - Primary not needed
Define texture_0_ID=LoadImage(#PB_Any, "./Image_Set/Background.bmp")
ErrorCheck_BF(BucketFill_BF(-2, temp_image_ID, texture_0_ID, 0, 0))

HideWindow(window_ID, 0)

Define i
For i=30 To 350 Step 2
  If i > 150
    CircularGradient_BF(1, 110*DPI_ResizeFactor_BF(), 100*DPI_ResizeFactor_BF(), 230*DPI_ResizeFactor_BF())
  EndIf
  
  StretchedText_Roundbox_Vector_BF(temp_image_ID, ; Output_ID
                                   font_ID,       ; Font ID      
                                   text$,         ; Text
                                   370-i/1.05,    ; Output x pos
                                   210-i/1.8,     ; Output y pos
                                   i*2,           ; Output width
                                   i,             ; Output height
                                   10,            ; Rounding radius
                                   10,            ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                   $800000FF,     ; Frame color
                                   $0000FFFF,     ; Background color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                   30,            ; Padding x
                                   30,            ; Padding y
                                   $FFFF0000,     ; Text color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                   #PB_VectorParagraph_Center) ; Text flag
  
  CopyContent_Image_Canvas_BF(temp_image_ID, canvas_ID)
  
  Delay(3)
  While WindowEvent() : Wend
  
Next i

CircularGradient_BF(0)

StretchedText_Roundbox_Vector_BF(canvas_ID, ; Output_ID
                                 font_ID,   ; Font ID      
                                 text$,     ; Text
                                 65,        ; Output x pos
                                 40,        ; Output y pos
                                 170,       ; Output width
                                 70,        ; Output height
                                 10,        ; Rounding radius
                                 5,         ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                 $FFFFFF00, ; Frame color
                                 $00FF0000, ; Background color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 5,         ; Padding x
                                 5,         ; Padding y
                                 $FFFFFFFF, ; Text color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 #PB_VectorParagraph_Center) ; Text flag

StretchedText_Roundbox_Vector_BF(canvas_ID, ; Output_ID
                                 font_ID,   ; Font ID      
                                 "GFX_Wizzard_BF"+#LF$+"Simple a little more",
                                 620,       ; Output x pos
                                 40,        ; Output y pos
                                 150,       ; Output width
                                 50,        ; Output height
                                 0,         ; Rounding radius
                                 2,         ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                 $FFFFFF00, ; Frame color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 $00FF0000, ; Background color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 5,         ; Padding x
                                 5,         ; Padding y
                                 $FFFFFFFF, ; Text color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 #PB_VectorParagraph_Center) ; Text flag

StretchedText_Roundbox_Vector_BF(canvas_ID, ; Output_ID
                                 font_ID,   ; Font ID      
                                 "GFX_Wizzard_BF"+#LF$+"Simple a little more",
                                 10,        ; Output x pos
                                 390,       ; Output y pos
                                 200,       ; Output width
                                 70,        ; Output height
                                 8,         ; Rounding radius
                                 4,         ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                 $FFFF0000, ; Frame color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 $01000000, ; Background color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 5,         ; Padding x
                                 5,         ; Padding y
                                 $FF000000, ; Text color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 #PB_VectorParagraph_Center) ; Text flag

StretchedText_Roundbox_Vector_BF(canvas_ID, ; Output_ID
                                 font_ID,   ; Font ID      
                                 "Formatted Text output"+#LF$+"The simplest ever",
                                 225,       ; Output x pos
                                 380,       ; Output y pos
                                 300,       ; Output width
                                 80,        ; Output height
                                 0,         ; Rounding radius
                                 2,         ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                 $01000000, ; Frame color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 $01000000, ; Background color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 5,         ; Padding x
                                 5,         ; Padding y
                                 $FF000000, ; Text color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                 #PB_VectorParagraph_Center) ; Text flag

Define box_1_text$="Klick me"+#LF$+"BF can make all boxes"+#LF$+"and rectangles clickable"
Macro draw_box_1(background_color, frame_color, text_color, text)
  StretchedText_Roundbox_Vector_BF(canvas_ID,        ; Output_ID
                                   font_ID,          ; Font ID
                                   text,             ; Text
                                   535,              ; Output x pos
                                   385,              ; Output y pos
                                   235,              ; Output width
                                   80,               ; Output height
                                   9,                ; Rounding radius
                                   6,                ; Frame thickness - Set zero for ignore a frame - A negative value reduce the background
                                   frame_color,      ; Frame color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                   background_color, ; Background color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                   8,                ; Padding x
                                   8,                ; Padding y
                                   text_color,       ; Text color - Alpha channel available - Alpha=0 ignore the alpha channel - set to $01, this is equal 0
                                   #PB_VectorParagraph_Center) ; Text flag
EndMacro
draw_box_1(RGBA($B8, 86, $0B, 0), RGBA(0, 0, 255, 255), #White, box_1_text$)

; Grab the boxes pos data and their image
Define box_1_ID=Grab_Rectangle_BF(canvas_ID,
                                  535, ; Output pos x
                                  385, ; Output pos y
                                  235, ; Rectangle width
                                  80,  ; Rectangle height
                                  0,   ; Grab the rectangle as image - 0=ignore a background image
                                  -1,  ; Output offset x
                                  -1,  ; Output_offset y
                                  2,   ; output offset width
                                  2)   ; Output offset height
                                       ; If you want to save a vector lib output, you have to consider the interpolation of the border lines which enlarge the rectangle
                                       ; This results in offsets : box_x=-1 - box_y=-1 - box_width=+2 - box_height=+2

; Handle the Boxes_BF
Define win_event
Repeat
  win_event=WaitWindowEvent()
  
  If win_event=#PB_Event_Gadget And EventGadget()=canvas_ID
    If EventType()=#PB_EventType_LeftButtonDown Or
       (EventType()=#PB_EventType_MouseMove And
        GetGadgetAttribute(canvas_ID, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
      
      Define canvas_x_pos=GetGadgetAttribute(canvas_ID, #PB_Canvas_MouseX)
      Define canvas_y_pos=GetGadgetAttribute(canvas_ID, #PB_Canvas_MouseY)
      
      Select Get_Rectangle_ID_BF(canvas_x_pos, canvas_y_pos) ; The function read the rectangle stack reverse, for better handling child rectangles
        Case box_1_ID
          Get_Rectangle_BF(box_1_ID) ; This call fill the location variables
          draw_box_1(RGBA($B8, 86, $0B, 0), RGBA(255, 0, 0, 255), #Green, box_1_text$)
          While WindowEvent() : Wend
          Delay(180)
          draw_box_1(RGBA($B8, 86, $0B, 0), RGBA(0, 0, 255, 255), #White, box_1_text$)
      EndSelect
      
    EndIf
  EndIf
  
  If win_event=#PB_Event_CloseWindow
    FreeTextures_BF() ; Free grabed textures
    FreeRectangles_BF() ; Free all Rectangles_BF
    Break
  EndIf
  
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 39
; FirstLine = 39
; Folding = -
; EnableXP
; DPIAware
; DisableDebugger