﻿; Demo - Draw text with DrawText_BF directly output on a screen - Stretched

XIncludeFile("./GFX_Wizzard_BF.pbi")

InitSprite()

EnableExplicit

LoadFont(1, "Arial", 24, #PB_Font_Bold)

#text$=#LF$+"Hello"+#LF$+
       " This text is created with DrawText_BF "+#LF$+
       "And directly outputted on screen"+#LF$+
       "Stretched"+#LF$

Define width=1
Define height=1

Define window_ID=OpenWindow(#PB_Any, 1, 1, 1, 1, "Draw Text directly on a screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)

OpenWindowedScreen(WindowID(window_ID), 0, 0, 1, 1)

Define width=DrawTextScreenOutput_BF(0, 0, #text$, #White, #Black, 0, 3, 1, 1, 8, 8) ; Calculate the needed width
Define height=DrawTextScreenOutput_BF(0, 0, #text$, #White, #Black, 0, 4, 1, 1, 8, 8); Calculate the needed height

CloseScreen()
OpenWindowedScreen(WindowID(window_ID), 0, 0, width, height)

ResizeWindow(window_ID, DesktopWidth_UserScaled_BF()/2-width/2, DesktopHeight_UserScaled_BF()/2-height/2, width, height)

Define sprite_1_ID=CreateSprite(#PB_Any, width, height) ; Create a PB sprite for the background

StartDrawing(SpriteOutput(sprite_1_ID))
Box(0, 0, width/4, height, $FF0000)
Box(width-width/4, 0, width/4, height, $FF)
StopDrawing()

; Flags : Text center=1 - Text right=2 - Text vertical=3
; Modes : Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3 , height mode=4
; Mono line output give back the xx output coordinate - Multi line output give back the yy output coordinate
; Additional you can set transparent for the text background
; DrawTextScreenOutput_BF(txt_x, txt_y, txt$, f_col=#White, b_col=#Black, flag=0, mode=0, transparent=1, font_ID=0, stretch_x=0, stretch_y=0)

HideWindow(window_ID, 0)

Repeat
  Repeat ; Get all window events before FlipBuffers
    Define win_event=WindowEvent()
    If win_event = #PB_Event_CloseWindow
      FreeTextures_BF() ; Free grabed textures
      End
    EndIf
  Until Not win_event
  
  If Delay_BF(0, 10) ; Output
    DrawTextScreenOutput_BF(0, 0, #text$, #White, #Black, 1, 0, 1, 1, 8, 8)
    FlipBuffers()
    ClearScreen(RGB(0, 0, 0)) 
    DisplaySprite(sprite_1_ID, 0, 0)
  EndIf
ForEver
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 28
; FirstLine = 9
; EnableXP