﻿XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Activate_DPI_aware_BF(1)

Define text$="A GFX_Wizzard_BF function"+#LF$+#LF$+
             "Magic_StretchText_BF"+#LF$+
             "Headline mode"+#LF$+
             "Stepless free scaled"+#LF$+
             "Exactly fitted free text"+#LF$+
             "Full automatically"+#LF$+
             "output on all channels, also screen"+#LF$+
             "DPI aware and gradient colors"
Define x_pos=0                  ; Output x pos
Define y_pos=0                  ; Output y pos
Define output_width=800         ; Output width
Define output_height=400        ; Output height
Define text_color=$FFFFFF       ; Accept alpha channel
Define font$="Georgia"          ; Font type - more is Not needed - accept also ""
Define font_style=#PB_Font_Bold ; Font style
Define text_stretching_x=3      ; Headline mode x stretching
Define text_stretching_y=3      ; Headline mode y stretching
Define padding_x.d=100          ; Padding x - Negative values available
Define padding_y.d=10           ; Padding y - Negative values available
Define flag=1                   ; Text center=1 - Text right=2 - Text vertical=3
Define mode=0                   ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4

; === Activate GradientColor ===
; This are arrays for handling gradient colors - Available array entries 0 > 99 - You can change this preset
GradientColor_Array_BF(1, 1, 0.2, RGBA($00, $FF, $00, $FF))
; GradientColor_Array_BF(1, 2, 0.4, RGBA($FF, $00, $FF, $FF))
GradientColor_Array_BF(1, 3, 0.7, RGBA($FF, $FF, $00, $FF))

LinearGradient_BF(1, -200*DPI_ResizeFactor_BF(), 0, output_width*DPI_ResizeFactor_BF(), output_height*DPI_ResizeFactor_BF())

Define window_ID=OpenWindow(#PB_Any, 0, 0, output_width, output_height, "Fitted text demo", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
Define output_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))
SetGadgetColor(output_ID, #PB_Gadget_BackColor, #Blue)

; For output as image use a output function with alpha channel support or you see nothing
; With the function "ActivateScreenOutput_BF" you can activate the screen output
Magic_StretchText_BF(output_ID,             ; All channels supported
                         text$,             ; Text
                         x_pos,             ; Output x pos
                         y_pos,             ; Output y pos
                         output_width,      ; Output width
                         output_height,     ; output height
                         text_color,        ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel 
                         text_stretching_x, ; Text stretching x - Headline mode
                         text_stretching_y, ; Text stretching y - Headline mode
                         padding_x.d,       ; Padding x - This is a virtual padding for resizing and boxed output
                         padding_y.d,       ; Padding y - This is a virtual padding for resizing and boxed output
                         flag,              ; Text center=1 - Text right=2 - Text vertical=3
                         mode,              ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                         font$,             ; Font type - more is not needed - accept also ""
                         font_style)        ; Font style 

Repeat
Until WaitWindowEvent()=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 4
; FirstLine = 4
; EnableXP
; DPIAware
; DisableDebugger