﻿
XIncludeFile("./GFX_Wizzard_BF.pbi")

EnableExplicit

Activate_DPI_aware_BF(1)

Define Image_ID=LoadImage(#PB_Any, "./Image_Set/stone_1.jpg")

Define text$="A GFX_Wizzard_BF function"+#LF$+
             "Magic_StretchText_BF"+#LF$+
             "Moved textured text"

Define x_pos=0                  ; Output x pos
Define y_pos=0                  ; Output y pos
Define output_width=800         ; Output width
Define output_height=200        ; Output height
Define text_color=$FFFFFF       ; Accept alpha channel
Define font$="Georgia"          ; Font type - more is Not needed - accept also ""
Define font_style=#PB_Font_Bold ; Font style
Define text_stretching_x=3      ; Headline mode x stretching
Define text_stretching_y=0      ; Headline mode y stretching
Define padding_x.d=30           ; Padding x - Negative values available
Define padding_y.d=60           ; Padding y - Negative values available
Define flag=1                   ; Text center=1 - Text right=2 - Text vertical=3
Define mode=0                   ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4

Define window_ID=OpenWindow(#PB_Any, 0, 0, output_width, output_height, "Fitted text demo", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
Define output_ID=CanvasGadget(#PB_Any, 0, 0, WindowWidth(window_ID), WindowHeight(window_ID))
SetGadgetColor(output_ID, #PB_Gadget_BackColor, #Blue)

; Important for all MagicText and MagicGadgets
; Letters are interpolated at the edges with this color
; 0 deactivate this function - 1 activate it
; On Linux you see not a effect
; On Windows you see a very fine effect with enabled DPI aware and a strong effekt with disabled DPI aware
; On MacOS the effect is good visible
; This effect can be very disturbing but also very beautiful
; The Embossing color is preset at the same as the text color
; Debug Hex(Embossing_Color()) ; This give back the used embossing color
; You must deactivate again - So : Embossing_Color()
Embossing_Color(1, #Black)

; With this function you can texture any MagicText and MagicGadgets text
; With changing x and y pos you can adjust or scroll the textures
; You must deactivate again - So : MagicText_BucketFill_BF()
; Accept also color in place of the image ID, as sample #Red
MagicText_BucketFill_BF(image_ID,                 ; Image ID -1 deactivate the function - Also you can set simple a color
                        0,                        ; Output x pos
                        0,                        ; Output y pos
                        0,                        ; Endposition texture output - Preset 0 = Clipping is automatic to available width 
                        0,                        ; Endposition texture output - Preset 0 = Clipping is automatic to available height 
                        50*DPI_ResizeFactor_BF(), ; Resize texture width  - 0 = without resizing
                        50*DPI_ResizeFactor_BF()) ; Resize texture height - 0 = without resizing   

; For output as image use a output function with alpha channel support or you see nothing
; With the function "ActivateScreenOutput_BF" you can activate the screen output
Magic_StretchText_BF(output_ID,         ; All channels supported
                     text$,             ; Text
                     x_pos,             ; Output x pos
                     y_pos,             ; Output y pos
                     output_width,      ; Output width
                     output_height,     ; output height
                     text_color,        ; Alpha channel available - Sample $FFAAAAAA - $FF is the alpha channel 
                     text_stretching_x, ; Text stretching x - Headline mode
                     text_stretching_y, ; Text stretching y - Headline mode
                     padding_x.d,       ; Padding x - This is a virtual padding for resizing and boxed output
                     padding_y.d,       ; Padding y - This is a virtual padding for resizing and boxed output
                     flag,              ; Text center=1 - Text right=2 - Text vertical=3
                     mode,              ; Revers text mode=1 - RTL text mode=2 - Give only back the needed width mode=3, height mode=4
                     font$,             ; Font type - more is not needed - accept also ""
                     font_style)        ; Font style 

Repeat
Until WaitWindowEvent(1)=#PB_Event_CloseWindow

; IDE Options = PureBasic 5.73 beta 2 (Windows - x64)
; CursorPosition = 74
; FirstLine = 46
; EnableXP
; DPIAware
; DisableDebugger